#include "dingoo/minimal.h"
#include <limits.h>
#include <fcntl.h>
#include <pthread.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "hack.h"
#include "ui.h"

int master_volume = 50;

extern void UpdateGame(unsigned long ulButtons, unsigned long ulJoystick);
extern void RenderScreen(unsigned short *pus, unsigned long ulButtons);

void *dingoo_screen;
static pthread_t thr = 0;
static volatile int thr_exit = 0;
static volatile int g_bUIThreadRunning = 0;

static void dzzInitScreen()
{
    // Start Minimal lib
    dingoo_init();

    // Allocate screen memory
    dingoo_screen = malloc(320*240*2 + 32);
    if(dingoo_screen == NULL) return;
    memset(dingoo_screen, 0, 320*240*2 + 32);
}

void dzzCleanupHardware()
{
  free(dingoo_screen);
  dingoo_screen = NULL;
  dingoo_deinit();
}

void dzzFlipScreen()
{
   memcpy((void*)dingoo_screen15, (void*)dingoo_screen, 320*240*2);
}

//#include "splash.c"

/*
void QuickInitUI(int bDoSplash)
{
   dzzInitScreen();

   if(bDoSplash)
  {
    memcpy((void*)dingoo_screen15, g_usSplashData, 320*240*2);
    dzzFlipScreen();
    memcpy((void*)dingoo_screen15, g_usSplashData, 320*240*2);
    dzzFlipScreen();
  }
}
*/

unsigned long dzzGetButtons()
{
  unsigned long dingookey;
  dingookey = dingoo_joystick_read(1);
  return dingookey;
}

int dzzShiftDown()
{
  if(dzzGetButtons() & DINGOO_L)
    return 1;
  return 0;
}

unsigned long dzzGetJoystick()
{
  unsigned long b;

  b = dingoo_joystick_read(1);

  if(b & DINGOO_UP)
  {
  if((b & DINGOO_LEFT) && (b & DINGOO_UP))
      return JOYDIR_UUL;
  if((b & DINGOO_RIGHT) && (b & DINGOO_UP))
      return JOYDIR_UUR;
    return JOYDIR_U;
  }
  
  if(b & DINGOO_LEFT)
  {
  if((b & DINGOO_LEFT) && (b & DINGOO_UP))
      return JOYDIR_LUL;
  if((b & DINGOO_LEFT) && (b & DINGOO_DOWN))
      return JOYDIR_LDL;
    return JOYDIR_L;
  }

  if(b & DINGOO_DOWN)
  {
  if((b & DINGOO_LEFT) && (b & DINGOO_DOWN))
      return JOYDIR_DDL;
  if((b & DINGOO_RIGHT) && (b & DINGOO_DOWN))
      return JOYDIR_DDR;
    return JOYDIR_D;
  }

  if(b & DINGOO_RIGHT)
  {
  if((b & DINGOO_RIGHT) && (b & DINGOO_UP))
      return JOYDIR_RUR;
  if((b & DINGOO_RIGHT) && (b & DINGOO_DOWN))
      return JOYDIR_RDR;
    return JOYDIR_R;
  }

  if((b & DINGOO_LEFT) && (b & DINGOO_UP))
  {
    return JOYDIR_UL;
  }
  
  if((b & DINGOO_LEFT) && (b & DINGOO_DOWN))
  {
    return JOYDIR_DL;
  }

  if((b & DINGOO_RIGHT) && (b & DINGOO_DOWN))
  {
    return JOYDIR_DR;
  }

  if((b & DINGOO_RIGHT) && (b & DINGOO_UP))
  {
    return JOYDIR_UR;
  }

  return JOYDIR_NONE;

}

// convert the joystick direction to a "mode 2" 8-way


unsigned long NormalizeJoystick(unsigned long ulIn)
{
   switch(ulIn)
  {
    case JOYDIR_U:
    case JOYDIR_UUL:
    case JOYDIR_UUR:
      return JOYDIR_U;

    case JOYDIR_UL:
      return JOYDIR_UL;

    case JOYDIR_LUL:
    case JOYDIR_L:
    case JOYDIR_LDL:
      return JOYDIR_L;

    case JOYDIR_DL:
      return JOYDIR_DL;

    case JOYDIR_DDL:
    case JOYDIR_D:
    case JOYDIR_DDR:
      return JOYDIR_D;

    case JOYDIR_DR:
      return JOYDIR_DR;

    case JOYDIR_RDR:
    case JOYDIR_R:
    case JOYDIR_RUR:
      return JOYDIR_R;

    case JOYDIR_UR:
      return JOYDIR_UR;

    default:
      break;
  }
  return JOYDIR_NONE;
}


#define LONG_LIMIT (LONG_MAX/10)

unsigned int g_ulFrameTimer = 0;

//unsigned long GetTime( void )
unsigned long GetTime( void )
{
  //struct timeval tv;
  //unsigned long time;
  //gettimeofday(&tv, NULL);
  //time = tv.tv_usec/1000;
  clock_t time=dingoo_timer_read();
  return time;
}

void dzzStartFrameTimer()
{
//  g_ulFrameTimer = GetTime();
  g_ulFrameTimer = dingoo_timer_read();
}

int dzzGetFrameTimer()
{
  //unsigned long ul;

  clock_t ul;

  //ul = GetTime();
  ul = dingoo_timer_read();
  if(ul > g_ulFrameTimer)
    return (ul - g_ulFrameTimer);
  // wrapped around
  return  (ul + (LONG_LIMIT-g_ulFrameTimer));
}

unsigned int g_ulJoystickTimer = 0;

void dzzStartJoystickTimer()
{
  //g_ulJoystickTimer = GetTime();
  g_ulJoystickTimer = dingoo_timer_read();
}

int dzzGetJoystickTimer()
{
  //unsigned long ul;
   clock_t ul;

 // ul = GetTime();
  ul = dingoo_timer_read();
  if(ul > g_ulJoystickTimer)
    return (ul - g_ulJoystickTimer);
  // wrapped around
  return (ul + (LONG_LIMIT-g_ulFrameTimer));

}

unsigned int g_ulStickClickTimer = 0;

void dzzStartStickClickTimer()
{
  //g_ulStickClickTimer = GetTime();
}

int dzzGetStickClickTimer()
{

return 0;
/*
  unsigned long ul;

  ul = GetTime();
  if(ul > g_ulStickClickTimer)
    return (int) (ul - g_ulStickClickTimer);
  // wrapped around
  return (int) (ul + (LONG_LIMIT-g_ulFrameTimer));
*/
}

void dzzMicroSleep(int nMicros)
{
  //usleep((unsigned long) nMicros);
  dingoo_timer_delay(nMicros/100);
}


static void *UIThread(void *none)
{
  unsigned long ulButtons;
  unsigned long ulJoystick;

  dzzInitScreen();
  dzzFlipScreen();

  g_bUIThreadRunning = 1;

  while(!thr_exit)
  {
    // do any game updating.  About all we'd do here is
    // autoscroll the map
    dzzStartFrameTimer();
    ulButtons = dzzGetButtons();
    ulJoystick = dzzGetJoystick();
    ulJoystick = NormalizeJoystick(ulJoystick);
    UpdateGame(ulButtons, ulJoystick);

    // draw the screen buffer
    // using the memscreen and current state, etc
    RenderScreen((void*)dingoo_screen, ulButtons);
    // wait for vertical sync
    while(dzzGetFrameTimer() < 16.66)
      dzzMicroSleep(6000);

    // flip the screen
    dzzFlipScreen();
  }
  dzzCleanupHardware();
  g_bUIThreadRunning = 0;
  return 0;
}

void StartUIThread()
{
  thr=0;
  thr_exit=0;

  pthread_create(&thr, NULL, UIThread, NULL);
}

void ShutdownUIThread()
{
	thr_exit=1;
	while(g_bUIThreadRunning)
	{
		//usleep(10000);
		dingoo_timer_delay(10);

	}
	thr=0;
  
}
