#include "hack.h"
#include "dlb.h"
#include "winprocs.h"
#include "decl.h"
#include "ui.h"
#include <stdio.h>
#include <stdlib.h>

extern int dzzShiftDown();

extern volatile int g_bExitGame;
extern int g_bFastDirection;

extern char g_szRepeatName[20];
extern int g_nRepeatRole;
extern int g_nRepeatRace;
extern int g_nRepeatSex;
extern int g_nRepeatAlignment;
extern int g_bOptionCrashRecovery;
extern int g_bOptionQWERTY;
extern int g_bOptionAutoGold;
extern int g_bOptionFastDir;
extern void SaveRepeatData();
extern void GetRepeatData();
extern void dzzSetOptions(int bCrashRecovery, int bQWERTY, int bAutoGold, int bFastDir);

extern void dzzMicroSleep(int nMicros);

int g_bWizard = 0;

int g_bDoHelpWindow = 0;

int g_bCarryingError = 0;

//// utility functions needed by the main nethack code

void error(const char *fmt, ...)
{
}

void regularize(char *s)
{
  register char *lp;

  while((lp=strchr(s, '.')) || (lp=strchr(s, '/')) || (lp=strchr(s,' ')))
    *lp = '_';
}

void append_slash(char *name)
{
  char *ptr;

  if (!*name)
    return;
  ptr = name + (strlen(name) - 1);
  if (*ptr != '/') {
    *++ptr = '/';
    *++ptr = '\0';
  }
}
/////////////////////////////////////////////////////////////////////////////



/*  
init_nhwindows(int* argcp, char** argv)
                -- Initialize the windows used by NetHack.  This can also
                   create the standard windows listed at the top, but does
                   not display them.
                -- Any commandline arguments relevant to the windowport
                   should be interpreted, and *argcp and *argv should
                   be changed to remove those arguments.
                -- When the message window is created, the variable
                   iflags.window_inited needs to be set to TRUE.  Otherwise
                   all plines() will be done via raw_print().
                ** Why not have init_nhwindows() create all of the "standard"
                ** windows?  Or at least all but WIN_INFO?      -dean
*/
void gp2x_init_nhwindows(int* argc, char** argv)
{
  // printf("gp2x_init_nhwindows()\n");
}

/* Do a window-port specific player type selection. If player_selection()
   offers a Quit option, it is its responsibility to clean up and terminate
   the process. You need to fill in pl_character[0].
*/
void gp2x_player_selection(void)
{
  // printf("gp2x_player_selection()\n");
}

/* Ask the user for a player name. */
void gp2x_askname(void)
{
  // printf("gp2x_askname()\n");
}

/* Does window event processing (e.g. exposure events).
   A noop for the tty and X window-ports.
*/
void gp2x_get_nh_event(void)
{
  // printf("gp2x_get_nh_event()\n");
}

/* Exits the window system.  This should dismiss all windows,
   except the "window" used for raw_print().  str is printed if possible.
*/
void gp2x_exit_nhwindows(const char *str)
{
  // printf("gp2x_exit_nhwindows(%s)\n", str);
}

/* Prepare the window to be suspended. */
void gp2x_suspend_nhwindows(const char *str)
{
  // printf("gp2x_suspend_nhwindows(%s)\n", str);
}


/* Restore the windows after being suspended. */
void gp2x_resume_nhwindows()
{
  // printf("gp2x_resume_nhwindows()\n");
}

static int g_nLastID = 0;

/*  Create a window of type "type" which can be 
        NHW_MESSAGE     (top line)
        NHW_STATUS      (bottom lines)
        NHW_MAP         (main dungeon)
        NHW_MENU        (inventory or other "corner" windows)
        NHW_TEXT        (help/text, full screen paged window)
*/
winid 
gp2x_create_nhwindow(int type)
{
  // printf("gp2x_create_nhwindow(%d)\n", type);

  switch (type) {
    case NHW_MAP:
      return NHW_MAP;
    case NHW_MESSAGE:
      return NHW_MESSAGE;
    case NHW_STATUS:
      return NHW_STATUS;
    case NHW_MENU:
      return NewTextWindow();
    case NHW_TEXT:
      return NewTextWindow();
  }

  return -1;
}

/* Clear the given window, when asked to. */
void gp2x_clear_nhwindow(winid wid)
{
  // printf("gp2x_clear_nhwindow(%d)\n", wid);
  ClearWindow(wid);
}

/* -- Display the window on the screen.  If there is data
                   pending for output in that window, it should be sent.
                   If blocking is TRUE, display_nhwindow() will not
                   return until the data has been displayed on the screen,
                   and acknowledged by the user where appropriate.
                -- All calls are blocking in the tty window-port.
                -- Calling display_nhwindow(WIN_MESSAGE,???) will do a
                   --more--, if necessary, in the tty window-port.
*/
void gp2x_display_nhwindow(winid wid, BOOLEAN_P block)
{
  // printf("gp2x_display_nhwindow(%d, %d)\n", wid, block);
  if(wid >= 10)
  {
    DisplayTextWindow(wid);
    if(block)
    {
      WaitForTextWindowKey();
    }
  }
}

/* Destroy will dismiss the window if the window has not 
 * already been dismissed.
*/
void gp2x_destroy_nhwindow(winid wid)
{
  // printf("gp2x_destroy_nhwindow(%d)\n", wid);
  if(wid >= 10)
  {
    FreeTextWindow(wid);
  }
}

/* Next output to window will start at (x,y), also moves
 displayable cursor to (x,y).  For backward compatibility,
 1 <= x < cols, 0 <= y < rows, where cols and rows are
 the size of window.
*/
void gp2x_curs(winid wid, int x, int y)
{
  if(wid == NHW_MAP)
  {
    SetMapCursor(x, y);
// printf("gp2x_curs(%d, %d, %d)\n", wid, x, y);
  }
  else if(wid == NHW_STATUS)
  {
    SetStatusCursor(x, y);
  }
}

/*
putstr(window, attr, str)
                -- Print str on the window with the given attribute.  Only
                   printable ASCII characters (040-0126) must be supported.
                   Multiple putstr()s are output on separate lines.
Attributes
                   can be one of
                        ATR_NONE (or 0)
                        ATR_ULINE
                        ATR_BOLD
                        ATR_BLINK
                        ATR_INVERSE
                   If a window-port does not support all of these, it may map
                   unsupported attributes to a supported one (e.g. map them
                   all to ATR_INVERSE).  putstr() may compress spaces out of
                   str, break str, or truncate str, if necessary for the
                   display.  Where putstr() breaks a line, it has to clear
                   to end-of-line.
                -- putstr should be implemented such that if two putstr()s
                   are done consecutively the user will see the first and
                   then the second.  In the tty port, pline() achieves this
                   by calling more() or displaying both on the same line.
*/
void gp2x_putstr(winid wid, int attr, const char *text)
{
  char sz[200];
  // printf("gp2x_putstr(%d, %d, %s)\n", wid, attr, text);
  strcpy(sz, text);
  if(wid == NHW_STATUS)
  {
    StatusPutstr(sz, attr);
  }
  if(wid >= 10)
  {
    AppendTextToTextWindow(wid, sz, attr);
  }
}

/* Display the file named str.  Complain about missing files
                   iff complain is TRUE.
*/
void gp2x_display_file(const char *filename,BOOLEAN_P must_exist)
{
  dlb *f;

  // printf("gp2x_display_file(%s, %d)\n", filename, must_exist);

  f = dlb_fopen(filename, RDTMODE);
  if(f)
  {
    // winid text;
    char line[1000];

    // text = gp2x_create_nhwindow(NHW_TEXT);

    while (dlb_fgets(line, 1000, f))
    {
       size_t len;
       len = strlen(line);
       if( line[len-1]=='\n' ) line[len-1]='\x0';
// printf("%s\n", line);
    }
    (void) dlb_fclose(f);
  }
}

int g_bShowSelectAllOption = 0;
int g_bShowGoldOption = 0;
int g_bAutoReturnShowAll = 0;
int g_bAutoReturnGold = 0;
int g_bShowFingersOption = 0;
int g_bAutoReturnFingers = 0;

/* Start using window as a menu.  You must call start_menu()
   before add_menu().  After calling start_menu() you may not
   putstr() to the window.  Only windows of type NHW_MENU may
   be used for menus.
*/
void gp2x_start_menu(winid wid)
{
  // printf("gp2x_start_menu(%d)\n", wid);
  StartMenu(wid);
}

/*
add_menu(windid window, int glyph, const anything identifier,
                                char accelerator, char groupacc,
                                int attr, char *str, boolean preselected)
                -- Add a text line str to the given menu window.  If identifier
                   is 0, then the line cannot be selected (e.g. a title).
                   Otherwise, identifier is the value returned if the line is
                   selected.  Accelerator is a keyboard key that can be used
                   to select the line.  If the accelerator of a selectable
                   item is 0, the window system is free to select its own
                   accelerator.  It is up to the window-port to make the
                   accelerator visible to the user (e.g. put "a - " in front
                   of str).  The value attr is the same as in putstr().
                   Glyph is an optional glyph to accompany the line.  If
                   window port cannot or does not want to display it, this
                   is OK.  If there is no glyph applicable, then this
                   value will be NO_GLYPH.
                -- All accelerators should be in the range [A-Za-z].
                -- It is expected that callers do not mix accelerator
                   choices.  Either all selectable items have an accelerator
                   or let the window system pick them.  Don't do both.
                -- Groupacc is a group accelerator.  It may be any character
                   outside of the standard accelerator (see above) or a
                   number.  If 0, the item is unaffected by any group
                   accelerator.  If this accelerator conflicts with
                   the menu command (or their user defined alises), it loses.
                   The menu commands and aliases take care not to interfere
                   with the default object class symbols.
                -- If you want this choice to be preselected when the
                   menu is displayed, set preselected to TRUE.
*/
void gp2x_add_menu(winid wid, int glyph, const ANY_P * identifier,
    CHAR_P accelerator, CHAR_P group_accel, int attr, 
    const char *str, BOOLEAN_P presel)
{
  /*
  printf("gp2x_add_menu(%d, %d, %p, %c, %c, %d, %s, %d)\n",
         wid, glyph, identifier, (char)accelerator, (char)group_accel,
       attr, str, presel);
  */
  AddMenuItem(wid, glyph, identifier, str, attr, (int) presel);
}

/*
end_menu(window, prompt)
                -- Stop adding entries to the menu and flushes the window
                   to the screen (brings to front?).  Prompt is a prompt
                   to give the user.  If prompt is NULL, no prompt will
                   be printed.
                ** This probably shouldn't flush the window any more (if
                ** it ever did).  That should be select_menu's job.  -dean
*/
void gp2x_end_menu(winid wid, const char *prompt)
{
  // printf("gp2x_end_menu(%d, %s)\n", wid, prompt);
}

/*
int select_menu(windid window, int how, menu_item **selected)
                -- Return the number of items selected; 0 if none were chosen,
                   -1 when explicitly cancelled.  If items were selected, then
                   selected is filled in with an allocated array of menu_item
                   structures, one for each selected line.  The caller must
                   free this array when done with it.  The "count" field
                   of selected is a user supplied count.  If the user did
                   not supply a count, then the count field is filled with
                   -1 (meaning all).  A count of zero is equivalent to not
                   being selected and should not be in the list.  If no items
                   were selected, then selected is NULL'ed out.  How is the
                   mode of the menu.  Three valid values are PICK_NONE,
                   PICK_ONE, and PICK_N, meaning: nothing is selectable,
                   only one thing is selectable, and any number valid items
                   may selected.  If how is PICK_NONE, this function should
                   never return anything but 0 or -1.
                -- You may call select_menu() on a window multiple times --
                   the menu is saved until start_menu() or destroy_nhwindow()
                   is called on the window.
                -- Note that NHW_MENU windows need not have select_menu()
                   called for them. There is no way of knowing whether
                   select_menu() will be called for the window at
                   create_nhwindow() time.
*/
int gp2x_select_menu(winid wid, int how, MENU_ITEM_P **selected)
{
  int nReturned = -1;

  // printf("gp2x_select_menu(%d, %d)\n", wid, how);
  if(how == PICK_ONE)
    AddTopTextLine("A,B,STICK=select  X=cancel");
  if(how == PICK_ANY)
    AddTopTextLine("A,B=done  STICK,SELECT=toggle  X=cancel");
  SelectMenu(wid, how, g_bShowSelectAllOption, g_bShowGoldOption, g_bShowFingersOption, (unsigned long **) selected);
  nReturned = WaitForMenu(wid);
  g_bAutoReturnShowAll = 0;
  g_bAutoReturnGold = 0;
  g_bAutoReturnFingers = 0;
  if((nReturned == 0) && g_bShowSelectAllOption)
    g_bAutoReturnShowAll = 1;
  g_bShowSelectAllOption = 0;
  g_bShowGoldOption = 0;
  g_bShowFingersOption = 0;
  HideTextWindow(wid);
  if(nReturned == 100)
  {
    // GOLD!
    nReturned = 0;
    g_bAutoReturnGold = 1;
  }
  if(nReturned == 101)
  {
    // FINGERS!
    nReturned = 0;
    g_bAutoReturnFingers = 1;
  }

  return nReturned;
}

/*
    -- Indicate to the window port that the inventory has been changed.
    -- Merely calls display_inventory() for window-ports that leave the 
  window up, otherwise empty.
*/
void gp2x_update_inventory()
{
  // printf("gp2x_update_inventory()\n");
  if (flags.perm_invent) display_inventory(NULL,FALSE);
}

/*
mark_synch()    -- Don't go beyond this point in I/O on any channel until
                   all channels are caught up to here.  Can be an empty call
                   for the moment
*/
void gp2x_mark_synch()
{
  // printf("gp2x_mark_synch()\n");
}

/*
wait_synch()    -- Wait until all pending output is complete (*flush*() for
                   streams goes here).
                -- May also deal with exposure events etc. so that the
                   display is OK when return from wait_synch().
*/
void gp2x_wait_synch()
{
  // printf("gp2x_wait_synch()\n");
}

/*
cliparound(x, y)-- Make sure that the user is more-or-less centered on the
                   screen if the playing area is larger than the screen.
                -- This function is only defined if CLIPPING is defined.
*/
void gp2x_cliparound(int x, int y)
{
  // winid wid = WIN_MAP;
  // printf("gp2x_cliparound(%d, %d)\n", x, y);
  SetMapCenter(x, y);
}

extern short glyph2tile[];

void SaveGlyphChars()
{
  int ochar = 0;
  int ocolor = 0;
  unsigned int ospecial = 0;
  int nOut, nGlyph, n;

  FILE *fp;
  fp = fopen("glyphs.txt", "w");
  for(nOut = 0; nOut < 1057; nOut++)
  {
    nGlyph = -1;
    for(n = 0; n < MAX_GLYPH; n++)
    {
      if(glyph2tile[n] == nOut)
      {
        nGlyph = n;
        break;
      }
    }
    if(nGlyph == -1)
      ochar = ' ';
    else
      mapglyph(nGlyph, &ochar, &ocolor, &ospecial, 0, 0);
    fprintf(fp, "%c", ochar);
    if(nOut % 40 == 39)
      fprintf(fp, "\n");
  }
  fprintf(fp, "\n");
  for(nOut = 0; nOut < 1057; nOut++)
  {
    nGlyph = -1;
    for(n = 0; n < MAX_GLYPH; n++)
    {
      if(glyph2tile[n] == nOut)
      {
        nGlyph = n;
        break;
      }
    }
    if(nGlyph == -1)
      ochar = ' ';
    else
      mapglyph(nGlyph, &ochar, &ocolor, &ospecial, 0, 0);
    fprintf(fp, "%d,", ocolor);
    if(nOut % 40 == 39)
      fprintf(fp, "\n");
  }
  fclose(fp);
}


/*
print_glyph(window, x, y, glyph)
                -- Print the glyph at (x,y) on the given window.  Glyphs are
                   integers at the interface, mapped to whatever the window-
                   port wants (symbol, font, color, attributes, ...there's
                   a 1-1 map between glyphs and distinct things on the map).
*/
void gp2x_print_glyph(winid wid,XCHAR_P x,XCHAR_P y,int glyph)
{
  int ochar = 0;
  int ocolor = 0;
  unsigned int ospecial = 0;

// printf("gp2x_print_glyph(%d, %d, %d, %d)\n", wid, x, y, glyph);
  mapglyph(glyph, &ochar, &ocolor, &ospecial, x, y);
  SetMapGlyph(x, y, glyph, ochar, ocolor);
}

/*
raw_print(str)  -- Print directly to a screen, or otherwise guarantee that
                   the user sees str.  raw_print() appends a newline to str.
                   It need not recognize ASCII control characters.  This is
                   used during startup (before windowing system initialization
                   -- maybe this means only error startup messages are raw),
                   for error messages, and maybe other "msg" uses.  E.g.
                   updating status for micros (i.e, "saving").
*/
void gp2x_raw_print(const char *str)
{
  char sz[200];
  // printf("gp2x_raw_print(%s)\n", str);
  strcpy(sz, str);
  if(strstr(str, "Not carrying anything"))
    g_bCarryingError = 1;
  else
    g_bCarryingError = 0;
  AddTopTextLine(sz);
}

/*
raw_print_bold(str)
                -- Like raw_print(), but prints in bold/standout (if
possible).
*/
void gp2x_raw_print_bold(const char *str)
{
  char sz[200];
  // printf("gp2x_raw_print_bold(%s)\n", str);
  strcpy(sz, str);
  AddTopTextLine(sz);
}

int g_bDoingMoveLoop = 0;

void DoMoveLoop()
{
  g_bDoingMoveLoop = 1;
}

/*
int nhgetch()   -- Returns a single character input from the user.
                -- In the tty window-port, nhgetch() assumes that tgetch()
                   will be the routine the OS provides to read a character.
                   Returned character _must_ be non-zero.
*/
int gp2x_nhgetch()
{
  int n;
// printf("nhgetch\n");
   while(1)
   {
     if(g_bDoingMoveLoop)
     {
       while(IsTrackingDirection())
       {
         dzzMicroSleep(10000);
       }
       g_bDoingMoveLoop = 0;
       n = GetTrackedDirection();
       return n;
     }
     n = GetInputChar();
     if(n != 0)
     {
       return n;
     }
     dzzMicroSleep(10000);
  }
  return 0;
}

typedef struct HelpLine
{
  int nAttr;
  char *pszText;
} HelpLine;

#define NUM_HELP_LINES 84

HelpLine HelpLines[NUM_HELP_LINES] = {
  { ATR_NONE, "" },
  { ATR_BOLD, "GP2X Nethack Controls" },
  { ATR_NONE, "" },
  { ATR_BOLD, "COMMAND SUMMARY" },
  { ATR_NONE, "" },
  { ATR_NONE, "During normal gameplay, the GP2X controls" },
  { ATR_NONE, "have the following functions.  Although this" },
  { ATR_NONE, "list might look complicated at first, it is" },
  { ATR_NONE, "not difficult to learn as you go, and you" },
  { ATR_NONE, "can always refer to the Help for a reminder." },
  { ATR_NONE, "" },
  { ATR_NONE, "START = invoke the Main menu" },
  { ATR_NONE, "SELECT = invoke the Activities menu (shortcut)" },
  { ATR_NONE, "A = invoke the Action menu (shortcut)" },
  { ATR_NONE, "L+A = cast a spell" },
  { ATR_NONE, "B = invoke the Use menu (shortcut)" },
  { ATR_NONE, "L+B = zap a wand" },
  { ATR_NONE, "X = look at things in your current location" },
  { ATR_NONE, "L+X = enter Farlook mode to examine things" },
  { ATR_NONE, "Y = open" },
  { ATR_NONE, "L+Y = kick" },
  { ATR_NONE, "L = a 'shift' key used to alter commands" },
  { ATR_NONE, "R = repeat last command" },
  { ATR_NONE, "L+R = fire weapon" },
  { ATR_NONE, "Joystick = move" },
  { ATR_NONE, "L+Joystick = move a far distance" },
  { ATR_NONE, "Stick-Click = search or pick up" },
  { ATR_NONE, "L+Stick-Click = wait" },
  { ATR_NONE, "Volume +/- = zoom in/out" },
  { ATR_NONE, "L+Volume +/- = scroll top text" },
  { ATR_NONE, "" },
  { ATR_BOLD, "COMMAND SUMMARY - MAP SELECTION" },
  { ATR_NONE, "" },
  { ATR_NONE, "Certain commands or situations require that" },
  { ATR_NONE, "you select a location or direction on the" },
  { ATR_NONE, "map.  When this occurs, a cursor (large yellow" },
  { ATR_NONE, "square) appears." },
  { ATR_NONE, "" },
  { ATR_NONE, "Joystick = move cursor" },
  { ATR_NONE, "Stick-Click,A,B,Y,SELECT = select location" },
  { ATR_NONE, "L+Stick-Click,A,B,Y,SELECT = in Farlook mode," },
  { ATR_NONE, "  show extended information about the selection" },
  { ATR_NONE, "Volume +/- = in direction selection mode," },
  { ATR_NONE, "  selects 'up' or 'down' as the direction" },
  { ATR_NONE, "" },
  { ATR_BOLD, "COMMAND SUMMARY - MENUS" },
  { ATR_NONE, "" },
  { ATR_NONE, "There are several types of menus in Nethack." },
  { ATR_NONE, "The concept is the same for all of them, but" },
  { ATR_NONE, "some of the details vary.  In all cases, the" },
  { ATR_NONE, "joystick up and down directions scroll through" },
  { ATR_NONE, "the available selections.  Holding down L" },
  { ATR_NONE, "while navigating scrolls by pages instead" }, 
  { ATR_NONE, "of lines." },
  { ATR_NONE, "" },
  { ATR_NONE, "In all cases, the X button ends the menu without" },
  { ATR_NONE, "making a selection ('Cancel')." },
  { ATR_NONE, "" },
  { ATR_NONE, "In all cases, the A and B buttons end the menu" },
  { ATR_NONE, "selection, choosing the current selection." },
  { ATR_NONE, "" },
  { ATR_NONE, "In cascaded game menus, the joystick left and" },
  { ATR_NONE, "right directions can be used to open and close" },
  { ATR_NONE, "submenus.  Also in this mode, Stick-Click can" },
  { ATR_NONE, "be used to make a selection." },
  { ATR_NONE, "" },
  { ATR_NONE, "In single-selection menus, Stick-Click can be" },
  { ATR_NONE, "used to make a selection." },
  { ATR_NONE, "" },
  { ATR_NONE, "In multiple-selection menus, the individual" },
  { ATR_NONE, "selections can be toggled on and off with the" },
  { ATR_NONE, "Stick-Click or the SELECT button." },
  { ATR_NONE, "" },
  { ATR_NONE, "In menus, quantities of objects can be changed" },
  { ATR_NONE, "with the Volume +/- keys" },
  { ATR_NONE, "" },
  { ATR_BOLD, "IMPORTANT HINT" },
  { ATR_NONE, "" },
  { ATR_NONE, "The top of the 'Activities' menu (invoked with" },
  { ATR_NONE, "the SELECT button) contains commands that are" },
  { ATR_NONE, "appropriate to the current game situation.  For" },
  { ATR_NONE, "example, when standing on a staircase leading" },
  { ATR_NONE, "down, 'Down' will appear in this menu." },
  { ATR_NONE, "" },
};

/*
int nh_poskey(int *x, int *y, int *mod)
                -- Returns a single character input from the user or a
                   a positioning event (perhaps from a mouse).  If the
                   return value is non-zero, a character was typed, else,
                   a position in the MAP window is returned in x, y and mod.
                   mod may be one of

                        CLICK_1         -- mouse click type 1 
                        CLICK_2         -- mouse click type 2 

                   The different click types can map to whatever the
                   hardware supports.  If no mouse is supported, this
                   routine always returns a non-zero character.
*/
int gp2x_nh_poskey(int *x, int *y, int *mod)
{
  int n;
// printf("nhposkey\n");
  while(1)
  {
    if(g_bDoHelpWindow)
    {
      winid wid;
      int n;
      wid = gp2x_create_nhwindow(NHW_TEXT);
      for(n = 0; n < NUM_HELP_LINES; n++)
      {
        gp2x_putstr(wid, HelpLines[n].nAttr, HelpLines[n].pszText);
      }
      gp2x_display_nhwindow(wid, TRUE);
      gp2x_destroy_nhwindow(wid);
      g_bDoHelpWindow = 0;
    }
    if(g_bDoingMoveLoop)
    {
      while(IsTrackingDirection())
      {
        dzzMicroSleep(10000);
      }
      g_bDoingMoveLoop = 0;
      n = GetTrackedDirection();
      return n;
    }
    n = GetInputChar();
    if(n != 0)
    {
      return n;
    }
    dzzMicroSleep(10000);
  }
  return 0;
}

/*
nhbell()        -- Beep at user.  [This will exist at least until sounds are
                   redone, since sounds aren't attributable to windows anyway.]
*/
void gp2x_nhbell()
{
  // printf("gp2x_nhbell()\n");
}

/*
doprev_message()
                -- Display previous messages.  Used by the ^P command.
                -- On the tty-port this scrolls WIN_MESSAGE back one line.
*/
int gp2x_doprev_message()
{
  // printf("gp2x_doprev_message()\n");
  return 0;
}

/*
char yn_function(const char *ques, const char *choices, char default)
                -- Print a prompt made up of ques, choices and default.
                   Read a single character response that is contained in
                   choices or default.  If choices is NULL, all possible
                   inputs are accepted and returned.  This overrides
                   everything else.  The choices are expected to be in
                   lower case.  Entering ESC always maps to 'q', or 'n',
                   in that order, if present in choices, otherwise it maps
                   to default.  Entering any other quit character (SPACE,
                   RETURN, NEWLINE) maps to default.
                -- If the choices string contains ESC, then anything after
                   it is an acceptable response, but the ESC and whatever
                   follows is not included in the prompt.
                -- If the choices string contains a '#' then accept a count.
                   Place this value in the global "yn_number" and return '#'.
                -- This uses the top line in the tty window-port, other
                   ports might use a popup.
*/
char gp2x_yn_function(const char *question, const char *choices,
    CHAR_P def)
{
  char truncquestion[100];
  char *pstr;

// printf("gp2x_yn_function(%s, %s, %d)\n", question, choices, def);

  strcpy(truncquestion, question);

  pstr = strchr(truncquestion, '?');
  if(pstr)
  {
    pstr++;
    *pstr = 0;
  }

  if(!strncmp(question, "Specify unknown", 15))
  {
    return 'y';
  }
  if(!strncmp(question, "More info", 9))
  {
    if(dzzShiftDown())
      return 'y';
    return 'q';
  }

  // force a menu selection
  if(!strncmp(question, "What do you want to", 19))
  {
    g_bShowSelectAllOption = 0;
    g_bShowGoldOption = 0;
    g_bShowFingersOption = 0;
    if(strchr(question, '$'))
    {
      g_bShowGoldOption = 1;
    }
    else if(strstr(question, "[-"))
    {
      g_bShowFingersOption = 1;
    }
    if(((strchr(question, '*')&& !strstr(question, "$ or")) || strstr(question, "$ or ?*")) && !g_bCarryingError)
    {
      AddTopTextLine(truncquestion);
      if(g_bAutoReturnShowAll)
      {
        g_bAutoReturnShowAll = 0;
        return '*';
      }
      if(g_bAutoReturnGold)
      {
        g_bAutoReturnGold = 0;
        return '$';
      }
      if(g_bAutoReturnFingers)
      {
        g_bAutoReturnFingers = 0;
        return '-';
      }
      if(!strchr(question, '?'))
        return '*';
      g_bShowSelectAllOption = 1;
      return '?';
    }
    if(strstr(question, "$ or ?*") && g_bCarryingError)
    {
      g_bCarryingError = 0;
      return '$';
    }
    if(g_bCarryingError)
    {
      g_bCarryingError = 0;
      return 27;
    }
    if(strchr(question, '*')&& strstr(question, "$ or"))
    {
      return 27;
    }
    AddTopTextLine(truncquestion);
    return '?';
  }

  if(!choices && strstr(question, "n what direction") && !g_bFastDirection)
  {
    int n;
    char q[1000];
    // we're selecting a direction
    if(question)
    {
      strcpy(q, question);
      AddTopTextLine(q);
    }
     StartTrackingDirection();
     while(IsTrackingDirection())
     {
       dzzMicroSleep(10000);
     }
     n = GetTrackedDirection();
     return n;
  }

  if(!choices)
  {
    int n;
    char sz[200];
    // this means anything goes
    strcpy(sz, question);
    AddTopTextLine(sz);

    while(1)
    {
      n = GetInputChar();
      if(n != 0)
        return n;
      dzzMicroSleep(10000);
    }
  }

  if(!strcmp(choices, "ynq"))
  {
    dzzPopYNQ(question);
    while(dzzIsYNQPopped())
    {
      dzzMicroSleep(10000);
    }
    return dzzGetYNQResult();
  }
  if(!strcmp(choices, "rl"))
  {
    dzzPopRL(question);
    while(dzzIsRLPopped())
    {
      dzzMicroSleep(10000);
    }
    return dzzGetRLResult();
  }
  dzzPopYN(question);
  while(dzzIsYNPopped())
  {
    dzzMicroSleep(10000);
  }
  return dzzGetYNResult();
}

/*
getlin(const char *ques, char *input)
      -- Prints ques as a prompt and reads a single line of text,
         up to a newline.  The string entered is returned without the
         newline.  ESC is used to cancel, in which case the string
         "\033\000" is returned.
      -- getlin() must call flush_screen(1) before doing anything.
      -- This uses the top line in the tty window-port, other
         ports might use a popup.
*/
void gp2x_getlin(int nWhich, const char *question, char *input)
{
  // printf("gp2x_getlin(%s\n", question));
  *input = 0;
  if(strstr(question, "what level do you want to teleport"))
  {
    strcpy(input, "?");
    return;
  }
  dzzGetInputString(nWhich, question, input, 40, 1, "");
  if(*input == 0)
    strcpy(input, "\033");
}


/*
int get_ext_cmd(void)
      -- Get an extended command in a window-port specific way.
         An index into extcmdlist[] is returned on a successful
         selection, -1 otherwise.
*/
int gp2x_get_ext_cmd()
{
  // printf("gp2x_get_ext_cmd()\n");
  return GetExtCommand();
}

/*
number_pad(state)
      -- Initialize the number pad to the given state.
*/
void gp2x_number_pad(int state)
{
  // printf("gp2x_number_pad(%d)\n", state);
}

/*
delay_output()  -- Causes a visible delay of 50ms in the output.
         Conceptually, this is similar to wait_synch() followed
         by a nap(50ms), but allows asynchronous operation.
*/
void gp2x_delay_output()
{
  // printf("gp2x_delay_output()\n");
  dzzMicroSleep(50);
}

void gp2x_change_color() 
{ 
  // printf("gp2x_change_color()\n"); 
}

char *gp2x_get_color_string() 
{ 
  // printf("gp2x_get_color_string()\n");
  return( "" ); 
}

/*
start_screen()  -- Only used on Unix tty ports, but must be declared for
         completeness.  Sets up the tty to work in full-screen
         graphics mode.  Look at win/tty/termcap.c for an
         example.  If your window-port does not need this function
         just declare an empty function.
*/
void gp2x_start_screen()
{
  // printf("gp2x_start_screen()\n");
}

/*
end_screen()    -- Only used on Unix tty ports, but must be declared for
         completeness.  The complement of start_screen().
*/
void gp2x_end_screen()
{
  // printf("gp2x_end_screen()\n");
}

/*
outrip(winid, int)
      -- The tombstone code.  If you want the traditional code use
         genl_outrip for the value and check the #if in rip.c.
*/
void gp2x_outrip(winid wid, int how)
{
  // printf("gp2x_outrip(%d) - name (%s) gold = %d\n", wid, how, plname, (int) u.ugold);
}

/* handle options updates here */
void gp2x_preference_update(const char *pref)
{
  // printf("gp2x_preference_update (%s)\n", pref);
}


struct window_procs gp2x_procs = {
    "gp2x",
    WC_COLOR|WC_HILITE_PET|WC_ALIGN_MESSAGE|WC_ALIGN_STATUS|
  WC_INVERSE|WC_SCROLL_AMOUNT|WC_SCROLL_MARGIN|WC_MAP_MODE|
  WC_FONT_MESSAGE|WC_FONT_STATUS|WC_FONT_MENU|WC_FONT_TEXT|WC_FONT_MAP|
  WC_FONTSIZ_MESSAGE|WC_FONTSIZ_STATUS|WC_FONTSIZ_MENU|WC_FONTSIZ_TEXT|
  WC_TILE_WIDTH|WC_TILE_HEIGHT|WC_TILE_FILE|WC_VARY_MSGCOUNT|
  WC_WINDOWCOLORS|WC_PLAYER_SELECTION|WC_SPLASH_SCREEN|WC_POPUP_DIALOG,
    0L,
    gp2x_init_nhwindows,
    gp2x_player_selection,
    gp2x_askname,
    gp2x_get_nh_event,
    gp2x_exit_nhwindows,
    gp2x_suspend_nhwindows,
    gp2x_resume_nhwindows,
    gp2x_create_nhwindow,
    gp2x_clear_nhwindow,
    gp2x_display_nhwindow,
    gp2x_destroy_nhwindow,
    gp2x_curs,
    gp2x_putstr,
    gp2x_display_file,
    gp2x_start_menu,
    gp2x_add_menu,
    gp2x_end_menu,
    gp2x_select_menu,
    genl_message_menu,    /* no need for X-specific handling */
    gp2x_update_inventory,
    gp2x_mark_synch,
    gp2x_wait_synch,
#ifdef CLIPPING
    gp2x_cliparound,
#endif
#ifdef POSITIONBAR
    donull,
#endif
    gp2x_print_glyph,
    gp2x_raw_print,
    gp2x_raw_print_bold,
    gp2x_nhgetch,
    gp2x_nh_poskey,
    gp2x_nhbell,
    gp2x_doprev_message,
    gp2x_yn_function,
    gp2x_getlin,
    gp2x_get_ext_cmd,
    gp2x_number_pad,
    gp2x_delay_output,
    /*
#ifdef CHANGE_COLOR
  mswin,
  gp2x_change_background,
#endif
    */
    /* other defs that really should go away (they're tty specific) */
    gp2x_start_screen,
    gp2x_end_screen,
    gp2x_outrip,
    gp2x_preference_update,
};

#define ROLE_ARCHEOLOGIST  0
#define ROLE_BARBARIAN     1
#define ROLE_CAVEMAN       2
#define ROLE_HEALER        3
#define ROLE_KNIGHT        4
#define ROLE_MONK          5
#define ROLE_PRIEST        6
#define ROLE_ROGUE         8
#define ROLE_RANGER        7
#define ROLE_SAMURAI       9
#define ROLE_TOURIST       10
#define ROLE_VALKYRIE      11
#define ROLE_WIZARD        12

#define RACE_HUMAN         0x01
#define RACE_DWARF         0x02
#define RACE_ELF           0x04
#define RACE_GNOME         0x08
#define RACE_ORC           0x10

#define SEX_MALE           0x01
#define SEX_FEMALE         0x02

#define ALIGNMENT_LAWFUL   0x01
#define ALIGNMENT_NEUTRAL  0x02
#define ALIGNMENT_CHAOTIC  0x04

static int g_nAllowedRaces[13] = {
  RACE_HUMAN | RACE_DWARF | RACE_GNOME,
  RACE_HUMAN | RACE_ORC,
  RACE_HUMAN | RACE_DWARF | RACE_GNOME,
  RACE_HUMAN | RACE_GNOME,
  RACE_HUMAN,
  RACE_HUMAN,
  RACE_HUMAN | RACE_ELF,
  RACE_HUMAN | RACE_ELF | RACE_GNOME,
  RACE_HUMAN | RACE_ORC,
  RACE_HUMAN,
  RACE_HUMAN,
  RACE_HUMAN | RACE_DWARF,
  RACE_HUMAN | RACE_ELF | RACE_GNOME,
};

static int g_nAllowedAlignments[13] = {
  ALIGNMENT_LAWFUL | ALIGNMENT_NEUTRAL,
  ALIGNMENT_NEUTRAL | ALIGNMENT_CHAOTIC,
  ALIGNMENT_LAWFUL | ALIGNMENT_NEUTRAL,
  ALIGNMENT_NEUTRAL,
  ALIGNMENT_LAWFUL,
  ALIGNMENT_LAWFUL | ALIGNMENT_NEUTRAL | ALIGNMENT_CHAOTIC,
  ALIGNMENT_LAWFUL | ALIGNMENT_NEUTRAL | ALIGNMENT_CHAOTIC,
  ALIGNMENT_NEUTRAL | ALIGNMENT_CHAOTIC,
  ALIGNMENT_CHAOTIC,
  ALIGNMENT_LAWFUL,
  ALIGNMENT_NEUTRAL,
  ALIGNMENT_LAWFUL | ALIGNMENT_NEUTRAL,
  ALIGNMENT_NEUTRAL | ALIGNMENT_CHAOTIC,
};

static char *g_ppszRoleNames[14] = {
  "Random",
  "Archeologist",
  "Barbarian",
  "Caveman",
  "Healer",
  "Knight",
  "Monk",
  "Priest",
  "Ranger",
  "Rogue",
  "Samurai",
  "Tourist",
  "Valkyrie",
  "Wizard"
};

static char *g_ppszRandomRole[6] = {
  "Your role will be chose randomly from",
  "Archeologist, Barbarian, Caveman, Healer,",
  "Knight, Monk, Priest, Ranger, Rogue,",
  "Samurai, Tourist, Valkyrie, and",
  "Wizard.",
  NULL
};

static char *g_ppszArcheologist[6] = {
  "Archeologists understand dungeons pretty",
  "well; this enables them to move quickly and",
  "sneak up on the local nasties.  They start",
  "equipped with the tools for a proper",
  "scientific expedition.",
  NULL
};

static char *g_ppszBarbarian[5] = {
  "Barbarians are warriors out of the hinterland,",
  "hardened to battle.  They begin their quests",
  "with naught but uncommon strength, a trusty",
  "hauberk, and a great two-handed sword.",
  NULL
};

static char *g_ppszCaveman[4] = {
  "Cavemen and Cavewomen start with",
  "exceptional strength but, unfortunately,",
  "with neolithic weapons.",
  NULL
};

static char *g_ppszHealer[9] = {
  "Healers are wise in medicine and apothecary.",
  "They know the herbs and simples that can",
  "restore vitality, ease pain, anesthetize, and",
  "neutralize poisons; and with their instruments,",
  "they can divine a being's state of health or",
  "sickness.  Their medical practice earns them",
  "quite reasonable amounts of money, with",
  "which they enter the dungeon.",
  NULL
};

static char *g_ppszKnight[5] = {
  "Knights are distinguished from the common",
  "skirmisher by their devotion to the ideals of",
  "chivalry and by the surpassing excellence of",
  "their armor.",
  NULL
};

static char *g_ppszMonk[6] = {
  "Monks are ascetics, who by rigorous practice",
  "of physical and mental disciplines have become",
  "capable of fighting as effectively without",
  "weapons as with.  They wear no armor but",
  "make up for it with increased mobility.",
  NULL
};

static char *g_ppszPriest[7] = {
  "Priests and Priestesses are clerics militant,",
  "crusaders advancing the cause of",
  "righteousness with arms, armor, and arts",
  "thaumaturgic.  Their ability to commune with",
  "deities via prayer occasionally extricates",
  "them from peril, but can also put them in it.",
  NULL
};

static char *g_ppszRanger[6] = {
  "Rangers are most at home in the woods,",
  "and some say slightly out of place in a",
  "dungeon.  They are, however, experts in",
  "archery as well as tracking, and",
  "stealthy movement.",
  NULL
};

static char *g_ppszRogue[5] = {
  "Rogues are agile and stealthy thieves, with",
  "knowledge of locks, traps, and poisons.  Their",
  "advantage lies in surprise, which they employ",
  "to great advantage.",
  NULL
};

static char *g_ppszSamurai[5] = {
  "Samurai are the elite warriors of feudal",
  "Nippon.  They are lightly armored and quick,",
  "and wear the dai-sho, two swords of the",
  "deadliest keenness.",
  NULL
};

static char *g_ppszTourist[5] = {
  "Tourists start out with lots of gold (suitable",
  "for shopping with), a credit card, lots of food,",
  "some maps, and an expensive camera.  Most",
  "monsters don't like being photographed.",
  NULL
};

static char *g_ppszValkyrie[5] = {
  "Valkyries are hardy warrior women.  Their",
  "upbringing in the harsh Northlands makes them",
  "strong, inures them to extremes of cold, and",
  "instills in them stealth and cunning.",
  NULL
};

static char *g_ppszWizard[6] = {
  "Wizards start out with a knowledge of magic,",
  "a selection of magical items, and a particular",
  "affinity for dweomercraft.  Although seemingly",
  "weak and easy to overcome at first sight, an",
  "experienced Wizard is a deadly foe.",
  NULL
};

static char *g_ppszDwarf[7] = {
  "Dwarves are smaller than humans or elves, but",
  "are stocky and solid individuals.  Dwarves'",
  "most notable trait is their great expertise in",
  "mining and metalwork.  Dwarvish armor is said",
  "to be second in quality not even to the mithril",
  "armor of the Elves.",
  NULL
};

static char *g_ppszElf[5] = {
  "Elves are agile, quick, and perceptive; very",
  "little of what goes on will escape an Elf.  The",
  "quality of Elven craftsmanship often gives them",
  "an advantage in arms and armor.",
  NULL
};

static char *g_ppszGnome[7] = {
  "Gnomes are smaller than but generally similar",
  "to dwarves.  Gnomes are known to be expert",
  "miners, and it is known that a secret",
  "underground mine complex built by this race",
  "exists within the Mazes of Menace, filled with",
  "both riches and danger.",
  NULL
};

static char *g_ppszRandomRace[3] = {
  "One of the available races will be chosen for",
  "you at random.",
  NULL
};

static char *g_ppszHuman[6] = {
  "Humans are by far the most common race of the",
  "surface world, and are thus the norm by which",
  "other races are often compared.  Although they",
  "have no special abilities, they can succeed in",
  "any role.",
  NULL
};

static char *g_ppszOrc[8] = {
  "Orcs are a cruel and barbaric race that hate",
  "every living thing (including other orcs).",
  "Above all others, Orcs hate Elves with a",
  "passion unequalled, and will go out of their",
  "way to kill one at any opportunity.  The armor",
  "and weapons fashioned by the Orcs are typically",
  "of inferior quality.",
  NULL
};

static char *g_ppszRandomSex[3] = {
  "The gender of your character will be chosen",
  "randomly.",
  NULL
};
static char *g_ppszMale[4] = {
  "Men are more likely than women to grow",
  "beards.  For other differences between",
  "the sexes, see www.google.com",
  NULL
};

static char *g_ppszFemale[4] = {
  "Women are less likely than men to grow",
  "beards.  For other differences between",
  "the sexes, see www.google.com",
  NULL
};

static char *g_ppszRandomAlignment[3] = {
  "One of the available alignments will",
  "be chosen for you at random.",
  NULL
};

static char *g_ppszAlignment[9] = {
  "Often, Lawful is taken as good and Chaotic",
  "as evil, but legal and ethical do not always",
  "coincide.  Your alignment influences how other",
  "monsters react toward you.  Monsters of a",
  "like alignment are more likely to be",
  "non-aggressive, while those of an opposing",
  "alignment are more likely to be seriously",
  "offended at your presence.",
  NULL
};

static char **g_pppszRoles[14] = {
  g_ppszRandomRole,
  g_ppszArcheologist,
  g_ppszBarbarian,
  g_ppszCaveman,
  g_ppszHealer,
  g_ppszKnight,
  g_ppszMonk,
  g_ppszPriest,
  g_ppszRanger,
  g_ppszRogue,
  g_ppszSamurai,
  g_ppszTourist,
  g_ppszValkyrie,
  g_ppszWizard
};

void DoHelp()
{
  g_bDoHelpWindow = 1;
}

//// main

extern char g_szTileFile[200];

int main(int argc, char *argv[])
{
  int bInitialized = 0;
  int nPhaseStack[10];
  int nPhaseStackEntries = 0;
  int fd;
// printf("Starting UI\n");
  GetRepeatData();
 // if(g_szTileFile[0])
 //   QuickInitUI();
//  else
//    QuickInitUI(0);
  StartUI();
// printf("Calling choose_windows\n");
  choose_windows(DEFAULT_WINDOW_SYS);
// printf("Calling initoptions\n");
  initoptions();
// printf("Calling init_nhwindows\n");
  init_nhwindows(&argc, argv);
  /* DZZ: local options
// printf("Calling process_options\n");
  process_options(argc, argv);
  */

// printf("Calling dlb_init\n");
  dlb_init();

  x_maze_max = COLNO-1;
  if(x_maze_max % 2)
    x_maze_max--;
  y_maze_max = ROWNO-1;
  if(y_maze_max % 2)
    y_maze_max--;
// printf("Calling vision_init\n");
  vision_init();
// printf("Calling display_gamewindows\n");
  display_gamewindows();
  // here we should look for a restored game somehow

  {
#define PHASE_NAME       0
#define PHASE_ROLE       1
#define PHASE_RACE       2
#define PHASE_SEX        3
#define PHASE_ALIGNMENT  4
#define PHASE_FINISHED   5

    int nPhase = PHASE_NAME;
    int nRole;
    int nRace;
    int nSex;
    int nAlignment;
    int bExitLoop = 0;

    plname[0] = 0;

#ifdef INSURANCE
extern int g_bCrashRecovery;
if(g_bCrashRecovery)
{
  int bRecover = 0;
  FILE *fp;
  fp = fopen("1lock.0", "r");
  if(fp)
  {
    bRecover = 1;
    fclose(fp);
  }
  if(bRecover)
    recover_savefile();
}
#endif

    while(!bExitLoop)
    {
      if(bInitialized)
        break;

      switch(nPhase)
      {
        case PHASE_NAME:
          dzzSetStatusLines("  http://gp2xgamer.com/nethack                       L+R=Exit NetHack", "                            GP2X port v0.6 by dzz");
          dzzGetInputString(50, "Enter your name:", plname, 12, 0, " \\/:*?\"<>|-");
          if(g_bExitGame)
            goto done;
          strcpy(g_szRepeatName, plname);
          if(!strcmpi(plname, "wizard"))
            wizard = 1;

          fd = restore_saved_game();
          if(fd >= 0)
          {
            if(dorecover(fd))
            {
              delete_savefile();
              bInitialized = 1;
            }
          }
          if(g_bExitGame)
            goto done;
          nPhaseStack[nPhaseStackEntries++] = PHASE_NAME;
          nPhase = PHASE_ROLE;
          break;

        case PHASE_ROLE:
          dzzSetStatusLines("  A=Choose selected role     Y=Go back           L+R=Exit NetHack",
              "                            GP2X port v0.6 by dzz");
          nRole = dzzPopMC("Select your character's role:", 14, g_nRepeatRole + 1,
              (const char **) g_ppszRoleNames, (const char ***) g_pppszRoles);
          if(g_bExitGame)
            goto done;
          if(nRole < 0) // 'Y' was pressed
          {
            nPhaseStackEntries--;
            nPhase = nPhaseStack[nPhaseStackEntries];
            break;
          }
          g_nRepeatRole = nRole-1;
          if(nRole == 0)
            nRole = rand() % 13;
          else
            nRole--;
          nPhaseStack[nPhaseStackEntries++] = PHASE_ROLE;
          nPhase = PHASE_RACE;
          break;

        case PHASE_RACE:
          if(g_nAllowedRaces[nRole] == RACE_HUMAN)
            nRace = RACE_HUMAN;
          else
          {
            char *g_Names[10];
            char **g_Descs[10];
            int nChoices = 0;
            int nDefaultRace = 0;
            g_Names[nChoices] = "Random";
            g_Descs[nChoices] = g_ppszRandomRace;
            nChoices++;
            if(g_nAllowedRaces[nRole] & RACE_HUMAN)
            {
              g_Names[nChoices] = "Human";
              g_Descs[nChoices] = g_ppszHuman;
              if(g_nRepeatRace == RACE_HUMAN)
                nDefaultRace = nChoices;
              nChoices++;
            }
            if(g_nAllowedRaces[nRole] & RACE_DWARF)
            {
              g_Names[nChoices] = "Dwarf";
              g_Descs[nChoices] = g_ppszDwarf;
              if(g_nRepeatRace == RACE_DWARF)
                nDefaultRace = nChoices;
              nChoices++;
            }
            if(g_nAllowedRaces[nRole] & RACE_ELF)
            {
              g_Names[nChoices] = "Elf";
              g_Descs[nChoices] = g_ppszElf;
              if(g_nRepeatRace == RACE_ELF)
                nDefaultRace = nChoices;
              nChoices++;
            }
            if(g_nAllowedRaces[nRole] & RACE_GNOME)
            {
              g_Names[nChoices] = "Gnome";
              g_Descs[nChoices] = g_ppszGnome;
              if(g_nRepeatRace == RACE_GNOME)
                nDefaultRace = nChoices;
              nChoices++;
            }
            if(g_nAllowedRaces[nRole] & RACE_ORC)
            {
              g_Names[nChoices] = "Orc";
              g_Descs[nChoices] = g_ppszOrc;
              if(g_nRepeatRace == RACE_ORC)
                nDefaultRace = nChoices;
              nChoices++;
            }
            if(g_nRepeatRace < 0)
              nDefaultRace = 0;
            dzzSetStatusLines("  A=Choose selected race     Y=Go back           L+R=Exit NetHack",
                "                            GP2X port v0.6 by dzz");
            nRace = dzzPopMC("Select your character's race:", nChoices, nDefaultRace,
              (const char **) g_Names, (const char ***) g_Descs);
            if(g_bExitGame)
              goto done;
            if(nRace < 0)
            {
              nPhaseStackEntries--;
              nPhase = nPhaseStack[nPhaseStackEntries];
              break;
            }
            if(!strcmp(g_Names[nRace], "Random"))
            {
              int nC = (rand() % (nChoices - 1)) + 1;
              if(!strcmp(g_Names[nC], "Dwarf")) nRace = RACE_DWARF;
              else if(!strcmp(g_Names[nC], "Elf")) nRace = RACE_ELF;
              else if(!strcmp(g_Names[nC], "Gnome")) nRace = RACE_GNOME;
              else if(!strcmp(g_Names[nC], "Orc")) nRace = RACE_ORC;
              else nRace = RACE_HUMAN;
              g_nRepeatRace = -1;
            }
            else
            {
              if(!strcmp(g_Names[nRace], "Dwarf")) nRace = RACE_DWARF;
              else if(!strcmp(g_Names[nRace], "Elf")) nRace = RACE_ELF;
              else if(!strcmp(g_Names[nRace], "Gnome")) nRace = RACE_GNOME;
              else if(!strcmp(g_Names[nRace], "Orc")) nRace = RACE_ORC;
              else nRace = RACE_HUMAN;
              g_nRepeatRace = nRace;
            }
          }
          nPhaseStack[nPhaseStackEntries++] = PHASE_RACE;
          nPhase = PHASE_SEX;
          break;

        case PHASE_SEX:
          if(nRole == ROLE_VALKYRIE)
            nSex = SEX_FEMALE;
          else
          {
            char *g_Names[3];
            char **g_Descs[3];
            int nDefaultSex = 0;
            g_Names[0] = "Random";
            g_Descs[0] = g_ppszRandomSex;
            g_Names[1] = "Male";
            g_Descs[1] = g_ppszMale;
            g_Names[2] = "Female";
            g_Descs[2] = g_ppszFemale;
            if(g_nRepeatSex < 0)
              nDefaultSex = 0;
            else if(g_nRepeatSex == SEX_MALE)
              nDefaultSex = 1;
            else if(g_nRepeatSex == SEX_FEMALE)
              nDefaultSex = 2;
            dzzSetStatusLines("  A=Choose selected gender    Y=Go back          L+R=Exit NetHack",
                "                            GP2X port v0.6 by dzz");
            nSex = dzzPopMC("Select your character's gender:", 3, nDefaultSex,
              (const char **) g_Names, (const char ***) g_Descs);
            if(g_bExitGame)
              goto done;
            if(nSex < 0)
            {
              nPhaseStackEntries--;
              nPhase = nPhaseStack[nPhaseStackEntries];
              break;
            }
            if(nSex == 0)
            {
              if((rand() & 0x01) == 0)
                nSex = SEX_MALE;
              else
                nSex = SEX_FEMALE;
              g_nRepeatSex = -1;
            }
            else
            {
              if(!strcmp(g_Names[nSex], "Male")) nSex = SEX_MALE;
              else nSex = SEX_FEMALE;
              g_nRepeatSex = nSex;
            }
          }
          nPhaseStack[nPhaseStackEntries++] = PHASE_SEX;
          nPhase = PHASE_ALIGNMENT;
          break;

        case PHASE_ALIGNMENT:
          if(g_nAllowedAlignments[nRole] == ALIGNMENT_LAWFUL)
            nAlignment = ALIGNMENT_LAWFUL;
          else if(g_nAllowedAlignments[nRole] == ALIGNMENT_NEUTRAL)
            nAlignment = ALIGNMENT_NEUTRAL;
          else if(g_nAllowedAlignments[nRole] == ALIGNMENT_CHAOTIC)
            nAlignment = ALIGNMENT_CHAOTIC;
          else if(nRace == RACE_ELF)
            nAlignment = ALIGNMENT_CHAOTIC;
          else if(nRace == RACE_DWARF)
            nAlignment = ALIGNMENT_LAWFUL;
          else if(nRace == RACE_GNOME)
            nAlignment = ALIGNMENT_NEUTRAL;
          else
          {
            char *g_Names[10];
            char **g_Descs[10];
            int nChoices = 0;
            int nDefaultAlignment = 0;
            g_Names[nChoices] = "Random";
            g_Descs[nChoices] = g_ppszRandomAlignment;
            nChoices++;
            if(g_nAllowedAlignments[nRole] & ALIGNMENT_LAWFUL)
            {
              g_Names[nChoices] = "Lawful";
              g_Descs[nChoices] = g_ppszAlignment;
              if(g_nRepeatAlignment == ALIGNMENT_LAWFUL)
                nDefaultAlignment = nChoices;
              nChoices++;
            }
            if(g_nAllowedAlignments[nRole] & ALIGNMENT_NEUTRAL)
            {
              g_Names[nChoices] = "Neutral";
              g_Descs[nChoices] = g_ppszAlignment;
              if(g_nRepeatAlignment == ALIGNMENT_NEUTRAL)
                nDefaultAlignment = nChoices;
              nChoices++;
            }
            if(g_nAllowedAlignments[nRole] & ALIGNMENT_CHAOTIC)
            {
              g_Names[nChoices] = "Chaotic";
              g_Descs[nChoices] = g_ppszAlignment;
              if(g_nRepeatAlignment == ALIGNMENT_CHAOTIC)
                nDefaultAlignment = nChoices;
              nChoices++;
            }
            if(g_nRepeatAlignment < 0)
              nDefaultAlignment = 0;
            dzzSetStatusLines("  A=Choose selected alignment    Y=Go back       L+R=Exit NetHack",
                "                            GP2X port v0.6 by dzz");
            nAlignment = dzzPopMC("Select your character's alignment:", nChoices, nDefaultAlignment,
                (const char **) g_Names, (const char ***) g_Descs);
            if(g_bExitGame)
              goto done;
            if(nAlignment < 0)
            {
              nPhaseStackEntries--;
              nPhase = nPhaseStack[nPhaseStackEntries];
              break;
            }
            if(nAlignment == 0)
            {
              int nC = (rand() % (nChoices - 1)) + 1;
              if(!strcmp(g_Names[nC], "Lawful")) nAlignment = ALIGNMENT_LAWFUL;
              else if(!strcmp(g_Names[nC], "Neutral")) nAlignment = ALIGNMENT_NEUTRAL;
              else nAlignment = ALIGNMENT_CHAOTIC;
              g_nRepeatAlignment = -1;
            }
            else
            {
              if(!strcmp(g_Names[nAlignment], "Lawful")) nAlignment = ALIGNMENT_LAWFUL;
              else if(!strcmp(g_Names[nAlignment], "Neutral")) nAlignment = ALIGNMENT_NEUTRAL;
              else nAlignment = ALIGNMENT_CHAOTIC;
              g_nRepeatAlignment = nAlignment;
            }
          }
          nPhase = PHASE_FINISHED;
          break;

        case PHASE_FINISHED:
          if(nRole == ROLE_ROGUE) // punishment for my desire to alphabetize properly
            flags.initrole = ROLE_RANGER;
          else if(nRole == ROLE_RANGER)
            flags.initrole = ROLE_ROGUE;
          else
            flags.initrole = nRole;
          switch(nRace)
          {
            case RACE_HUMAN: flags.initrace = 0; break;
            case RACE_DWARF: flags.initrace = 2; break;
            case RACE_ELF: flags.initrace = 1; break;
            case RACE_GNOME: flags.initrace = 3; break;
            case RACE_ORC: flags.initrace = 4; break;
          }
          if(nSex == SEX_MALE)
            flags.initgend = 0;
          else
            flags.initgend = 1;

          switch(nAlignment)
          {
            case ALIGNMENT_LAWFUL: flags.initalign = 0; break;
            case ALIGNMENT_NEUTRAL: flags.initalign = 1; break;
            case ALIGNMENT_CHAOTIC: flags.initalign = 2; break;
          }
          if(g_bExitGame)
            goto done;
          SaveRepeatData();
          bExitLoop = 1;
          break;
      }
    }
  }
  if(g_bExitGame)
    goto done;

  if(!bInitialized)
    newgame();

  // initialize some last-second stuff that seems to be needed
  flags.pickup_types[0] = 12;
  flags.pickup_types[1] = 0;
  flags.pickup = TRUE;

  dzzSetOptions(g_bOptionCrashRecovery, g_bOptionQWERTY, g_bOptionAutoGold, g_bOptionFastDir);

  dzzMicroSleep(200000);

  moveloop();

done:
  ShutdownUI();

//#ifdef GP2X
//#ifndef WIN32
//  chdir("/usr/gp2x");
//  execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
//#endif
//#endif

  return 0;
}
