#include <stdlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>
#include "hack.h"
#include "ui.h"

#include "func_tab.h"
extern struct ext_func_tab extcmdlist[];

int g_bTransparent = 0;
unsigned short g_usTransparentColor = 0;
unsigned short g_usBackgroundColor = 0;
unsigned short g_usCursorColor = XRGB(31,63,10);
int g_nLargeTileWidth = 32;
int g_nLargeTileHeight = 32;
int g_nMediumTileWidth = 16;
int g_nMediumTileHeight = 16;

int g_bQWERTYKeyboard = 0;
int g_bCrashRecovery = 1;
int g_bFastDirection = 0;

/* This file is part of the GP2X port, by DZZ, June 2006 */

#define PICK_NONE 0
#define PICK_ONE  1
#define PICK_ANY  2

#define FLOATTOFIXEDDOT8(x) ((long) ((256.0f * ((float) (x))) + 0.5f))
#define DOT8FIXEDTOFLOAT(x) (((float) (x)) / 256.0f)

volatile int g_bAutocenter = 1;

volatile int g_bExitGame = 0;

extern int InitTiles32();
extern void InitTiles8();

extern int checkpickup();
extern int checkup();
extern int checkdown();
extern int checkloot();
extern int checkforce();
extern int checkoffer();
extern int checkpay();
extern int checkride();
extern int checkclose();
extern int checkdrink();
extern int checkdip();
extern int checkmonability();

extern void dzzMicroSleep(int nMicros);

extern void dzzStartJoystickTimer();
extern int dzzGetJoystickTimer();

extern void dzzStartStickClickTimer();
extern int dzzGetStickClickTimer();

extern void StartUIThread();
extern void ShutdownUIThread();

extern int dzzDrawString(unsigned short *pus, int nWidth, int nXPos, int nYPos, char *pStr, unsigned short usColor);
extern int dzzStringWidth(char *pStr);

void FillScreenRect(unsigned short *pus, int nX, int nY, int nWidth, 
  int nHeight, unsigned short usColor);
void DrawScreenRect(unsigned short *pus, int nX, int nY, int nWidth, 
  int nHeight, unsigned short usColor);
void DrawScreenLine(unsigned short *pus, int nX1, int nY1, int nX2, int nY2,
    unsigned short usColor);

void ScrollTextWindow(int nID, int bDown);
void ScrollMenuWindow(int nID, int bDown);
void PageMenuWindow(int nID, int bDown);
void PageTextWindow(int nID, int bDown);
void MenuQuantity(int nID, int nIncrement);
void HandleMenuUpdate();

extern void DoMoveLoop();
extern void DoHelp();

unsigned long g_ulButtons = 0;
unsigned long g_ulJoystick = 0;
unsigned long g_bShifted = 0;
char g_cInvalidChars[100];

#define NOTDOWN    0
#define NEWDOWN    1
#define OLDDOWN    2

static int g_bADown = OLDDOWN;
static int g_bBDown = OLDDOWN;
static int g_bXDown = OLDDOWN;
static int g_bYDown = OLDDOWN;
static int g_bLeftDown = OLDDOWN;
static int g_bRightDown = OLDDOWN;
static int g_bUpDown = OLDDOWN;
static int g_bDownDown = OLDDOWN;
static int g_bULDown = OLDDOWN;
static int g_bURDown = OLDDOWN;
static int g_bDLDown = OLDDOWN;
static int g_bDRDown = OLDDOWN;
static int g_bStickDown = OLDDOWN;
static int g_bSelectDown = OLDDOWN;
static int g_bStartDown = OLDDOWN;
static int g_bLDown = OLDDOWN;
static int g_bRDown = OLDDOWN;
static int g_bVolUpDown = OLDDOWN;
static int g_bVolDownDown = OLDDOWN;

static volatile int g_bTextWindowVisible = 0;
static volatile int g_bMenuVisible = 0;
static volatile int g_nMenuID = 0;
static volatile int g_bMenuAborted = 0;

static int g_nTextWindowID = 0;


////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// SUPPORT FUNCTIONS
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

char g_szRepeatName[20];
int g_nRepeatRole;
int g_nRepeatRace;
int g_nRepeatSex;
int g_nRepeatAlignment;
int g_bOptionCrashRecovery;
int g_bOptionQWERTY;
int g_bOptionAutoGold;
int g_bOptionFastDir;
char g_szTileFile[200];

void GetRepeatData()
{
  FILE *fp;
  char line[500];

  strcpy(g_szRepeatName, "default");
  g_szTileFile[0] = 0;
  g_nRepeatRole = -1;
  g_nRepeatRace = -1;
  g_nRepeatSex = -1;
  g_nRepeatAlignment = -1;
  g_bOptionCrashRecovery = 1;
  g_bOptionQWERTY = 0;
  g_bOptionAutoGold = 1;
  g_bOptionFastDir = 0;
  fp = fopen("repeat.dat", "r");
  if(!fp)
    return;
  if(!fgets(line, 500, fp))
  {
    fclose(fp);
    return;
  }
  sscanf(line, "%s", g_szRepeatName);
  while((strlen(g_szRepeatName) > 0) && (g_szRepeatName[strlen(g_szRepeatName)-1] <= ' '))
    g_szRepeatName[strlen(g_szRepeatName)-1] = 0;
  if(!fgets(line, 500, fp))
  {
    fclose(fp);
    return;
  }
  sscanf(line, "%d %d %d %d", &g_nRepeatRole,
     &g_nRepeatRace, &g_nRepeatSex, &g_nRepeatAlignment);
  if(!fgets(line, 500, fp))
  {
    fclose(fp);
    return;
  }
  sscanf(line, "%s", g_szTileFile);
  while((strlen(g_szTileFile) > 0) && (g_szTileFile[strlen(g_szTileFile)-1] <= ' '))
    g_szTileFile[strlen(g_szTileFile)-1] = 0;
  if(!fgets(line, 500, fp))
  {
    fclose(fp);
    return;
  }
  sscanf(line, "%d %d %d %d", &g_bOptionCrashRecovery,
     &g_bOptionQWERTY, &g_bOptionAutoGold, &g_bOptionFastDir);
  g_bQWERTYKeyboard = g_bOptionQWERTY;
  if(g_bOptionCrashRecovery)
  {
    flags.ins_chkpt = TRUE;
    g_bCrashRecovery = 1;
  }
  else
  {
    flags.ins_chkpt = FALSE;
    g_bCrashRecovery = 0;
  }
  fclose(fp);
}

void SaveRepeatData()
{
  FILE *fp;
  fp = fopen("repeat.dat", "w");
  if(!fp)
    return;
  fprintf(fp, "%s\n%d %d %d %d\n%s\n", g_szRepeatName, g_nRepeatRole,
      g_nRepeatRace, g_nRepeatSex, g_nRepeatAlignment, g_szTileFile);
  fprintf(fp, "%d %d %d %d\n", g_bOptionCrashRecovery,
          g_bOptionQWERTY, g_bOptionAutoGold, g_bOptionFastDir);
  fclose(fp);
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// Keyboard text entry memory
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

typedef struct KeyboardMemoryList
{
  struct KeyboardMemoryList *pNext;
  int nWhichMemory;
  char szAnswers[10][100];
  int nAnswers;
}KeyboardMemoryList;

KeyboardMemoryList *g_pKeyboardMemory = NULL;
int g_bKeyboardMemoryLoaded = 0;

void LoadKeyboardMemory()
{
  FILE *fp;
  char line[100];
  KeyboardMemoryList *pNew;
  int bFinished = 0;

  if(g_bKeyboardMemoryLoaded)
    return;
  g_bKeyboardMemoryLoaded = 1;
  fp = fopen("keyboard.dat", "r");
  if(!fp)
    return;
  if(fgets(line, sizeof(line), fp) == NULL)
    return;
  line[strlen(line)-1] = 0;
  while(1)
  {
    pNew = (KeyboardMemoryList *) malloc(sizeof(KeyboardMemoryList));
    pNew->nWhichMemory = atoi(line);
    pNew->nAnswers = 0;
    while(1)
    {
      if(fgets(line, sizeof(line), fp) == NULL)
      {
        bFinished = 1;
        break;
      }
      line[strlen(line)-1] = 0;
      if(line[0] != ' ')
        break;
      if(pNew->nAnswers < 10)
      {
        strcpy(pNew->szAnswers[pNew->nAnswers], &line[1]);
        pNew->nAnswers++;
      }
    }
    pNew->pNext = g_pKeyboardMemory;
    g_pKeyboardMemory = pNew;
    if(bFinished)
      break;
  }
  fclose(fp);
}

void SaveKeyboardMemory()
{
  KeyboardMemoryList *pLoop;
  FILE *fp;
  int n;

  fp = fopen("keyboard.dat", "w");
  if(!fp)
    return;
  pLoop = g_pKeyboardMemory;
  while(pLoop)
  {
    fprintf(fp, "%d\n", pLoop->nWhichMemory);
    for(n = 0; n < pLoop->nAnswers; n++)
    {
      fprintf(fp, " %s\n", pLoop->szAnswers[n]);
    }
    pLoop = pLoop->pNext;
  }
  fclose(fp);
  sync();
  //sync();
  //sync();
}

int GetNextKeyboardMemory(int nWhichMemory, int nIndex, char *pszAnswer)
{
  KeyboardMemoryList *pLoop;
  LoadKeyboardMemory();
  pLoop = g_pKeyboardMemory;
  while(pLoop)
  {
    if(nWhichMemory == pLoop->nWhichMemory)
    {
      if(pLoop->nAnswers == 0)
        return -1;
      if(nIndex >= pLoop->nAnswers)
        nIndex = 0;
      strcpy(pszAnswer, pLoop->szAnswers[nIndex]);
      return nIndex + 1;
    }
    pLoop = pLoop->pNext;
  }
  return -1;
}

int DoesTextEntryHistoryExist(int nWhichMemory)
{
  KeyboardMemoryList *pLoop;
  LoadKeyboardMemory();
  pLoop = g_pKeyboardMemory;
  while(pLoop)
  {
    if(nWhichMemory == pLoop->nWhichMemory)
    {
      if(pLoop->nAnswers > 0)
        return 1;
      return 0;
    }
    pLoop = pLoop->pNext;
  }
  return 0;
}

void AddKeyboardMemory(int nWhichMemory, char *pszAnswer)
{
  KeyboardMemoryList *pLoop, *pNew;
  int n, m;

  LoadKeyboardMemory();
  pLoop = g_pKeyboardMemory;
  while(pLoop)
  {
    if(nWhichMemory == pLoop->nWhichMemory)
    {
      // see if we already have this answer.  If so, remove it from the list
      for(n = 0; n < pLoop->nAnswers; n++)
      {
        if(!strcmp(pszAnswer, pLoop->szAnswers[n]))
        {
          for(m = n; m < pLoop->nAnswers - 1; m++)
            strcpy(pLoop->szAnswers[m], pLoop->szAnswers[m+1]);
          pLoop->nAnswers--;
          break;
        }
      }
      // make room for the new entry
      for(n = pLoop->nAnswers; n > 0; n--)
      {
        if(n < 10)
        {
          strcpy(pLoop->szAnswers[n], pLoop->szAnswers[n-1]);
        }
      }
      strcpy(pLoop->szAnswers[0], pszAnswer);
      pLoop->nAnswers++;
      if(pLoop->nAnswers > 10)
        pLoop->nAnswers = 10;
      SaveKeyboardMemory();
      return;
    }
    pLoop = pLoop->pNext;
  }
  pNew = (KeyboardMemoryList *) malloc(sizeof(KeyboardMemoryList));
  pNew->nWhichMemory = nWhichMemory;
  strcpy(pNew->szAnswers[0], pszAnswer);
  pNew->nAnswers = 1;
  pNew->pNext = g_pKeyboardMemory;
  g_pKeyboardMemory = pNew;
  SaveKeyboardMemory();
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// MAPS
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

#define LARGE_MAP  1
#define MEDIUM_MAP 2
#define SMALL_MAP  3

static unsigned short g_usLargeMap[2560*768];
static unsigned short g_usMediumMap[1280*384];
static unsigned short g_usSmallMap[320*200];
static int g_nCurrentMap = MEDIUM_MAP;
// these are in a 24.8 format, in "tile" coordinates (so each tile
// has 256 logical subunits)
static int g_nTargetCenterX = 40<<8;
static int g_nTargetCenterY = 10<<8;
static int g_nCurrentCenterX = 40<<8;
static int g_nCurrentCenterY = 10<<8;

void ClearMaps()
{
  int n;
  for(n = 0; n < g_nLargeTileWidth*80*g_nLargeTileHeight*24; n++)
    g_usLargeMap[n] = g_usBackgroundColor;
  for(n = 0; n < g_nMediumTileWidth*80*g_nMediumTileHeight*24; n++)
    g_usMediumMap[n] = g_usBackgroundColor;
  for(n = 0; n < 320*200; n++)
    g_usSmallMap[n] = g_usBackgroundColor;
}

void ClearWindow(int nID)
{
  if(nID == 3)
  {
    ClearMaps();
    g_bAutocenter = 1;
  }
}

void CenterMaps()
{
  g_nTargetCenterX = 40<<8;
  g_nTargetCenterY = 10<<8;
  g_nCurrentCenterX = 40<<8;
  g_nCurrentCenterY = 10<<8;
}

void InitMaps()
{
  g_nCurrentMap = MEDIUM_MAP;
  ClearMaps();
  CenterMaps();
}

void SetMapCenter(int nX, int nY) // that's in tiles
{
  g_nTargetCenterX = (nX<<8) + 128;
  g_nTargetCenterY = (nY<<8) + 128;
  if(g_bAutocenter)
  {
    g_nCurrentCenterX = g_nTargetCenterX;
    g_nCurrentCenterY = g_nTargetCenterY;
    g_bAutocenter = 0;
  }
}

int g_bTrackingCursor = 0;
int g_bHaveCursorBackup = 0;
int g_nCursorX = 0;
int g_nCursorY = 0;
unsigned short g_usLargeCursorBackup[32*32];
unsigned short g_usMediumCursorBackup[16*16];
unsigned short g_usSmallCursorBackup[8*4];

void StopTrackingCursor()
{
  g_bTrackingCursor = 0;
}

void DrawCursorLine(unsigned short *pus, int nLen, int nStride)
{
  while(nLen > 0)
  {
    *pus = g_usCursorColor;
    pus += nStride;
    nLen--;
  }
}

void DrawCursor(int nX, int nY)
{
  DrawCursorLine(&g_usLargeMap[(nY*g_nLargeTileHeight)*(g_nLargeTileWidth*80)+nX*g_nLargeTileWidth],
        g_nLargeTileWidth, 1);
  DrawCursorLine(&g_usLargeMap[(nY*g_nLargeTileHeight)*(g_nLargeTileWidth*80)+nX*g_nLargeTileWidth+g_nLargeTileWidth-1], g_nLargeTileHeight, g_nLargeTileWidth*80);
  DrawCursorLine(&g_usLargeMap[(nY*g_nLargeTileHeight+g_nLargeTileHeight-1)*(g_nLargeTileWidth*80)+nX*g_nLargeTileWidth], g_nLargeTileWidth, 1);
  DrawCursorLine(&g_usLargeMap[(nY*g_nLargeTileHeight)*(g_nLargeTileWidth*80)+nX*g_nLargeTileWidth], g_nLargeTileHeight, g_nLargeTileWidth*80);

  DrawCursorLine(&g_usMediumMap[(nY*g_nMediumTileHeight)*(g_nMediumTileWidth*80)+nX*g_nMediumTileWidth], g_nMediumTileWidth, 1);
  DrawCursorLine(&g_usMediumMap[(nY*g_nMediumTileHeight)*(g_nMediumTileWidth*80)+nX*g_nMediumTileWidth+g_nMediumTileWidth-1], g_nMediumTileHeight, (g_nMediumTileWidth*80));
  DrawCursorLine(&g_usMediumMap[(nY*g_nMediumTileHeight+g_nMediumTileHeight-1)*(g_nMediumTileWidth*80)+nX*g_nMediumTileWidth], g_nMediumTileWidth, 1);
  DrawCursorLine(&g_usMediumMap[(nY*g_nMediumTileHeight)*(g_nMediumTileWidth*80)+nX*g_nMediumTileWidth], g_nMediumTileHeight, (g_nMediumTileWidth*80));

  DrawCursorLine(&g_usSmallMap[(nY*8)*320+nX*4], 4, 1);
  DrawCursorLine(&g_usSmallMap[(nY*8)*320+nX*4+3], 8, 320);
  DrawCursorLine(&g_usSmallMap[(nY*8+7)*320+nX*4], 4, 1);
  DrawCursorLine(&g_usSmallMap[(nY*8)*320+nX*4], 8, 320);
}

void FetchCursorBackup(int nX, int nY)
{
  int x, y;
  for(y = 0; y < g_nMediumTileHeight; y++)
  {
    for(x = 0; x < g_nMediumTileWidth; x++)
    {
      g_usMediumCursorBackup[y*g_nMediumTileWidth+x] = g_usMediumMap[(nY*g_nMediumTileHeight+y)*(g_nMediumTileWidth*80)+nX*g_nMediumTileWidth+x];
    }
  }
  // large map
  for(y = 0; y < 32; y++)
  {
    for(x = 0; x < 32; x++)
    {
      g_usLargeCursorBackup[y*g_nLargeTileWidth+x] = g_usLargeMap[(nY*g_nLargeTileHeight+y)*(g_nLargeTileWidth*80)+nX*g_nLargeTileWidth+x];
    }
  }
  // small map
  for(y = 0; y < 8; y++)
  {
    for(x = 0; x < 4; x++)
    {
      g_usSmallCursorBackup[y*4+x] = g_usSmallMap[(nY*8+y)*320+nX*4+x];
    }
  }
}

void DrawCursorBackup(int nX, int nY)
{
  int x, y;
  for(y = 0; y < g_nMediumTileHeight; y++)
  {
    for(x = 0; x < g_nMediumTileWidth; x++)
    {
      g_usMediumMap[(nY*g_nMediumTileHeight+y)*(g_nMediumTileWidth*80)+nX*g_nMediumTileWidth+x] = g_usMediumCursorBackup[y*g_nMediumTileWidth+x];
    }
  }
  // large map
  for(y = 0; y < g_nLargeTileHeight; y++)
  {
    for(x = 0; x < g_nLargeTileWidth; x++)
    {
      g_usLargeMap[(nY*g_nLargeTileHeight+y)*(g_nLargeTileWidth*80)+nX*g_nLargeTileWidth+x] = g_usLargeCursorBackup[y*g_nLargeTileWidth+x];
    }
  }
  // small map
  for(y = 0; y < 8; y++)
  {
    for(x = 0; x < 4; x++)
    {
      g_usSmallMap[(nY*8+y)*320+nX*4+x] = g_usSmallCursorBackup[y*4+x];
    }
  }
}

void StartTrackingCursor()
{
  g_bTrackingCursor = 1;
  FetchCursorBackup(g_nCursorX, g_nCursorY);
  g_bHaveCursorBackup = 1;
  DrawCursor(g_nCursorX, g_nCursorY);
}

void SetMapCursor(int nX, int nY)
{
  if(g_bHaveCursorBackup)
  {
    DrawCursorBackup(g_nCursorX, g_nCursorY);
  }
  if(g_bTrackingCursor)
  {
    FetchCursorBackup(nX, nY);
    g_bHaveCursorBackup = 1;
    DrawCursor(nX, nY);
  }
  else
  {
    g_bHaveCursorBackup = 0;
  }
  g_nCursorX = nX;
  g_nCursorY = nY;
}

//////////////////////////////////////////////////////

int g_bTrackingDirection = 0;
char g_cTrackDirection = 27;
int g_nDirectionX;
int g_nDirectionY;
unsigned long g_ulLastDirectionJoystick;
int g_nDirectionDeltaX;
int g_nDirectionDeltaY;

void SetDirectionCursor(int nX, int nY, char cDirection)
{
  if(g_bHaveCursorBackup)
  {
    DrawCursorBackup(g_nDirectionX, g_nDirectionY);
  }
  FetchCursorBackup(nX, nY);
  g_bHaveCursorBackup = 1;
  DrawCursor(nX, nY);
  g_cTrackDirection = cDirection;
  g_nDirectionX = nX;
  g_nDirectionY = nY;
}

int IsTrackingDirection()
{
  return g_bTrackingDirection;
}

char GetTrackedDirection()
{
  return g_cTrackDirection;
}

int GetPlayerLocation(int *pnX, int *pnY)
{
  *pnX = u.ux;
  *pnY = u.uy;
}

void StartTrackingDirection()
{
  int nX, nY;
  g_bTrackingDirection = 1;
  g_bHaveCursorBackup = 0;
  g_ulLastDirectionJoystick = JOYDIR_NONE;
  g_nDirectionDeltaX = 0;
  g_nDirectionDeltaY = 0;
  GetPlayerLocation(&nX, &nY);
  SetDirectionCursor(nX, nY, 27);
  g_cTrackDirection = '.';
}

void StopTrackingDirection()
{
  g_bTrackingDirection = 0;
  if(g_bHaveCursorBackup)
    DrawCursorBackup(g_nDirectionX, g_nDirectionY);
  g_bHaveCursorBackup = 0;
}

//////////////////////////////////////////////////////

extern short glyph2tile[];
extern unsigned short g_usTiles16[];
extern unsigned short g_usTiles32[];
extern unsigned short g_usTiles8[];

void SetMapGlyph(int nX, int nY, int nGlyph, int ch, int nColor)
{
  int x, y;
  int nTile;
  int nBgTile;
  int nTileX;
  int nTileY;
  unsigned short us;

// printf("%d %d glyph %d bg %d tile %d ch (%c) color %d\n", nX, nY, nGlyph, back_to_glyph(nX, nY), glyph2tile[nGlyph], ch, nColor);

  // do the background
  nTile = glyph2tile[back_to_glyph(nX, nY)];
  nTileX = nTile % 40;
  nTileY = nTile / 40;
  for(y = 0; y < g_nMediumTileHeight; y++)
  {
    for(x = 0; x < g_nMediumTileWidth; x++)
    {
      g_usMediumMap[(nY*g_nMediumTileHeight+y)*(g_nMediumTileWidth*80)+nX*g_nMediumTileWidth+x] = 
        g_usTiles16[(nTileY*g_nMediumTileHeight+y)*(g_nMediumTileWidth*40)+nTileX*g_nMediumTileWidth+x];
    }
  }
  // large map
  for(y = 0; y < g_nLargeTileHeight; y++)
  {
    for(x = 0; x < g_nLargeTileWidth; x++)
    {
      g_usLargeMap[(nY*g_nLargeTileHeight+y)*(g_nLargeTileWidth*80)+nX*g_nLargeTileWidth+x] = 
        g_usTiles32[(nTileY*g_nLargeTileHeight+y)*(g_nLargeTileWidth*40)+nTileX*g_nLargeTileWidth+x];
    }
  }
  // small map
  for(y = 0; y < 8; y++)
  {
    for(x = 0; x < 4; x++)
    {
      g_usSmallMap[(nY*8+y)*320+nX*4+x] = 
        g_usTiles8[(nTileY*8+y)*160+nTileX*4+x];
    }
  }

  // do the foreground
  nTile = glyph2tile[nGlyph];
  nTileX = nTile % 40;
  nTileY = nTile / 40;
  for(y = 0; y < g_nMediumTileHeight; y++)
  {
    for(x = 0; x < g_nMediumTileWidth; x++)
    {
      us = g_usTiles16[(nTileY*g_nMediumTileHeight+y)*(g_nMediumTileWidth*40)+nTileX*g_nMediumTileWidth+x];
      if(!g_bTransparent || (us != g_usTransparentColor))
        g_usMediumMap[(nY*g_nMediumTileHeight+y)*(g_nMediumTileWidth*80)+nX*g_nMediumTileWidth+x] = us;
    }
  }
  // large map
  for(y = 0; y < g_nLargeTileHeight; y++)
  {
    for(x = 0; x < g_nLargeTileWidth; x++)
    {
      us = g_usTiles32[(nTileY*g_nLargeTileHeight+y)*(g_nLargeTileWidth*40)+nTileX*g_nLargeTileWidth+x];
      if(!g_bTransparent || (us != g_usTransparentColor))
        g_usLargeMap[(nY*g_nLargeTileHeight+y)*(g_nLargeTileWidth*80)+nX*g_nLargeTileWidth+x] =  us;
    }
  }
  // small map
  for(y = 0; y < 8; y++)
  {
    for(x = 0; x < 4; x++)
    {
      us = g_usTiles8[(nTileY*8+y)*160+nTileX*4+x];
      if(!g_bTransparent || (us != g_usTransparentColor))
        g_usSmallMap[(nY*8+y)*320+nX*4+x] =  us;
    }
  }
}

// the first pixel of the destination is pus

void DrawMap(unsigned short *pus, int nHeight)
{
  switch(g_nCurrentMap)
  {
    case SMALL_MAP:
      {
        int nY;
        // we copy the entire map no matter what our location is
        for(nY = 0; nY < nHeight; nY++)
          memcpy(pus + nY * 320, &g_usSmallMap[nY * 320], 320*2);
      }
      break;
    case MEDIUM_MAP:
      {
        int n, nX, nY;
        nX = (g_nCurrentCenterX * g_nMediumTileWidth) >> 8; // .8 to tiled coords
        nY = (g_nCurrentCenterY * g_nMediumTileHeight) >> 8;
        if(nX < 160) nX = 160;
        if(nY < nHeight / 2) nY = nHeight / 2;
        if(nX >= g_nMediumTileWidth*80 - 160) nX = g_nMediumTileWidth*80 - 160 - 1;
        if(nY >= 21 * g_nMediumTileHeight - nHeight / 2)
          nY = 21 * g_nMediumTileHeight - (nHeight / 2) - 1;
        nX -= 160;
        nY -= nHeight / 2;
        for(n = 0; n < nHeight; n++)
          memcpy(pus + n * 320, &g_usMediumMap[(n + nY) * (g_nMediumTileWidth*80) + nX], 320*2);
      }
      break;
    case LARGE_MAP:
      {
        int n, nX, nY;
        nX = (g_nCurrentCenterX * g_nLargeTileWidth) >> 8; // .8 to tiled coords
        nY = (g_nCurrentCenterY * g_nLargeTileHeight) >> 8;
        if(nX < 160) nX = 160;
        if(nY < nHeight / 2) nY = nHeight / 2;
        if(nX >= (g_nLargeTileWidth*80) - 160) nX = (g_nLargeTileWidth*80) - 160 - 1;
        if(nY >= 21 * g_nLargeTileHeight - nHeight / 2)
          nY = 21 * g_nLargeTileHeight - (nHeight / 2) - 1;
        nX -= 160;
        nY -= nHeight / 2;
        for(n = 0; n < nHeight; n++)
          memcpy(pus + n * 320, &g_usLargeMap[(n + nY) * (g_nLargeTileWidth*80) + nX], 320*2);
      }
      break;
  }
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// Y/N BOX
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

static int g_bYNShown = 0;
static char g_szYNQuestion[100];
static char g_chYNResult;

int dzzIsYNPopped()
{
  return g_bYNShown;
}

void dzzSetYNResult(char c)
{
  g_chYNResult = c;
}

char dzzGetYNResult()
{
  return g_chYNResult;
}

void dzzUnpopYN()
{
  g_bYNShown = 0;
}

void dzzPopYN(const char *szQuestion)
{
  strcpy(g_szYNQuestion, szQuestion);
  g_bYNShown = 1;
}

void dzzDrawYN(unsigned short *pus)
{
  int nQuestionWidth, nYesWidth, nNoWidth, nButtonWidth;
  int nTotalWidth, nLeft, nTop;

  nQuestionWidth = dzzStringWidth(g_szYNQuestion);
  nYesWidth = dzzStringWidth("A=Yes");
  nNoWidth = dzzStringWidth("X=No");
  if(nYesWidth > nNoWidth)
    nButtonWidth = nYesWidth + 16;
  else
    nButtonWidth = nNoWidth + 16;

  if(nQuestionWidth > 150)
    nTotalWidth = nQuestionWidth + 10;
  else
    nTotalWidth = 160;

  nTop = (240-50)/2;
  nLeft = (320-nTotalWidth)/2;

  FillScreenRect(pus, nLeft, nTop, nTotalWidth, 50, XRGB(31,63,31));
  DrawScreenRect(pus, nLeft, nTop, nTotalWidth, 50, XRGB(0,0,16));

  dzzDrawString(pus, 320, 160-nQuestionWidth/2, nTop + 10,
      g_szYNQuestion, XRGB(0,0,0));

  FillScreenRect(pus, nLeft+10, nTop + 30, nButtonWidth, 13, XRGB(16, 63, 16));
  DrawScreenRect(pus, nLeft+10, nTop + 30, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+10+(nButtonWidth-nNoWidth)/2, nTop+33,
      "A=Yes", XRGB(0,0,0));

  FillScreenRect(pus, nLeft+nTotalWidth-nButtonWidth-10, nTop + 30, nButtonWidth, 13, XRGB(31, 63, 0));
  DrawScreenRect(pus, nLeft+nTotalWidth-nButtonWidth-10, nTop + 30, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+nTotalWidth-10-(nButtonWidth+nNoWidth)/2, nTop+33,
      "X=No", XRGB(0,0,0));
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// R/L BOX
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

static int g_bRLShown = 0;
static char g_szRLQuestion[100];
static char g_chRLResult;

int dzzIsRLPopped()
{
  return g_bRLShown;
}

void dzzSetRLResult(char c)
{
  g_chRLResult = c;
}

char dzzGetRLResult()
{
  return g_chRLResult;
}

void dzzUnpopRL()
{
  g_bRLShown = 0;
}

void dzzPopRL(const char *szQuestion)
{
  strcpy(g_szRLQuestion, szQuestion);
  g_bRLShown = 1;
}

void dzzDrawRL(unsigned short *pus)
{
  int nQuestionWidth, nYesWidth, nNoWidth, nButtonWidth;
  int nTotalWidth, nLeft, nTop;

  nQuestionWidth = dzzStringWidth(g_szRLQuestion);
  nYesWidth = dzzStringWidth("A=Left");
  nNoWidth = dzzStringWidth("B=Right");
  if(nYesWidth > nNoWidth)
    nButtonWidth = nYesWidth + 16;
  else
    nButtonWidth = nNoWidth + 16;

  if(nQuestionWidth > 150)
    nTotalWidth = nQuestionWidth + 10;
  else
    nTotalWidth = 160;

  nTop = (240-50)/2;
  nLeft = (320-nTotalWidth)/2;

  FillScreenRect(pus, nLeft, nTop, nTotalWidth, 50, XRGB(31,63,31));
  DrawScreenRect(pus, nLeft, nTop, nTotalWidth, 50, XRGB(0,0,16));

  dzzDrawString(pus, 320, 160-nQuestionWidth/2, nTop + 10,
      g_szRLQuestion, XRGB(0,0,0));

  FillScreenRect(pus, nLeft+10, nTop + 30, nButtonWidth, 13, XRGB(16, 63, 16));
  DrawScreenRect(pus, nLeft+10, nTop + 30, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+10+(nButtonWidth-nNoWidth)/2, nTop+33,
      "A=Left", XRGB(0,0,0));

  FillScreenRect(pus, nLeft+nTotalWidth-nButtonWidth-10, nTop + 30, nButtonWidth, 13, XRGB(31, 63, 0));
  DrawScreenRect(pus, nLeft+nTotalWidth-nButtonWidth-10, nTop + 30, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+nTotalWidth-10-(nButtonWidth+nNoWidth)/2, nTop+33,
      "B=Right", XRGB(0,0,0));
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// Y/N/Q BOX
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

static int g_bYNQShown = 0;
static char g_szYNQQuestion[100];
static char g_chYNQResult;

int dzzIsYNQPopped()
{
  return g_bYNQShown;
}

void dzzSetYNQResult(char c)
{
  g_chYNQResult = c;
}

char dzzGetYNQResult()
{
  return g_chYNQResult;
}

void dzzUnpopYNQ()
{
  g_bYNQShown = 0;
}

void dzzPopYNQ(const char *szQuestion)
{
  strcpy(g_szYNQQuestion, szQuestion);
  g_bYNQShown = 1;
}

void dzzDrawYNQ(unsigned short *pus)
{
  int nQuestionWidth, nYesWidth, nNoWidth, nQuitWidth, nButtonWidth;
  int nTotalWidth, nLeft, nTop;

  nQuestionWidth = dzzStringWidth(g_szYNQQuestion);
  nYesWidth = dzzStringWidth("A=Yes");
  nNoWidth = dzzStringWidth("X=No");
  nQuitWidth = dzzStringWidth("Y=Quit");
  nButtonWidth = nNoWidth + 16;
  if(nYesWidth > nButtonWidth - 16)
    nButtonWidth = nYesWidth + 16;
  if(nQuitWidth > nButtonWidth - 16)
    nButtonWidth = nQuitWidth + 16;

  if(nQuestionWidth > 170)
    nTotalWidth = nQuestionWidth + 10;
  else
    nTotalWidth = 180;

  nTop = (240-50)/2;
  nLeft = (320-nTotalWidth)/2;

  FillScreenRect(pus, nLeft, nTop, nTotalWidth, 50, XRGB(31,63,31));
  DrawScreenRect(pus, nLeft, nTop, nTotalWidth, 50, XRGB(0,0,16));

  dzzDrawString(pus, 320, 160-nQuestionWidth/2, nTop + 10,
      g_szYNQQuestion, XRGB(0,0,0));

  FillScreenRect(pus, nLeft+10, nTop + 30, nButtonWidth, 13, XRGB(16, 63, 16));
  DrawScreenRect(pus, nLeft+10, nTop + 30, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+10+(nButtonWidth-nNoWidth)/2, nTop+33,
      "A=Yes", XRGB(0,0,0));

  FillScreenRect(pus, nLeft+nTotalWidth/2-nButtonWidth/2, nTop + 30, nButtonWidth, 13, XRGB(31, 63, 0));
  DrawScreenRect(pus, nLeft+nTotalWidth/2-nButtonWidth/2, nTop + 30, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+nTotalWidth/2-nNoWidth/2, nTop+33,
      "X=No", XRGB(0,0,0));

  FillScreenRect(pus, nLeft+nTotalWidth-nButtonWidth-10, nTop + 30, nButtonWidth, 13, XRGB(0, 63, 31));
  DrawScreenRect(pus, nLeft+nTotalWidth-nButtonWidth-10, nTop + 30, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+nTotalWidth-10-(nButtonWidth+nQuitWidth)/2, nTop+33,
      "Y=Quit", XRGB(0,0,0));
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// MCLIST
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

int g_nMCChoices;
char g_MCLabels[20][20];
char g_MCTexts[20][20][70];
int g_MCTextLines[20];
char g_MCTitle[50];
int g_nMCSelection;
int g_bMCShown = 0;
int g_nMCLines;

int dzzIsMCPopped()
{
  return g_bMCShown;
}

int dzzGetMCResult()
{
  return g_nMCSelection;
}

void dzzUnpopMC()
{
  g_bMCShown = 0;
}

int dzzPopMC(const char *pszTitle, int nSelections, int nDefault,
    const char **ppszLabels, const char ***pppszTexts)
{
  int n;

  strcpy(g_MCTitle, pszTitle);
  g_nMCChoices = nSelections;
  g_nMCLines = nSelections + 2;
  for(n = 0; n < nSelections; n++)
  {
    strcpy(g_MCLabels[n], ppszLabels[n]);
    g_MCTextLines[n] = 0;
    while(pppszTexts[n][g_MCTextLines[n]])
    {
      strcpy(g_MCTexts[n][g_MCTextLines[n]], pppszTexts[n][g_MCTextLines[n]]);
      g_MCTextLines[n]++;
    }
    if(g_MCTextLines[n]+3 > g_nMCLines)
      g_nMCLines = g_MCTextLines[n]+3;
  }
  g_nMCSelection = nDefault;

  g_bMCShown = 1;

  while(dzzIsMCPopped())
  {
    if(g_bExitGame)
      break;
    dzzMicroSleep(10000);
  }
  return dzzGetMCResult();
}

void dzzMCUp()
{
  g_nMCSelection--;
  if(g_nMCSelection < 0)
    g_nMCSelection = g_nMCChoices-1;
}

void dzzMCDown()
{
  g_nMCSelection++;
  if(g_nMCSelection >= g_nMCChoices)
    g_nMCSelection = 0;
}

void dzzMCA()
{
  dzzUnpopMC();
}

void dzzMCY()
{
  g_nMCSelection = -1;
  dzzUnpopMC();
}

void dzzDrawMC(unsigned short *pus)
{
  int nX, nY, nWidth, nHeight, nChoicesWidth, nTextWidth;
  int n, m;
  int nLen;

  nChoicesWidth = 0;
  nTextWidth = 0;

  for(n = 0; n < g_nMCChoices; n++)
  {
    nLen = dzzStringWidth(g_MCLabels[n]);
    if(nLen+10 > nChoicesWidth)
      nChoicesWidth = nLen+10;
    for(m = 0; m < g_MCTextLines[n]; m++)
    {
      nLen = dzzStringWidth(g_MCTexts[n][m]);
      if(nLen+10 > nTextWidth)
        nTextWidth = nLen + 10;
    }
  }
  nWidth = nChoicesWidth + nTextWidth + 20;
  nX = (320 - nWidth) / 2;
  nHeight = g_nMCLines * 11 + 5;
  nY = (240 - nHeight) / 2 + 5;

  FillScreenRect(pus, nX, nY, nWidth, nHeight, XRGB(31,63,31));
  DrawScreenRect(pus, nX, nY, nWidth, nHeight, XRGB(0,0,16));

  dzzDrawString(pus, 320, nX+5, nY+5, g_MCTitle, XRGB(0,0,0));

  for(n = 0; n < g_nMCChoices; n++)
  {
    if(n == g_nMCSelection)
      FillScreenRect(pus, nX+5, nY+20+(n*11), nChoicesWidth, 11, XRGB(16,63,16));
    dzzDrawString(pus, 320, nX+10, nY+21+(n*11), g_MCLabels[n], XRGB(0,0,0));
  }

  for(n = 0; n < g_MCTextLines[g_nMCSelection]; n++)
  {
    dzzDrawString(pus, 320, nX + nChoicesWidth + 15, nY+31+(n*10),
      g_MCTexts[g_nMCSelection][n], XRGB(0,0,0));
  }
  DrawScreenLine(pus, nX + nChoicesWidth + 10, nY+22, nX+nChoicesWidth+10, nY+nHeight-5,
      XRGB(0,0,0));
}


////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// OPTIONS
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

#define OPTIONPAGES   4

int g_bOptionValues[OPTIONPAGES] = { 1, 0, 1, 0 };
char *g_pszOptionStrings[OPTIONPAGES] = {
  "Crash Recovery",
  "QWERTY Keyboard",
  "Auto-Pickup Gold",
  "Fast Direction Select",
};

char *g_pszCrashRecoveryDescription[6] = {
  "If this option is selected, Nethack saves your",
  "progress and tries to recover the game after a",
  "program crash or power loss.  It makes moving",
  "between levels of the dungeon slower and writes",
  "data to the program directory more often.",
  NULL,
};

char *g_pszQWERTYDescription[4] = {
  "If this options is selected, the QWERTY keyboard",
  "order is used when entering text strings.  If it is",
  "not selected, an ABCDEF order is used instead.",
  NULL,
};

char *g_pszAutoGoldDescription[4] = {
  "If this option is selected, your character will",
  "automatically pick up gold coins when you move",
  "on top of them.",
  NULL,
};

char *g_pszFastDirDescription[6] = {
  "If this option is selected, the selection cursor is",
  "not displayed when you have to select a direction",
  "(such as when opening doors).  Instead, you just",
  "move the joystick in the desired direction to quickly",
  "choose.  It is faster but less accurate",
  NULL,
};

char **g_ppszOptionDescriptions[OPTIONPAGES] = {
  g_pszCrashRecoveryDescription,
  g_pszQWERTYDescription,
  g_pszAutoGoldDescription,
  g_pszFastDirDescription,
};

int g_nCurrentOption;
int g_bOptionsShown;

int dzzIsOptionPopped()
{
  return g_bOptionsShown;
}

void dzzUnpopOption()
{
  g_bOptionsShown = 0;
}

void dzzPopOption()
{
  // load g_bOptionValues from in-game settings?  they should be ok without doing that
  g_nCurrentOption = 0;
  g_bOptionsShown = 1;
}

void dzzApplyOptions()
{
  // apply the options to in-game settings
  if(g_bOptionValues[0]) // crash recovery
  {
    flags.ins_chkpt = TRUE;
    g_bCrashRecovery = 1;
  }
  else
  {
    flags.ins_chkpt = FALSE;
    g_bCrashRecovery = 0;
  }
  if(g_bOptionValues[1]) // QWERTY
  {
    g_bQWERTYKeyboard = 1;
  }
  else
  {
    g_bQWERTYKeyboard = 0;
  }
  if(g_bOptionValues[2]) // Auto pickup gold
  {
    flags.pickup = TRUE;
  }
  else
  {
    flags.pickup = FALSE;
  }
  if(g_bOptionValues[3]) // fast direction
  {
    g_bFastDirection = 1;
  }
  else
  {
    g_bFastDirection = 0;
  }
}

void dzzSetOptions(int bCrashRecovery, int bQWERTY, int bAutoGold, int bFastDir)
{
  if(bCrashRecovery < 0) bCrashRecovery = 1;
  if(bQWERTY < 0) bQWERTY = 0;
  if(bAutoGold < 0) bAutoGold = 1;
  if(bFastDir < 0) bFastDir = 0;
  g_bOptionValues[0] = bCrashRecovery;
  g_bOptionValues[1] = bQWERTY;
  g_bOptionValues[2] = bAutoGold;
  g_bOptionValues[3] = bFastDir;
  dzzApplyOptions();
}

void dzzOptionA()
{
  dzzApplyOptions();
  g_bOptionCrashRecovery = g_bOptionValues[0];
  g_bOptionQWERTY = g_bOptionValues[1];
  g_bOptionAutoGold = g_bOptionValues[2];
  g_bOptionFastDir = g_bOptionValues[3];
  SaveRepeatData();
  dzzUnpopOption();
}

void dzzOptionB()
{
  g_nCurrentOption++;
  if(g_nCurrentOption >= OPTIONPAGES)
    g_nCurrentOption = 0;
}

void dzzOptionSelect()
{
  if(g_bOptionValues[g_nCurrentOption])
    g_bOptionValues[g_nCurrentOption] = 0;
  else
    g_bOptionValues[g_nCurrentOption] = 1;
}

#define OPTHEIGHT  120

void dzzDrawOption(unsigned short *pus)
{
  int nQuestionWidth, nDoneWidth, nToggleWidth, nNextWidth, nButtonWidth;
  int nTotalWidth, nLeft, nTop, nLine;
  char buf[10];

  nQuestionWidth = dzzStringWidth(g_pszOptionStrings[g_nCurrentOption]);
  nDoneWidth = dzzStringWidth("A=Done");
  nToggleWidth = dzzStringWidth("SELECT=Toggle");
  nNextWidth = dzzStringWidth("B=Next");
  nButtonWidth = nToggleWidth + 16;

  nTotalWidth = 290;

  nTop = (240-OPTHEIGHT)/2;
  nLeft = (320-nTotalWidth)/2;

  FillScreenRect(pus, nLeft, nTop, nTotalWidth, OPTHEIGHT, XRGB(31,63,31));
  DrawScreenRect(pus, nLeft, nTop, nTotalWidth, OPTHEIGHT, XRGB(0,0,16));

  dzzDrawString(pus, 320, nLeft + 30, nTop + 12,
      g_pszOptionStrings[g_nCurrentOption], XRGB(0,0,0));
  dzzDrawString(pus, 320, nLeft + 31, nTop + 12,
      g_pszOptionStrings[g_nCurrentOption], XRGB(0,0,0));

  sprintf(buf, "%d of %d", g_nCurrentOption + 1, OPTIONPAGES);
  dzzDrawString(pus, 320, nLeft + nTotalWidth - 20 - dzzStringWidth(buf), nTop + 12, buf, XRGB(0,0,0));

  FillScreenRect(pus, nLeft+10, nTop + OPTHEIGHT - 20, nButtonWidth, 13, XRGB(16, 63, 16));
  DrawScreenRect(pus, nLeft+10, nTop + OPTHEIGHT - 20, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+10+(nButtonWidth-nDoneWidth)/2, nTop+OPTHEIGHT-17,
      "A=Done", XRGB(0,0,0));

  FillScreenRect(pus, nLeft+nTotalWidth/2-nButtonWidth/2, nTop + OPTHEIGHT - 20, nButtonWidth, 13, XRGB(31, 63, 0));
  DrawScreenRect(pus, nLeft+nTotalWidth/2-nButtonWidth/2, nTop + OPTHEIGHT - 20, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+nTotalWidth/2-nToggleWidth/2, nTop+OPTHEIGHT-17,
      "SELECT=Toggle", XRGB(0,0,0));

  FillScreenRect(pus, nLeft+nTotalWidth-nButtonWidth-10, nTop + OPTHEIGHT - 20, nButtonWidth, 13, XRGB(0, 63, 31));
  DrawScreenRect(pus, nLeft+nTotalWidth-nButtonWidth-10, nTop + OPTHEIGHT - 20, nButtonWidth, 13, XRGB(0, 0, 0));
  dzzDrawString(pus, 320, nLeft+nTotalWidth-10-(nButtonWidth+nNextWidth)/2, nTop+OPTHEIGHT-17,
      "B=Next", XRGB(0,0,0));

  nTop += 10;

  DrawScreenLine(pus, nLeft+12, nTop, nLeft+21, nTop, XRGB(0,0,0));
  DrawScreenLine(pus, nLeft+12, nTop, nLeft+12, nTop+9, XRGB(0,0,0));
  DrawScreenLine(pus, nLeft+12, nTop+9, nLeft+21, nTop+9, XRGB(0,0,0));
  DrawScreenLine(pus, nLeft+21, nTop, nLeft+21, nTop+9, XRGB(0,0,0));
  if(g_bOptionValues[g_nCurrentOption])
  {
    FillScreenRect(pus, nLeft+14, nTop+2, 6, 6, XRGB(0,0,0));
  }

  nTop += 20;
  nLine = 0;
  while(g_ppszOptionDescriptions[g_nCurrentOption][nLine])
  {
    dzzDrawString(pus, 320, nLeft + 30, nTop,
      g_ppszOptionDescriptions[g_nCurrentOption][nLine], XRGB(0,0,0));
    nLine++;
    nTop += 12;
  }
}


////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// TEXT STRING ENTRY
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

static volatile int g_bTextEntryShown = 0;
static char g_szTextEntryQuestion[100];
static char g_szTextEntryResult[80];
static int g_nTextEntryMaxLen;
static int g_nCurTextEntryRow = 0;
static int g_nCurTextEntryCol = 0;
static int g_nTextEntryCycle;
static int g_bTextEntryHistory;
static int g_bTextEntryCancelable;
static int g_nWhichMemory;

int dzzIsTextEntryPopped()
{
  return g_bTextEntryShown;
}

void dzzUnpopTextEntry()
{
  g_bTextEntryShown = 0;
}

void dzzPopTextEntry(int nWhichMemory, const char *szQuestion, int bCancelable, int nMaxLen, char *pszInvalid)
{
  strcpy(g_szTextEntryQuestion, szQuestion);
  g_nWhichMemory = nWhichMemory;
  g_bTextEntryCancelable = bCancelable;
  g_szTextEntryResult[0] = 0;
  g_nTextEntryCycle = 0;
  g_bTextEntryHistory = DoesTextEntryHistoryExist(nWhichMemory);
  g_nTextEntryMaxLen = nMaxLen;
  g_nCurTextEntryRow = 0;
  g_nCurTextEntryRow = 0;
  g_bTextEntryShown = 1;
  strcpy(g_cInvalidChars, pszInvalid);
}

char g_BoxCharsQWERTY[4][12] = {
  { '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '=' },
  { 'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '[', ']' },
  { 'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', '\'', '\\' },
  { 'z', 'x', 'c', 'v', 'b', 'n', 'm', ',', '.', '/', ' ', '`' },
};

char g_BoxCharsShiftQWERTY[4][12] = {
  { '!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '_', '+' },
  { 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', '{', '}' },
  { 'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', ':', '"', '|' },
  { 'Z', 'X', 'C', 'V', 'B', 'N', 'M', '<', '>', '?', ' ', '~' },
};

char g_BoxCharsABCDEF[4][12] = {
  { '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '=' },
  { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', '[', ']' },
  { 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', ';', '\'', '\\' },
  { 't', 'u', 'v', 'w', 'x', 'y', 'z', ',', '.', '/', ' ', '`' },
};

char g_BoxCharsShiftABCDEF[4][12] = {
  { '!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '_', '+' },
  { 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', '{', '}' },
  { 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', ':', '"', '|' },
  { 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '<', '>', '?', ' ', '~' },
};

void dzzDrawTextEntry(unsigned short *pus, unsigned long ulButtons)
{
  int nX, nY, nWidth, nHeight;
  int n, nW, nTW, nRow, nCol;
  char sz[30];
  char szQuestion[200];
  char szQuestion2[100];
  int bTwoLines = 0;
  int nExtra = 0;
  int nExtra2 = 0;

  strcpy(szQuestion, g_szTextEntryQuestion);
  nTW = dzzStringWidth(szQuestion);
  n = strlen(szQuestion);
  while(nTW >= 184)
  {
    while(szQuestion[n] != ' ')
      n--;
    szQuestion[n] = 0;
    nTW = dzzStringWidth(szQuestion);
    if(nTW < 184)
    {
      strcpy(szQuestion2, &szQuestion[n+1]);
      bTwoLines = 1;
      nExtra = 11;
      break;
    }
    szQuestion[n] = ' ';
    n--;
  }
  if(g_bTextEntryHistory)
    nExtra2 = 11;

  nWidth = 190;
  nHeight = 110 + nExtra + nExtra2;
  nX = (320-nWidth)/2;
  nY = (240-nHeight)/2;

  if(ulButtons & GP2X_L)
    g_bShifted = 1;
  else
    g_bShifted = 0;

  FillScreenRect(pus, nX, nY, nWidth, nHeight, XRGB(31,63,31));
  DrawScreenRect(pus, nX, nY, nWidth, nHeight, XRGB(0,0,16));

  nTW = dzzStringWidth(szQuestion);
  dzzDrawString(pus, 320, 160-nTW/2, nY + 4,
      szQuestion, XRGB(0,0,0));
  if(bTwoLines)
  {
    nTW = dzzStringWidth(szQuestion2);
    dzzDrawString(pus, 320, 160-nTW/2, nY + 4 + nExtra,
        szQuestion2, XRGB(0,0,0));
  }
  if(g_szTextEntryResult[0])
  {
    nTW = dzzStringWidth(g_szTextEntryResult);
    dzzDrawString(pus, 320, 160-nTW/2, nY + 16 + nExtra,
        g_szTextEntryResult, XRGB(0,0,0));
  }
  // the text boxes
  for(nRow = 0; nRow < 4; nRow++)
  {
    for(nCol = 0; nCol < 12; nCol++)
    {
      if((nRow == g_nCurTextEntryRow) && (nCol == g_nCurTextEntryCol))
        FillScreenRect(pus, nX+10+(nCol*14), nY+27+nRow*11+nExtra, 14, 11, XRGB(0,63,0));
      else
        FillScreenRect(pus, nX+10+(nCol*14), nY+27+nRow*11+nExtra, 14, 11, XRGB(31,63,0));
      DrawScreenRect(pus, nX+10+(nCol*14), nY+27+nRow*11+nExtra, 14, 11, XRGB(0,0,0));
      if(g_bShifted)
        sz[0] = g_bQWERTYKeyboard ? g_BoxCharsShiftQWERTY[nRow][nCol] : g_BoxCharsShiftABCDEF[nRow][nCol];
      else
        sz[0] = g_bQWERTYKeyboard ? g_BoxCharsQWERTY[nRow][nCol] : g_BoxCharsABCDEF[nRow][nCol];
      sz[1] = 0;
      if(sz[0] == ' ')
      {
        strcpy(sz, "sp");
        nW = dzzStringWidth(sz);
        if(!strchr(g_cInvalidChars, ' '))
          dzzDrawString(pus, 320, nX+17+(nCol*14)-nW/2, nY+29+nRow*11+nExtra, sz, XRGB(0,0,0));
      }
      else
      {
        nW = dzzStringWidth(sz);
        if(!strchr(g_cInvalidChars, sz[0]))
          dzzDrawString(pus, 320, nX+17+(nCol*14)-nW/2, nY+29+nRow*11+nExtra, sz, XRGB(0,0,0));
      }
    }
  }
  if(g_bTextEntryHistory)
  {
    dzzDrawString(pus, 320, nX+10, nY+76+nExtra, "Vol+ = cycle recent answers", XRGB(0,0,0));
  }
  if(g_bTextEntryCancelable)
  {
    sprintf(sz, "Y = clear        SELECT = cancel");
  }
  else
  {
    sprintf(sz, "Y = clear");
  }
  dzzDrawString(pus, 320, nX+10, nY+76+nExtra+nExtra2, sz, XRGB(0,0,0));
  dzzDrawString(pus, 320, nX+10, nY+87+nExtra+nExtra2, "START = done", XRGB(0,0,0));
  dzzDrawString(pus, 320, nX+10, nY+99+nExtra+nExtra2, "B = letter", XRGB(0,0,0));
  dzzDrawString(pus, 320, nX+110, nY+87+nExtra+nExtra2, "X = erase", XRGB(0,0,0));
  dzzDrawString(pus, 320, nX+110, nY+99+nExtra+nExtra2, "L = shift", XRGB(0,0,0));
}

void dzzInputStringL()
{
  g_nCurTextEntryCol--;
  if(g_nCurTextEntryCol < 0)
  {
    g_nCurTextEntryCol = 11;
  }
}

void dzzInputStringR()
{
  g_nCurTextEntryCol++;
  if(g_nCurTextEntryCol >= 12)
    g_nCurTextEntryCol = 0;
}

void dzzInputStringU()
{
  g_nCurTextEntryRow--;
  if(g_nCurTextEntryRow < 0)
  {
    g_nCurTextEntryRow = 3;
  }
}


void dzzInputStringD()
{
  g_nCurTextEntryRow++;
  if(g_nCurTextEntryRow >= 4)
    g_nCurTextEntryRow = 0;
}


void dzzInputStringX()
{
  int nLen;
  nLen = strlen(g_szTextEntryResult);
  if(nLen != 0)
    g_szTextEntryResult[nLen-1] = 0;
}

void dzzInputStringSelect()
{
  if(g_bTextEntryCancelable)
  {
    strcpy(g_szTextEntryResult, "");
    dzzUnpopTextEntry();
  }
}

void dzzInputStringB(int bShifted)
{
  int nLen;
  char c;
  nLen = strlen(g_szTextEntryResult);
  if(nLen != g_nTextEntryMaxLen)
  {
    if(bShifted)
      c = g_bQWERTYKeyboard ? g_BoxCharsShiftQWERTY[g_nCurTextEntryRow][g_nCurTextEntryCol] :
        g_BoxCharsShiftABCDEF[g_nCurTextEntryRow][g_nCurTextEntryCol];
    else
      c = g_bQWERTYKeyboard ? g_BoxCharsQWERTY[g_nCurTextEntryRow][g_nCurTextEntryCol] :
        g_BoxCharsABCDEF[g_nCurTextEntryRow][g_nCurTextEntryCol];
    if(!strchr(g_cInvalidChars, c))
    {
      g_szTextEntryResult[nLen] = c;
      g_szTextEntryResult[nLen+1] = 0;
    }
  }
}

void dzzInputStringStart()
{
  if(strlen(g_szTextEntryResult) == 0)
  {
    if(!g_bTextEntryCancelable)
      return;
  }
  else
  {
    AddKeyboardMemory(g_nWhichMemory, g_szTextEntryResult);
  }
  dzzUnpopTextEntry();
}

void dzzInputStringY()
{
  g_szTextEntryResult[0] = 0;
}

void dzzInputStringCycle()
{
  if(!g_bTextEntryHistory)
    return;
  g_nTextEntryCycle = GetNextKeyboardMemory(g_nWhichMemory, g_nTextEntryCycle, g_szTextEntryResult);
}

void dzzGetInputString(int nWhichMemory, const char *pszQuestion, char *pszBuf, int nMaxLen, int bCancelable, char *pszInvalid)
{
  dzzPopTextEntry(nWhichMemory, pszQuestion, bCancelable, nMaxLen, pszInvalid);
  while(dzzIsTextEntryPopped())
  {
    if(g_bExitGame)
    {
      dzzUnpopTextEntry();
      break;
    }
    dzzMicroSleep(10000);
  }
  strcpy(pszBuf, g_szTextEntryResult);
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// MENUS
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

#define MAX_ITEMS  16

typedef struct dzzMenuItem
{
  char *pszText;
  int nID;
  struct dzzMenu *pSubmenu;
} dzzMenuItem;

typedef struct dzzMenu
{
  int bPopped;
  int nX;
  int nY;
  int nCurItem;
  int nMenuItems;
  dzzMenuItem Items[MAX_ITEMS];
} dzzMenu;

#define IDM_INVENTORY   100
#define IDM_HELP        101
#define IDM_SAVEQUIT    102
#define IDM_QUIT        103
#define IDM_LISTSPELLS  104
#define IDM_LISTOBJECTS 105
#define IDM_LISTSKILLS  106
#define IDM_ATTRIBUTES  107
#define IDM_WIELD       108
#define IDM_WEARRING    109
#define IDM_TAKEOFFRING 110
#define IDM_WEARARMOR   111
#define IDM_REMOVEARMOR 112
#define IDM_NOARMOR     113
#define IDM_SIT         114
#define IDM_JUMP        115
#define IDM_WIPEFACE    116
#define IDM_TELEPORT    117
#define IDM_LOOK        118
#define IDM_FARLOOK     119
#define IDM_OPEN        120
#define IDM_KICK        121
#define IDM_SEARCH      122
#define IDM_REST        123
#define IDM_DROP        124
#define IDM_EAT         125
#define IDM_QUAFF       126
#define IDM_READ        127
#define IDM_APPLY       128
#define IDM_INVOKE      129
#define IDM_RUB         130
#define IDM_FIRE        131
#define IDM_ZAP         132
#define IDM_CAST        133
#define IDM_FIGHT       134
#define IDM_AMMUNITION  135
#define IDM_TWOHANDED   136
#define IDM_EXCHANGE    137
#define IDM_THROW       138
#define IDM_UP          139
#define IDM_DOWN        140
#define IDM_LOOT        141
#define IDM_FORCE       142
#define IDM_OFFER       143
#define IDM_PRAY        144
#define IDM_DIP         145
#define IDM_PAY         146
#define IDM_RIDE        147
#define IDM_STOPRIDE    148
#define IDM_UNTRAP      149
#define IDM_TURN        150
#define IDM_CLOSE       151
#define IDM_PICKUP      152
#define IDM_NAME        153
#define IDM_ENGRAVE     154
#define IDM_MOVE        155
#define IDM_CHAT        156
#define IDM_MONSTER     157
#define IDM_CALL        158
#define IDM_OPTIONS     159

#define IDM_WIZ_WISH         170
#define IDM_WIZ_IDENTIFY     171
#define IDM_WIZ_MAP          172
#define IDM_WIZ_GENESIS      173
#define IDM_WIZ_WHERE        174
#define IDM_WIZ_POLYSELF     175
#define IDM_WIZ_LEVEL_TELE   176
#define IDM_WIZ_LEVEL_CHANGE 177

#define IDM_TILES       200

dzzMenu WearMenu = {
  0, 0, 0, 0,
  7,
  { { "Wear Armor", IDM_WEARARMOR, NULL },
    { "Remove Armor", IDM_REMOVEARMOR, NULL },
    { "Wield", IDM_WIELD, NULL },
    { "Wear Accessory", IDM_WEARRING, NULL },
    { "Remove Accessory", IDM_TAKEOFFRING, NULL },
    { "Quiver", IDM_AMMUNITION, NULL },
    { "Remove All Armor", IDM_NOARMOR, NULL },
  }
};

dzzMenu DoMenu = {
  0, 0, 0, 0,
  11,
  { { "Sit Down", IDM_SIT, NULL },
    { "Jump", IDM_JUMP, NULL },
    { "Pray", IDM_PRAY, NULL },
    { "Wipe Face", IDM_WIPEFACE, NULL },
    { "Teleport", IDM_TELEPORT, NULL },
    { "Look (X)", IDM_LOOK, NULL },
    { "Far Look (L+X)", IDM_FARLOOK, NULL },
    { "Open (Y)", IDM_OPEN, NULL },
    { "Kick (L+Y)", IDM_KICK, NULL },
    { "Search (STICK)", IDM_SEARCH, NULL },
    { "Rest (L+STICK)", IDM_REST, NULL },
  }
};

dzzMenu UseMenu = {
  0, 0, 0, 0,
  7,
  { { "Eat", IDM_EAT, NULL },
    { "Drop", IDM_DROP, NULL },
    { "Quaff", IDM_QUAFF, NULL },
    { "Read", IDM_READ, NULL },
    { "Apply", IDM_APPLY, NULL },
    { "Invoke", IDM_INVOKE, NULL },
    { "Rub", IDM_RUB, NULL },
  }
};

dzzMenu ActionMenu = {
  0, 0, 0, 0,
  10,
  { { "Fire Weapon (L+R)", IDM_FIRE, NULL },
    { "Zap Wand (L+B)", IDM_ZAP, NULL },
    { "Cast Spell (L+A)", IDM_CAST, NULL },
    { "Throw", IDM_THROW, NULL },
    { "Fight", IDM_FIGHT, NULL },
    { "Loot", IDM_LOOT, NULL },
    { "Ride", IDM_RIDE, NULL },
    { "Untrap", IDM_UNTRAP, NULL },
    { "Dip", IDM_DIP, NULL },
    { "Turn Undead", IDM_TURN, NULL },
  }
};

dzzMenu AdvancedMenu = {
  0, 0, 0, 0,
  7,
  {
    { "Move", IDM_MOVE, NULL },
    { "Engrave", IDM_ENGRAVE, NULL },
    { "Name Object", IDM_NAME, NULL },
    { "Name Monster", IDM_CALL, NULL },
    { "Chat", IDM_CHAT, NULL },
    { "Two Handed", IDM_TWOHANDED, NULL },
    { "Exchange Weapon", IDM_EXCHANGE, NULL },
  }
};


// this will have context-specific entries prepended
dzzMenu ActivitiesMenu = {
  0, 0, 0, 0,
  5,
  { { "Wear/Wield", 0, &WearMenu },
    { "Do", 0, &DoMenu },
    { "Advanced", 0, &AdvancedMenu },
    { "Use (B)", 0, &UseMenu },
    { "Action (A)", 0, &ActionMenu },
  }
};

dzzMenu ExpandedActivitiesMenu = {
  0, 0, 0, 0,
  0,
  { { "", 0, NULL } }
};

static char *g_pDownText = "Down";
static char *g_pUpText = "Up";
static char *g_pLootText = "Loot";
static char *g_pForceText = "Force";
static char *g_pOfferText = "Offer";
static char *g_pPayText = "Pay";
static char *g_pRideText = "Ride";
static char *g_pStopRideText = "Dismount";
static char *g_pCloseText = "Close";
static char *g_pPickUpText = "Pick Up";
static char *g_pDrinkText = "Drink";
static char *g_pDipText = "Dip";
static char *g_pMonsterText = "Monster";

void BuildExpandedActivitiesMenu()
{
  int n;

  ExpandedActivitiesMenu.nCurItem = 0;
  ExpandedActivitiesMenu.nMenuItems = 0;

  if(checkpickup())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pPickUpText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_PICKUP;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkdown())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pDownText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_DOWN;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkup())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pUpText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_UP;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkmonability())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pMonsterText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_MONSTER;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkdrink())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pDrinkText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_QUAFF;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkdip())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pDipText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_DIP;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkloot())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pLootText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_LOOT;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkforce())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pForceText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_FORCE;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkoffer())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pOfferText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_OFFER;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkpay())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pPayText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_PAY;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  if(checkclose())
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pCloseText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_CLOSE;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  
  /* this ended up kind of ridiculous 
  n = checkride();
  if(n == 1)
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pRideText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_RIDE;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  else if(n == 2)
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      g_pStopRideText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      IDM_STOPRIDE;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      NULL;
    ExpandedActivitiesMenu.nMenuItems++;
  }
  */
  for(n = 0; n < ActivitiesMenu.nMenuItems; n++)
  {
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pszText =
      ActivitiesMenu.Items[n].pszText;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].nID =
      ActivitiesMenu.Items[n].nID;
    ExpandedActivitiesMenu.Items[ExpandedActivitiesMenu.nMenuItems].pSubmenu =
      ActivitiesMenu.Items[n].pSubmenu;
    ExpandedActivitiesMenu.nMenuItems++;
  }
}

dzzMenu InfoMenu = {
  0, 0, 0, 0,
  4,
  { { "List Spells", IDM_LISTSPELLS, NULL },
    { "List Objects", IDM_LISTOBJECTS, NULL },
    { "List/Enhance Skills", IDM_LISTSKILLS, NULL },
    { "Attributes", IDM_ATTRIBUTES, NULL },
  }
};

dzzMenu TilesMenu = {
  0, 0, 0, 0, 
  10,
  { { "Default", IDM_TILES, NULL },
    { "XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, NULL },
    { "XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, NULL },
    { "XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, NULL },
    { "XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, NULL },
    { "XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, NULL },
    { "XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, NULL },
    { "XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, NULL },
    { "XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, NULL },
    { "XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, NULL },
  }
};

dzzMenu WizardMenu = {
  0, 0, 0, 0,
  8,
  { { "Wish", IDM_WIZ_WISH, NULL },
    { "Identify", IDM_WIZ_IDENTIFY, NULL },
    { "Map", IDM_WIZ_MAP, NULL },
    { "Genesis", IDM_WIZ_GENESIS, NULL },
    { "Where", IDM_WIZ_WHERE, NULL },
    { "Polyself", IDM_WIZ_POLYSELF, NULL },
    { "Level Teleport", IDM_WIZ_LEVEL_TELE, NULL },
    { "Level Change", IDM_WIZ_LEVEL_CHANGE, NULL },
  }
};

dzzMenu AppMenu = {
  0, 0, 0, 0,
  8,
  { { "Inventory", IDM_INVENTORY, NULL },
    { "Help", IDM_HELP, NULL },
    { "Save & Quit", IDM_SAVEQUIT, NULL },
    { "Quit (No Save)", IDM_QUIT, NULL },
    { "Activities (SELECT)", 0, &ExpandedActivitiesMenu },
    { "Info", 0, &InfoMenu },
    { "Options", IDM_OPTIONS, NULL },
    { "Load Tiles", 0, &TilesMenu },
    { "Wizard", 0, &WizardMenu }
  }
};

void InitTilesMenu()
{
  int nIndex = 1;
  struct dirent *dp;
  DIR *dirp;
  char *pstr;

  dirp = opendir(".");
  while(dp = readdir(dirp))
  {
    // process dp->d_name
    pstr = strrchr(dp->d_name, '.');
    if(pstr)
    {
      if(!strcmpi(pstr, ".png") && strcmpi(dp->d_name, "nethack.png"))
      {
        TilesMenu.Items[nIndex].pszText = (char *) malloc(strlen(dp->d_name)+1);
        strcpy(TilesMenu.Items[nIndex].pszText, dp->d_name);
        pstr = strrchr(TilesMenu.Items[nIndex].pszText, '.');
        if(pstr)
          *pstr = 0;
        TilesMenu.Items[nIndex].nID = IDM_TILES + nIndex;
        nIndex++;
        if(nIndex == 10)
          break;
      }
    }
  }
  closedir(dirp);
  TilesMenu.nMenuItems = nIndex;
}

dzzMenu *g_pCurrentMenu = NULL;
int g_nMenuSelection;

// call this if the cancel button is pushed; it kills one level of menus
void dzzUnpopMenu(dzzMenu *pMenu)
{
  int n;
  if(!pMenu->bPopped)
    return;
  for(n = 0; n < pMenu->nMenuItems; n++)
  {
    if(pMenu->Items[n].pSubmenu && pMenu->Items[n].pSubmenu->bPopped)
    {
      dzzUnpopMenu(pMenu->Items[n].pSubmenu);
      return;
    }
  }
  pMenu->bPopped = 0;
  if(pMenu == g_pCurrentMenu)
    g_pCurrentMenu = NULL;
}

int dzzIsMenuPopped()
{
  if(g_pCurrentMenu)
    return 1;
  return 0;
}

// this gets the root level popping started
void dzzPopMenu(dzzMenu *pMenu)
{
  int n;
  while(dzzIsMenuPopped())
  {
    dzzUnpopMenu(g_pCurrentMenu);
  }
  BuildExpandedActivitiesMenu();
  g_pCurrentMenu = pMenu;
  pMenu->bPopped = 1;
  pMenu->nX = 10;
  pMenu->nY = 40;
  pMenu->nCurItem = 0;
  for(n = 0; n < pMenu->nMenuItems; n++)
  {
    if(pMenu->Items[n].pSubmenu)
      pMenu->Items[n].pSubmenu->bPopped = 0;
  }
  g_nMenuSelection = -1;
}

int dzzGetMenuWidth(dzzMenu *pMenu)
{
  int n, nWidth, nItemWidth;
  nWidth = 0;
  for(n = 0; n < pMenu->nMenuItems; n++)
  {
    nItemWidth = dzzStringWidth(pMenu->Items[n].pszText) + 24;
    if(nItemWidth > nWidth)
      nWidth = nItemWidth;
  }
  return nWidth;
}

void dzzDrawMenu(unsigned short *pus, dzzMenu *pMenu)
{
  int n, nWidth;
  // compute the width
  nWidth = dzzGetMenuWidth(pMenu);
  DrawScreenLine(pus, pMenu->nX-1, pMenu->nY-1, pMenu->nX+nWidth, pMenu->nY-1,
    XRGB(0,40,0));
  DrawScreenLine(pus, pMenu->nX+nWidth, pMenu->nY-1, pMenu->nX+nWidth,
      pMenu->nY+pMenu->nMenuItems*11, XRGB(0,40,0));
  DrawScreenLine(pus, pMenu->nX-1, pMenu->nY+pMenu->nMenuItems*11, 
      pMenu->nX+nWidth, pMenu->nY+pMenu->nMenuItems*11, XRGB(0,40,0));
  DrawScreenLine(pus, pMenu->nX-1, pMenu->nY-1, 
      pMenu->nX-1, pMenu->nY+pMenu->nMenuItems*11, XRGB(0,40,0));
  FillScreenRect(pus, pMenu->nX, pMenu->nY, nWidth, pMenu->nMenuItems * 11,
      XRGB(31,63,31));
  for(n = 0; n < pMenu->nMenuItems; n++)
  {
    if(pMenu->nCurItem == n)
    {
      // draw highlight rect
      FillScreenRect(pus, pMenu->nX, pMenu->nY + 11 * n, 
          nWidth, 11, XRGB(16,63,16));
    }
    dzzDrawString(pus, 320, pMenu->nX + 4, pMenu->nY + 1 + 11 * n, 
        pMenu->Items[n].pszText, XRGB(0,0,0));
    if(pMenu->Items[n].pSubmenu)
    {
      // draw "arrow"
      FillScreenRect(pus, pMenu->nX+nWidth-8, pMenu->nY + 11 * n + 3, 
          5, 5, XRGB(0,16,0));
    }
    if(pMenu->Items[n].pSubmenu && pMenu->Items[n].pSubmenu->bPopped)
      dzzDrawMenu(pus, pMenu->Items[n].pSubmenu);
  }
}

void dzzDrawMenus(unsigned short *pus)
{
  if(g_pCurrentMenu)
    dzzDrawMenu(pus, g_pCurrentMenu);
}

dzzMenu *FindLowestMenu(dzzMenu *pMenu)
{
  int n;
  if(!pMenu)
    return NULL;
  for(n = 0; n < pMenu->nMenuItems; n++)
  {
    if(pMenu->Items[n].pSubmenu && pMenu->Items[n].pSubmenu->bPopped)
      return FindLowestMenu(pMenu->Items[n].pSubmenu);
  }
  return pMenu;
}

void dzzMenuUp()
{
  dzzMenu *pMenu;
  pMenu = FindLowestMenu(g_pCurrentMenu);
  if(!pMenu)
    return;
  pMenu->nCurItem--;
  if(pMenu->nCurItem < 0)
    pMenu->nCurItem = pMenu->nMenuItems - 1;
}

void dzzMenuDown()
{
  dzzMenu *pMenu;
  pMenu = FindLowestMenu(g_pCurrentMenu);
  if(!pMenu)
    return;
  pMenu->nCurItem++;
  if(pMenu->nCurItem >= pMenu->nMenuItems)
    pMenu->nCurItem = 0;
}

void dzzMenuX()
{
  if(g_pCurrentMenu)
    dzzUnpopMenu(g_pCurrentMenu);
}

void dzzMenuLeft()
{
  if(g_pCurrentMenu)
    dzzUnpopMenu(g_pCurrentMenu);
}

void dzzMenuStickOrA()
{
  dzzMenu *pMenu;
  pMenu = FindLowestMenu(g_pCurrentMenu);
  if(!pMenu)
    return;
  if(pMenu->Items[pMenu->nCurItem].pSubmenu)
  {
    int n, nWidth, nHeight;
    if(pMenu->Items[pMenu->nCurItem].pSubmenu == &ExpandedActivitiesMenu)
      BuildExpandedActivitiesMenu();
    nWidth = dzzGetMenuWidth(pMenu);
    pMenu->Items[pMenu->nCurItem].pSubmenu->bPopped = 1;
    pMenu->Items[pMenu->nCurItem].pSubmenu->nX = pMenu->nX + nWidth + 1;
    pMenu->Items[pMenu->nCurItem].pSubmenu->nY = pMenu->nY + pMenu->nCurItem * 11;
    nHeight = pMenu->Items[pMenu->nCurItem].pSubmenu->nMenuItems * 11 + 2;
    if(pMenu->Items[pMenu->nCurItem].pSubmenu->nY + nHeight >= 240)
      pMenu->Items[pMenu->nCurItem].pSubmenu->nY = 239 - nHeight;
    pMenu->Items[pMenu->nCurItem].pSubmenu->nCurItem = 0;
    for(n = 0; n < pMenu->Items[pMenu->nCurItem].pSubmenu->nMenuItems; n++)
    {
      if(pMenu->Items[pMenu->nCurItem].pSubmenu->Items[n].pSubmenu)
        pMenu->Items[pMenu->nCurItem].pSubmenu->Items[n].pSubmenu->bPopped = 0;
    }
  }
  else
  {
    // this is a real menu selection
    g_nMenuSelection = pMenu->Items[pMenu->nCurItem].nID;
    while(dzzIsMenuPopped())
    {
      dzzUnpopMenu(g_pCurrentMenu);
    }
  }
}

void dzzMenuRight()
{
  dzzMenu *pMenu;
  pMenu = FindLowestMenu(g_pCurrentMenu);
  if(!pMenu)
    return;
  if(pMenu->Items[pMenu->nCurItem].pSubmenu)
    dzzMenuStickOrA();
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// INPUT QUEUE
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

#define MAX_INPUT_CHARS 10
static volatile int g_nInputChars = 0;
static volatile int g_InputChars[MAX_INPUT_CHARS];
static volatile int g_nExtCommand = -1;

int GetInputChar()
{
  int nRet;
  int n;
  if(g_nInputChars > 0)
  {
    nRet = g_InputChars[0];
    for(n = 0; n < g_nInputChars; n++)
      g_InputChars[n] = g_InputChars[n+1];
    g_nInputChars--;
// printf("Returning (%c)\n", nRet);
    return nRet;
  }
  return 0;
}

void SetInputChar(int ch)
{
  g_InputChars[0] = ch;
  g_nInputChars = 1;
}

void SetInputString(char *pStr)
{
  int n = 0;
  while(*pStr)
  {
    g_InputChars[n] = *pStr;
    pStr++;
    n++;
  }
  g_nInputChars = n;
}

void SetExtCommand(int nCmd)
{
  g_nExtCommand = nCmd;
}

int GetExtCommand()
{
  int n;
  n = g_nExtCommand;
  g_nExtCommand = -1;
  return n;
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// UI THREAD INTERFACE
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

static unsigned long g_ulLastJoystick = -1;
static int g_nNextJoystickRepeatTime;

static int g_nNextStickClickRepeatTime;

#define R1TIME  4000
#define R2TIME  1000

int ExtCommandIndex(char *pszCmd)
{
  int n;
  for(n = 0; extcmdlist[n].ef_txt && (extcmdlist[n].ef_txt[0] != '?'); n++)
  {
    if(!strcmp(extcmdlist[n].ef_txt, pszCmd))
    {
      return n;
    }
  }
  return 3;
}

void UpdateGame(unsigned long ulButtons, unsigned long ulJoystick)
{
  int nTime;
  int nXDiff, nYDiff;

  if((ulButtons & GP2X_L) && (ulButtons & GP2X_R))
  {
    g_bExitGame = 1;
  }

  // scroll the screen
  nXDiff = g_nTargetCenterX - g_nCurrentCenterX;
  nYDiff = g_nTargetCenterY - g_nCurrentCenterY;
  if(nXDiff || nYDiff)
  {
    float fXDiff, fYDiff, fDist;
    fXDiff = DOT8FIXEDTOFLOAT(nXDiff);
    fYDiff = DOT8FIXEDTOFLOAT(nYDiff);
    fDist = (float) sqrt(fXDiff*fXDiff + fYDiff*fYDiff);
    if(g_nCurrentMap == LARGE_MAP)
    {
      if(fDist >= 1.0f * 32.0f / ((float) g_nLargeTileHeight))
      {
        g_nCurrentCenterX += FLOATTOFIXEDDOT8(fXDiff * 0.12f);
        g_nCurrentCenterY += FLOATTOFIXEDDOT8(fYDiff * 0.12f);
      }
    }
    else
    {
      if(fDist >= 2.0f * 16.0f / ((float) g_nMediumTileHeight))
      {
        g_nCurrentCenterX += FLOATTOFIXEDDOT8(fXDiff * 0.06f);
        g_nCurrentCenterY += FLOATTOFIXEDDOT8(fYDiff * 0.06f);
      }
    }
  }
  g_ulButtons = ulButtons;
  g_ulJoystick = ulJoystick;

  if(!(ulButtons & GP2X_A))
    g_bADown = NOTDOWN;
  else if(g_bADown == NOTDOWN)
    g_bADown = NEWDOWN;

  if(!(ulButtons & GP2X_B))
    g_bBDown = NOTDOWN;
  else if(g_bBDown == NOTDOWN)
    g_bBDown = NEWDOWN;

  if(!(ulButtons & GP2X_X))
    g_bXDown = NOTDOWN;
  else if(g_bXDown == NOTDOWN)
    g_bXDown = NEWDOWN;

  if(!(ulButtons & GP2X_Y))
    g_bYDown = NOTDOWN;
  else if(g_bYDown == NOTDOWN)
    g_bYDown = NEWDOWN;

  if(!(ulButtons & GP2X_SELECT))
    g_bSelectDown = NOTDOWN;
  else if(g_bSelectDown == NOTDOWN)
    g_bSelectDown = NEWDOWN;

  if(!(ulButtons & GP2X_VOL_UP))
    g_bVolUpDown = NOTDOWN;
  else if(g_bVolUpDown == NOTDOWN)
    g_bVolUpDown = NEWDOWN;

  if(!(ulButtons & GP2X_VOL_DOWN))
    g_bVolDownDown = NOTDOWN;
  else if(g_bVolDownDown == NOTDOWN)
    g_bVolDownDown = NEWDOWN;

  if(!(ulButtons & GP2X_START))
    g_bStartDown = NOTDOWN;
  else if(g_bStartDown == NOTDOWN)
    g_bStartDown = NEWDOWN;

  if(!(ulButtons & GP2X_L))
    g_bLDown = NOTDOWN;
  else if(g_bLDown == NOTDOWN)
    g_bLDown = NEWDOWN;

  if(!(ulButtons & GP2X_R))
    g_bRDown = NOTDOWN;
  else if(g_bRDown == NOTDOWN)
    g_bRDown = NEWDOWN;

  if(IsTrackingDirection())
  {
    int nX, nY;
    char cDir;

    if(!(ulButtons & GP2X_PUSH))
      g_bStickDown = NOTDOWN;
    else if(g_bStickDown == NOTDOWN)
      g_bStickDown = NEWDOWN;

    GetPlayerLocation(&nX, &nY);

    if(ulJoystick != g_ulLastDirectionJoystick)
    {
      switch(ulJoystick)
      {
        case JOYDIR_NONE:
          break;

        case JOYDIR_U:
        case JOYDIR_UUL:
        case JOYDIR_UUR:
          if(g_nDirectionDeltaY > -1)
            g_nDirectionDeltaY--;
          break;
        case JOYDIR_UL:
          if((g_nDirectionDeltaX > -1) && (g_nDirectionDeltaY > -1))
          {
            g_nDirectionDeltaX--;
            g_nDirectionDeltaY--;
          }
          break;
        case JOYDIR_LUL:
        case JOYDIR_L:
        case JOYDIR_LDL:
          if(g_nDirectionDeltaX > -1)
            g_nDirectionDeltaX--;
          break;
        case JOYDIR_DL:
          if((g_nDirectionDeltaX > -1) && (g_nDirectionDeltaY < 1))
          {
            g_nDirectionDeltaX--;
            g_nDirectionDeltaY++;
          }
          break;
        case JOYDIR_DDL:
        case JOYDIR_D:
        case JOYDIR_DDR:
          if(g_nDirectionDeltaY < 1)
            g_nDirectionDeltaY++;
          break;
        case JOYDIR_DR:
          if((g_nDirectionDeltaX < 1) && (g_nDirectionDeltaY < 1))
          {
            g_nDirectionDeltaX++;
            g_nDirectionDeltaY++;
          }
          break;
        case JOYDIR_RDR:
        case JOYDIR_R:
        case JOYDIR_RUR:
          if(g_nDirectionDeltaX < 1)
            g_nDirectionDeltaX++;
          break;
        case JOYDIR_UR:
          if((g_nDirectionDeltaX < 1) && (g_nDirectionDeltaY > -1))
          {
            g_nDirectionDeltaX++;
            g_nDirectionDeltaY--;
          }
          break;
      }
      if((g_nDirectionDeltaX == 0) && (g_nDirectionDeltaY == 0))
        cDir = '.';
      else if((g_nDirectionDeltaX == -1) && (g_nDirectionDeltaY == 0))
        cDir = 'h';
      else if((g_nDirectionDeltaX == -1) && (g_nDirectionDeltaY == -1))
        cDir = 'y';
      else if((g_nDirectionDeltaX == 0) && (g_nDirectionDeltaY == -1))
        cDir = 'k';
      else if((g_nDirectionDeltaX == 1) && (g_nDirectionDeltaY == -1))
        cDir = 'u';
      else if((g_nDirectionDeltaX == 1) && (g_nDirectionDeltaY == 0))
        cDir = 'l';
      else if((g_nDirectionDeltaX == 1) && (g_nDirectionDeltaY == 1))
        cDir = 'n';
      else if((g_nDirectionDeltaX == 0) && (g_nDirectionDeltaY == 1))
        cDir = 'j';
      else if((g_nDirectionDeltaX == -1) && (g_nDirectionDeltaY == 1))
        cDir = 'b';

      SetDirectionCursor(nX+g_nDirectionDeltaX, nY+g_nDirectionDeltaY, cDir);
    }
    g_ulLastDirectionJoystick = ulJoystick;

    if((g_bADown == NEWDOWN) || (g_bBDown == NEWDOWN) || (g_bStickDown == NEWDOWN) ||
       (g_bSelectDown == NEWDOWN) || (g_bYDown == NEWDOWN))
    {
      StopTrackingDirection();
    }
    else if(g_bXDown == NEWDOWN)
    {
      SetDirectionCursor(nX, nY, 27);
      StopTrackingDirection();
    }
    else if(g_bVolDownDown == NEWDOWN)
    {
      SetDirectionCursor(nX, nY, '>');
      StopTrackingDirection();
    }
    else if(g_bVolUpDown == NEWDOWN)
    {
      SetDirectionCursor(nX, nY, '<');
      StopTrackingDirection();
    }

    if(g_bADown == NEWDOWN) g_bADown = OLDDOWN;
    if(g_bBDown == NEWDOWN) g_bBDown = OLDDOWN;
    if(g_bXDown == NEWDOWN) g_bXDown = OLDDOWN;
    if(g_bYDown == NEWDOWN) g_bYDown = OLDDOWN;
    if(g_bStartDown == NEWDOWN) g_bStartDown = OLDDOWN;
    if(g_bSelectDown == NEWDOWN) g_bSelectDown = OLDDOWN;
    if(g_bVolUpDown == NEWDOWN) g_bVolUpDown = OLDDOWN;
    if(g_bVolDownDown == NEWDOWN) g_bVolDownDown = OLDDOWN;
    if(g_bStickDown == NEWDOWN) g_bStickDown = OLDDOWN;
    if(g_bLDown == NEWDOWN) g_bLDown = OLDDOWN;
    if(g_bRDown == NEWDOWN) g_bRDown = OLDDOWN;

    // reset all the timers
    g_nNextJoystickRepeatTime = dzzGetJoystickTimer() + R1TIME;
    g_nNextStickClickRepeatTime = dzzGetStickClickTimer() + R1TIME;

    return;
  }

  if(!(ulButtons & GP2X_PUSH))
    g_bStickDown = NOTDOWN;
  else if(g_bStickDown == NOTDOWN)
  {
    g_bStickDown = NEWDOWN;
    dzzStartStickClickTimer();
    g_nNextStickClickRepeatTime = dzzGetStickClickTimer() + R1TIME;
  }
  else
  {
    nTime = dzzGetStickClickTimer();
    if(nTime > g_nNextStickClickRepeatTime)
    {
      g_bStickDown = NEWDOWN;
      g_nNextStickClickRepeatTime = g_nNextStickClickRepeatTime + R2TIME;
    }
  }

  if(ulJoystick != JOYDIR_L)
    g_bLeftDown = NOTDOWN;
  else if(g_bLeftDown == NOTDOWN)
  {
    g_bLeftDown = NEWDOWN;
    dzzStartJoystickTimer();
    g_ulLastJoystick = JOYDIR_L;
    g_nNextJoystickRepeatTime = dzzGetJoystickTimer() + R1TIME;
  }
  else if(g_ulLastJoystick == JOYDIR_L)
  {
    nTime = dzzGetJoystickTimer();
    if(nTime > g_nNextJoystickRepeatTime)
    {
      g_bLeftDown = NEWDOWN;
      g_nNextJoystickRepeatTime = g_nNextJoystickRepeatTime + R2TIME;
    }
  }

  if(ulJoystick != JOYDIR_R)
    g_bRightDown = NOTDOWN;
  else if(g_bRightDown == NOTDOWN)
  {
    g_bRightDown = NEWDOWN;
    dzzStartJoystickTimer();
    g_ulLastJoystick = JOYDIR_R;
    g_nNextJoystickRepeatTime = dzzGetJoystickTimer() + R1TIME;
  }
  else if(g_ulLastJoystick == JOYDIR_R)
  {
    nTime = dzzGetJoystickTimer();
    if(nTime > g_nNextJoystickRepeatTime)
    {
      g_bRightDown = NEWDOWN;
      g_nNextJoystickRepeatTime = g_nNextJoystickRepeatTime + R2TIME;
    }
  }

  if(ulJoystick != JOYDIR_U)
    g_bUpDown = NOTDOWN;
  else if(g_bUpDown == NOTDOWN)
  {
    g_bUpDown = NEWDOWN;
    dzzStartJoystickTimer();
    g_ulLastJoystick = JOYDIR_U;
    g_nNextJoystickRepeatTime = dzzGetJoystickTimer() + R1TIME;
  }
  else if(g_ulLastJoystick == JOYDIR_U)
  {
    nTime = dzzGetJoystickTimer();
    if(nTime > g_nNextJoystickRepeatTime)
    {
      g_bUpDown = NEWDOWN;
      g_nNextJoystickRepeatTime = g_nNextJoystickRepeatTime + R2TIME;
    }
  }

  if(ulJoystick != JOYDIR_D)
    g_bDownDown = NOTDOWN;
  else if(g_bDownDown == NOTDOWN)
  {
    g_bDownDown = NEWDOWN;
    dzzStartJoystickTimer();
    g_ulLastJoystick = JOYDIR_D;
    g_nNextJoystickRepeatTime = dzzGetJoystickTimer() + R1TIME;
  }
  else if(g_ulLastJoystick == JOYDIR_D)
  {
    nTime = dzzGetJoystickTimer();
    if(nTime > g_nNextJoystickRepeatTime)
    {
      g_bDownDown = NEWDOWN;
      g_nNextJoystickRepeatTime = g_nNextJoystickRepeatTime + R2TIME;
    }
  }

  if(ulJoystick != JOYDIR_UL)
    g_bULDown = NOTDOWN;
  else if(g_bULDown == NOTDOWN)
  {
    g_bULDown = NEWDOWN;
    dzzStartJoystickTimer();
    g_ulLastJoystick = JOYDIR_UL;
    g_nNextJoystickRepeatTime = dzzGetJoystickTimer() + R1TIME;
  }
  else if(g_ulLastJoystick == JOYDIR_UL)
  {
    nTime = dzzGetJoystickTimer();
    if(nTime > g_nNextJoystickRepeatTime)
    {
      g_bULDown = NEWDOWN;
      g_nNextJoystickRepeatTime = g_nNextJoystickRepeatTime + R2TIME;
    }
  }

  if(ulJoystick != JOYDIR_UR)
    g_bURDown = NOTDOWN;
  else if(g_bURDown == NOTDOWN)
  {
    g_bURDown = NEWDOWN;
    dzzStartJoystickTimer();
    g_ulLastJoystick = JOYDIR_UR;
    g_nNextJoystickRepeatTime = dzzGetJoystickTimer() + R1TIME;
  }
  else if(g_ulLastJoystick == JOYDIR_UR)
  {
    nTime = dzzGetJoystickTimer();
    if(nTime > g_nNextJoystickRepeatTime)
    {
      g_bURDown = NEWDOWN;
      g_nNextJoystickRepeatTime = g_nNextJoystickRepeatTime + R2TIME;
    }
  }

  if(ulJoystick != JOYDIR_DL)
    g_bDLDown = NOTDOWN;
  else if(g_bDLDown == NOTDOWN)
  {
    g_bDLDown = NEWDOWN;
    dzzStartJoystickTimer();
    g_ulLastJoystick = JOYDIR_DL;
    g_nNextJoystickRepeatTime = dzzGetJoystickTimer() + R1TIME;
  }
  else if(g_ulLastJoystick == JOYDIR_DL)
  {
    nTime = dzzGetJoystickTimer();
    if(nTime > g_nNextJoystickRepeatTime)
    {
      g_bDLDown = NEWDOWN;
      g_nNextJoystickRepeatTime = g_nNextJoystickRepeatTime + R2TIME;
    }
  }

  if(ulJoystick != JOYDIR_DR)
    g_bDRDown = NOTDOWN;
  else if(g_bDRDown == NOTDOWN)
  {
    g_bDRDown = NEWDOWN;
    dzzStartJoystickTimer();
    g_ulLastJoystick = JOYDIR_DR;
    g_nNextJoystickRepeatTime = dzzGetJoystickTimer() + R1TIME;
  }
  else if(g_ulLastJoystick == JOYDIR_DR)
  {
    nTime = dzzGetJoystickTimer();
    if(nTime > g_nNextJoystickRepeatTime)
    {
      g_bDRDown = NEWDOWN;
      g_nNextJoystickRepeatTime = g_nNextJoystickRepeatTime + R2TIME;
    }
  }

  // what to do depends on various states.  First, if we are
  // viewing a text file modally, deal with that situation
  
  if(g_bTextWindowVisible)
  {
    if(g_bADown == NEWDOWN)
    {
      g_bTextWindowVisible = 0;
      g_bADown = OLDDOWN;
    }
    if(g_bBDown == NEWDOWN)
    {
      g_bTextWindowVisible = 0;
      g_bBDown = OLDDOWN;
    }
    if(g_bXDown == NEWDOWN)
    {
      g_bTextWindowVisible = 0;
      g_bXDown = OLDDOWN;
    }
    if(g_bYDown == NEWDOWN)
    {
      g_bTextWindowVisible = 0;
      g_bYDown = OLDDOWN;
    }
    if(g_bSelectDown == NEWDOWN)
    {
      g_bTextWindowVisible = 0;
      g_bSelectDown = OLDDOWN;
    }
    if(g_bStickDown == NEWDOWN)
    {
      g_bTextWindowVisible = 0;
      g_bStickDown = OLDDOWN;
    }
    if(g_bStartDown == NEWDOWN)
    {
      g_bTextWindowVisible = 0;
      g_bStartDown = OLDDOWN;
    }
    if(g_bDownDown == NEWDOWN)
    {
      if(g_ulButtons & GP2X_L)
        PageTextWindow(g_nTextWindowID, 1);
      else
        ScrollTextWindow(g_nTextWindowID, 1);
      g_bDownDown = OLDDOWN;
    }
    if(g_bUpDown == NEWDOWN)
    {
      if(g_ulButtons & GP2X_L)
        PageTextWindow(g_nTextWindowID, 0);
      else
        ScrollTextWindow(g_nTextWindowID, 0);
      g_bUpDown = OLDDOWN;
    }
    return;
  }

  if(g_bMenuVisible)
  {
    HandleMenuUpdate();
    return;
  }

  // next, handle the case where we are in a YN dialog
  
  if(dzzIsYNPopped())
  {
    if(g_bVolUpDown == NEWDOWN)
    {
      ScrollDownTopTextLines();
      g_bVolUpDown = OLDDOWN;
    }
    if(g_bVolDownDown == NEWDOWN)
    {
      ScrollUpTopTextLines();
      g_bVolDownDown = OLDDOWN;
    }
    if(g_bADown == NEWDOWN)
    {
      dzzUnpopYN();
      dzzSetYNResult('y');
      g_bADown = OLDDOWN;
    }
    else if(g_bXDown == NEWDOWN)
    {
      dzzUnpopYN();
      dzzSetYNResult('n');
      g_bXDown = OLDDOWN;
    }
    return;
  }
  
  if(dzzIsRLPopped())
  {
    if(g_bVolUpDown == NEWDOWN)
    {
      ScrollDownTopTextLines();
      g_bVolUpDown = OLDDOWN;
    }
    if(g_bVolDownDown == NEWDOWN)
    {
      ScrollUpTopTextLines();
      g_bVolDownDown = OLDDOWN;
    }
    if(g_bADown == NEWDOWN)
    {
      dzzUnpopRL();
      dzzSetRLResult('l');
      g_bADown = OLDDOWN;
    }
    else if(g_bBDown == NEWDOWN)
    {
      dzzUnpopRL();
      dzzSetRLResult('r');
      g_bBDown = OLDDOWN;
    }
    return;
  }
  
  if(dzzIsYNQPopped())
  {
    if(g_bVolUpDown == NEWDOWN)
    {
      ScrollDownTopTextLines();
      g_bVolUpDown = OLDDOWN;
    }
    if(g_bVolDownDown == NEWDOWN)
    {
      ScrollUpTopTextLines();
      g_bVolDownDown = OLDDOWN;
    }
    if(g_bADown == NEWDOWN)
    {
      dzzUnpopYNQ();
      dzzSetYNQResult('y');
      g_bADown = OLDDOWN;
    }
    else if(g_bXDown == NEWDOWN)
    {
      dzzUnpopYNQ();
      dzzSetYNQResult('n');
      g_bXDown = OLDDOWN;
    }
    else if(g_bYDown == NEWDOWN)
    {
      dzzUnpopYNQ();
      dzzSetYNQResult('q');
      g_bYDown = OLDDOWN;
    }
    return;
  }
  
  if(dzzIsOptionPopped())
  {
    if(g_bADown == NEWDOWN)
    {
      dzzOptionA();
      g_bADown = OLDDOWN;
    }
    else if(g_bBDown == NEWDOWN)
    {
      dzzOptionB();
      g_bBDown = OLDDOWN;
    }
    else if(g_bSelectDown == NEWDOWN)
    {
      dzzOptionSelect();
      g_bSelectDown = OLDDOWN;
    }
    else if(g_bStickDown == NEWDOWN)
    {
      dzzOptionSelect();
      g_bStickDown = OLDDOWN;
    }
    return;
  }

  // next, handle the case where we are in a MC dialog
  
  if(dzzIsMCPopped())
  {
    if(g_bADown == NEWDOWN)
    {
      dzzMCA();
      g_bADown = OLDDOWN;
    }
    else if(g_bBDown == NEWDOWN)
    {
      dzzMCA();
      g_bBDown = OLDDOWN;
    }
    else if(g_bStartDown == NEWDOWN)
    {
      dzzMCA();
      g_bStartDown = OLDDOWN;
    }
    else if(g_bStickDown == NEWDOWN)
    {
      dzzMCA();
      g_bStickDown = OLDDOWN;
    }
    else if(g_bYDown == NEWDOWN)
    {
      dzzMCY();
      g_bYDown = OLDDOWN;
    }
    else if(g_bUpDown == NEWDOWN)
    {
      dzzMCUp();
      g_bUpDown = OLDDOWN;
    }
    else if(g_bDownDown == NEWDOWN)
    {
      dzzMCDown();
      g_bDownDown = OLDDOWN;
    }
    return;
  }

  // next, handle the case where we are entering text
  
  if(dzzIsTextEntryPopped())
  {
    if(g_bLeftDown == NEWDOWN)
    {
      dzzInputStringL();
      g_bLeftDown = OLDDOWN;
    }
    else if(g_bRightDown == NEWDOWN)
    {
      dzzInputStringR();
      g_bRightDown = OLDDOWN;
    }
    else if(g_bUpDown == NEWDOWN)
    {
      dzzInputStringU();
      g_bUpDown = OLDDOWN;
    }
    else if(g_bDownDown == NEWDOWN)
    {
      dzzInputStringD();
      g_bDownDown = OLDDOWN;
    }
    else if (g_bULDown == NEWDOWN)
    {
      dzzInputStringU();
      dzzInputStringL();
      g_bULDown = OLDDOWN;
    }
    else if (g_bURDown == NEWDOWN)
    {
      dzzInputStringU();
      dzzInputStringR();
      g_bURDown = OLDDOWN;
    }
    else if (g_bDLDown == NEWDOWN)
    {
      dzzInputStringD();
      dzzInputStringL();
      g_bDLDown = OLDDOWN;
    }
    else if (g_bDRDown == NEWDOWN)
    {
      dzzInputStringD();
      dzzInputStringR();
      g_bDRDown = OLDDOWN;
    }
    else if(g_bXDown == NEWDOWN)
    {
      dzzInputStringX();
      g_bXDown = OLDDOWN;
    }
    else if(g_bYDown == NEWDOWN)
    {
      dzzInputStringY();
      g_bYDown = OLDDOWN;
    }
    else if(g_bStartDown == NEWDOWN)
    {
      dzzInputStringStart();
      g_bStartDown = OLDDOWN;
    }
    else if(g_bStickDown == NEWDOWN)
    {
      dzzInputStringB(ulButtons & GP2X_L);
      g_bStickDown = OLDDOWN;
    }
    else if(g_bBDown == NEWDOWN)
    {
      dzzInputStringB(ulButtons & GP2X_L);
      g_bBDown = OLDDOWN;
    }
    else if(g_bSelectDown == NEWDOWN)
    {
      dzzInputStringSelect();
      g_bSelectDown = OLDDOWN;
    }
    else if(g_bVolUpDown == NEWDOWN)
    {
      dzzInputStringCycle();
      g_bVolUpDown = OLDDOWN;
    }
    else if(g_bVolDownDown == NEWDOWN)
    {
      g_bVolDownDown = OLDDOWN;
    }
    return;
  }

  // next, if a menu is down, we only deal with that
  
  if(dzzIsMenuPopped())
  {
    if(g_bUpDown == NEWDOWN)
    {
      dzzMenuUp();
      g_bUpDown = OLDDOWN;
    }
    else if(g_bDownDown == NEWDOWN)
    {
      dzzMenuDown();
      g_bDownDown = OLDDOWN;
    }
    else if(g_bXDown == NEWDOWN)
    {
      dzzMenuX();
      g_bXDown = OLDDOWN;
    }
    else if(g_bRightDown == NEWDOWN)
    {
      dzzMenuRight();
      g_bRightDown = OLDDOWN;
    }
    else if(g_bLeftDown == NEWDOWN)
    {
      dzzMenuLeft();
      g_bLeftDown = OLDDOWN;
    }
    else if((g_bADown == NEWDOWN) || (g_bStickDown == NEWDOWN) ||
        (g_bBDown == NEWDOWN) || (g_bSelectDown == NEWDOWN))
    {
      dzzMenuStickOrA();
      if(g_bADown == NEWDOWN)
        g_bADown = OLDDOWN;
      else if(g_bBDown == NEWDOWN)
        g_bBDown = OLDDOWN;
      else if(g_bSelectDown == NEWDOWN)
        g_bSelectDown = OLDDOWN;
      else
        g_bStickDown = OLDDOWN;
      if(g_nMenuSelection >= IDM_TILES)
      {
        char szOldFile[200];
        strcpy(szOldFile, g_szTileFile);
        if(g_nMenuSelection == IDM_TILES)
          g_szTileFile[0] = 0;
        else
        {
          strcpy(g_szTileFile, TilesMenu.Items[g_nMenuSelection-IDM_TILES].pszText);
          strcat(g_szTileFile, ".png");
        }
        if(InitTiles32())
        {
          InitTiles8();
          SaveRepeatData();
          SetInputChar('r' - 'a' + 1);
        }
        else
        {
          strcpy(g_szTileFile, szOldFile);
        }
      }
      else if(g_nMenuSelection >= 0)
      {
        switch(g_nMenuSelection)
        {
          case IDM_INVENTORY:
            SetInputChar('i');
            break;
          case IDM_HELP:
            DoHelp();
            break;
          case IDM_SAVEQUIT:
            SetInputChar('S');
            break;
          case IDM_QUIT:
            SetExtCommand(ExtCommandIndex("quit"));
            SetInputChar('#');
            break;
          case IDM_OPTIONS:
            dzzPopOption();
            break;
          case IDM_LISTSPELLS:
            SetInputChar('+');
            break;
          case IDM_LISTOBJECTS:
            SetInputChar('\\');
            break;
          case IDM_LISTSKILLS:
            SetExtCommand(ExtCommandIndex("enhance"));
            SetInputChar('#');
            break;
          case IDM_ATTRIBUTES:
            SetInputChar('x' - 'a' + 1);
            break;
          case IDM_WIELD:
            SetInputChar('w');
            break;
          case IDM_WEARRING:
            SetInputChar('P');
            break;
          case IDM_TAKEOFFRING:
            SetInputChar('R');
            break;
          case IDM_WEARARMOR:
            SetInputChar('W');
            break;
          case IDM_REMOVEARMOR:
            SetInputChar('T');
            break;
          case IDM_NOARMOR:
            SetInputChar('A');
            break;
          case IDM_SIT:
            SetExtCommand(ExtCommandIndex("sit"));
            SetInputChar('#');
            break;
          case IDM_JUMP:
            SetExtCommand(ExtCommandIndex("jump"));
            SetInputChar('#');
            break;
          case IDM_WIPEFACE:
            SetExtCommand(ExtCommandIndex("wipe"));
            SetInputChar('#');
            break;
          case IDM_TELEPORT:
            SetInputChar('t' - 'a' + 1);
            break;
          case IDM_LOOK:
            SetInputChar(':');
            break;
          case IDM_FARLOOK:
            SetInputChar(';');
            break;
          case IDM_OPEN:
            SetInputChar('o');
            break;
          case IDM_KICK:
            SetInputChar('d' - 'a' + 1);
            break;
          case IDM_SEARCH:
            SetInputChar('s');
            break;
          case IDM_REST:
            SetInputChar('.');
            break;
          case IDM_DROP:
            SetInputChar('d');
            break;
          case IDM_EAT:
            SetInputChar('e');
            break;
          case IDM_QUAFF:
            SetInputChar('q');
            break;
          case IDM_READ:
            SetInputChar('r');
            break;
          case IDM_APPLY:
            SetInputChar('a');
            break;
          case IDM_INVOKE:
            SetExtCommand(ExtCommandIndex("invoke"));
            SetInputChar('#');
            break;
          case IDM_MONSTER:
            SetExtCommand(ExtCommandIndex("monster"));
            SetInputChar('#');
            break;
          case IDM_RUB:
            SetExtCommand(ExtCommandIndex("rub"));
            SetInputChar('#');
            break;
          case IDM_FIRE:
            SetInputChar('f');
            break;
          case IDM_ZAP:
            SetInputChar('z');
            break;
          case IDM_CAST:
            SetInputChar('Z');
            break;
          case IDM_FIGHT:
            SetInputChar('F');
            break;
          case IDM_AMMUNITION:
            SetInputChar('Q');
            break;
          case IDM_TWOHANDED:
            SetExtCommand(ExtCommandIndex("twoweapon"));
            SetInputChar('#');
            break;
          case IDM_EXCHANGE:
            SetInputChar('x');
            break;
          case IDM_THROW:
            SetInputChar('t');
            break;
          case IDM_UP:
            SetInputChar('<');
            break;
          case IDM_DOWN:
            SetInputChar('>');
            break;
          case IDM_PICKUP:
            SetInputChar(',');
            break;
          case IDM_LOOT:
            SetExtCommand(ExtCommandIndex("loot"));
            SetInputChar('#');
            break;
          case IDM_FORCE:
            SetExtCommand(ExtCommandIndex("force"));
            SetInputChar('#');
            break;
          case IDM_OFFER:
            SetExtCommand(ExtCommandIndex("offer"));
            SetInputChar('#');
            break;
          case IDM_NAME:
            SetExtCommand(ExtCommandIndex("name"));
            SetInputChar('#');
            break;
          case IDM_CALL:
            AddTopTextLine("Select the creature you would like to name.");
            SetInputChar('C');
            break;
          case IDM_CHAT:
            SetExtCommand(ExtCommandIndex("chat"));
            SetInputChar('#');
            break;
          case IDM_ENGRAVE:
            SetInputChar('E');
            break;
          case IDM_MOVE:
            {
              AddTopTextLine("Move - in what direction?");
              StartTrackingDirection();
              DoMoveLoop();
            }
            break;
          case IDM_PRAY:
            SetExtCommand(ExtCommandIndex("pray"));
            SetInputChar('#');
            break;
          case IDM_DIP:
            SetExtCommand(ExtCommandIndex("dip"));
            SetInputChar('#');
            break;
          case IDM_PAY:
            SetInputChar('p');
            break;
          case IDM_CLOSE:
            SetInputChar('c');
            break;
          case IDM_RIDE:
          case IDM_STOPRIDE:
            SetExtCommand(ExtCommandIndex("ride"));
            SetInputChar('#');
            break;
          case IDM_UNTRAP:
            SetExtCommand(ExtCommandIndex("untrap"));
            SetInputChar('#');
            break;
          case IDM_TURN:
            SetExtCommand(ExtCommandIndex("turn"));
            SetInputChar('#');
            break;
          case IDM_WIZ_WISH:
            SetInputChar('w' - 'a' + 1);
            break;
          case IDM_WIZ_IDENTIFY:
            SetInputChar('i' - 'a' + 1);
            break;
          case IDM_WIZ_MAP:
            SetInputChar('f' - 'a' + 1);
            break;
          case IDM_WIZ_GENESIS:
            SetInputChar('g' - 'a' + 1);
            break;
          case IDM_WIZ_WHERE:
            SetInputChar('o' - 'a' + 1);
            break;
          case IDM_WIZ_POLYSELF:
            {
              SetExtCommand(ExtCommandIndex("polyself"));
              SetInputChar('#');
            }
            break;
          case IDM_WIZ_LEVEL_TELE:
            SetInputChar('v' - 'a' + 1);
            break;
          case IDM_WIZ_LEVEL_CHANGE:
            {
              SetExtCommand(ExtCommandIndex("levelchange"));
              SetInputChar('#');
            }
            break;
        }
        g_nMenuSelection = -1;
      }
    }
    return;
  }

  // finally, normal game mode
  
  if(g_bVolUpDown == NEWDOWN)
  {
    if(ulButtons & GP2X_L)
    {
      // scroll top text
      ScrollDownTopTextLines();
    }
    else
    {
      // zoom in
      switch(g_nCurrentMap)
      {
        case SMALL_MAP:
          g_nCurrentMap = MEDIUM_MAP;
          break;
        case MEDIUM_MAP:
          g_nCurrentMap = LARGE_MAP;
          break;
      }
    }
    g_bVolUpDown = OLDDOWN;
    return;
  }
  
  if(g_bVolDownDown == NEWDOWN)
  {
    if(ulButtons & GP2X_L)
    {
      // scroll top text
      ScrollUpTopTextLines();
    }
    else
    {
      // zoom out
      switch(g_nCurrentMap)
      {
        case LARGE_MAP:
          g_nCurrentMap = MEDIUM_MAP;
          break;
        case MEDIUM_MAP:
          g_nCurrentMap = SMALL_MAP;
          break;
      }
    }
    g_bVolDownDown = OLDDOWN;
    return;
  }

  if(g_bXDown == NEWDOWN)
  {
    if(g_bTrackingCursor)
    {
      StopTrackingCursor();
      SetInputChar('.');
      g_bXDown = OLDDOWN;
      return;
    }
    if(ulButtons & GP2X_L) // farlook
    {
      SetInputChar('/');
    }
    else
      SetInputChar(':'); // look
    g_bXDown = OLDDOWN;
    return;
  }

  if(g_bYDown == NEWDOWN)
  {
    if(g_bTrackingCursor)
    {
      StopTrackingCursor();
      SetInputChar('.');
      g_bYDown = OLDDOWN;
      return;
    }
    if(ulButtons & GP2X_L) // kick
      SetInputChar('d' - 'a' + 1);
    else
      SetInputChar('o'); // open
    g_bYDown = OLDDOWN;
    return;
  }

  if(g_bStickDown == NEWDOWN)
  {
    if(g_bTrackingCursor)
    {
      StopTrackingCursor();
      SetInputChar('.');
      g_bStickDown = OLDDOWN;
      return;
    }
    if(ulButtons & GP2X_L) // wait
      SetInputChar('.');
    else if(checkpickup())
      SetInputChar(',');  // pick up
    else
      SetInputChar('s'); // search
    g_bStickDown = OLDDOWN;
    return;
  }

  if(g_bStartDown == NEWDOWN)
  {
    if(g_bTrackingCursor)
    {
      StopTrackingCursor();
      SetInputChar('.');
      g_bStartDown = OLDDOWN;
      return;
    }
    if(!dzzIsMenuPopped())
    {
      if(wizard)
        AppMenu.nMenuItems = 9;
      else
        AppMenu.nMenuItems = 8;
      dzzPopMenu(&AppMenu);
    }
    g_bStartDown = OLDDOWN;
    return;
  }

  if(g_bSelectDown == NEWDOWN)
  {
    if(g_bTrackingCursor)
    {
      StopTrackingCursor();
      SetInputChar('.');
      g_bSelectDown = OLDDOWN;
      return;
    }
    if(!dzzIsMenuPopped())
      dzzPopMenu(&ExpandedActivitiesMenu);
    g_bSelectDown = OLDDOWN;
    return;
  }

  if(g_bRDown == NEWDOWN)
  {
    if(g_bTrackingCursor)
    {
      StopTrackingCursor();
      SetInputChar('.');
      g_bRDown = OLDDOWN;
      return;
    }
    if(ulButtons & GP2X_L)
      SetInputChar('f');
     else
     {
      SetInputChar(1);
     }
    g_bRDown = OLDDOWN;
    return;
  }

  if(g_bADown == NEWDOWN)
  {
    if(g_bTrackingCursor)
    {
      StopTrackingCursor();
      SetInputChar('.');
      g_bADown = OLDDOWN;
      return;
    }
    if(!dzzIsMenuPopped())
    {
      if(ulButtons & GP2X_L)
        SetInputChar('Z');
      else
        dzzPopMenu(&ActionMenu);
    }
    g_bADown = OLDDOWN;
    return;
  }

  if(g_bBDown == NEWDOWN)
  {
    if(g_bTrackingCursor)
    {
      StopTrackingCursor();
      SetInputChar('.');
      g_bBDown = OLDDOWN;
      return;
    }
    if(!dzzIsMenuPopped())
    {
      if(ulButtons & GP2X_L)
        SetInputChar('z');
      else
        dzzPopMenu(&UseMenu);
    }
    g_bBDown = OLDDOWN;
    return;
  }

  if(g_bLeftDown == NEWDOWN)
  {
    if((ulButtons & GP2X_L) && !g_bTrackingCursor)
      SetInputChar('h' - 'a' + 1);
    else
      SetInputChar('h');
    g_bLeftDown = OLDDOWN;
    return;
  }
  if(g_bRightDown == NEWDOWN)
  {
    if((ulButtons & GP2X_L) && !g_bTrackingCursor)
      SetInputChar('l' - 'a' + 1);
    else
      SetInputChar('l');
    g_bRightDown = OLDDOWN;
    return;
  }
  if(g_bUpDown == NEWDOWN)
  {
    if((ulButtons & GP2X_L) && !g_bTrackingCursor)
      SetInputChar('k' - 'a' + 1);
    else
      SetInputChar('k');
    g_bUpDown = OLDDOWN;
    return;
  }
  if(g_bDownDown == NEWDOWN)
  {
    if((ulButtons & GP2X_L) && !g_bTrackingCursor)
      SetInputChar('j' - 'a' + 1);
    else
      SetInputChar('j');
    g_bDownDown = OLDDOWN;
    return;
  }
  if(g_bULDown == NEWDOWN)
  {
    if((ulButtons & GP2X_L) && !g_bTrackingCursor)
      SetInputChar('y' - 'a' + 1);
    else
      SetInputChar('y');
    g_bULDown = OLDDOWN;
    return;
  }
  if(g_bURDown == NEWDOWN)
  {
    if((ulButtons & GP2X_L) && !g_bTrackingCursor)
      SetInputChar('u' - 'a' + 1);
    else
      SetInputChar('u');
    g_bURDown = OLDDOWN;
    return;
  }
  if(g_bDLDown == NEWDOWN)
  {
    if((ulButtons & GP2X_L) && !g_bTrackingCursor)
      SetInputChar('b' - 'a' + 1);
    else
      SetInputChar('b');
    g_bDLDown = OLDDOWN;
    return;
  }
  if(g_bDRDown == NEWDOWN)
  {
    if((ulButtons & GP2X_L) && !g_bTrackingCursor)
      SetInputChar('n' - 'a' + 1);
    else
      SetInputChar('n');
    g_bDRDown = OLDDOWN;
    return;
  }
}

void FillScreenRect(unsigned short *pus, int nX, int nY, int nWidth, 
  int nHeight, unsigned short usColor)
{
  unsigned short *pusLoc;
  int n;

  pusLoc = pus + nY * 320 + nX;
  while(nHeight > 0)
  {
    n = nWidth;
    while(n > 0)
    {
      *pusLoc = usColor;
      n--;
      pusLoc++;
    }
    pusLoc += (320 - nWidth);
    nHeight--;
  }
}

// this is not very efficient. change it if it needs to be

void DrawScreenLine(unsigned short *pus, int nX1, int nY1, int nX2, int nY2,
    unsigned short usColor)
{
  if(nX1 == nX2)
  {
    while(nY1 <= nY2)
    {
      pus[nY1 * 320 + nX1] = usColor;
      nY1++;
    }
  }
  else if(nY1 == nY2)
  {
    while(nX1 <= nX2)
    {
      pus[nY1 * 320 + nX1] = usColor;
      nX1++;
    }
  }
}

void DrawScreenRect(unsigned short *pus, int nX, int nY, int nWidth, 
  int nHeight, unsigned short usColor)
{
  DrawScreenLine(pus, nX, nY, nX+nWidth, nY, usColor);
  DrawScreenLine(pus, nX, nY+nHeight, nX+nWidth, nY+nHeight, usColor);
  DrawScreenLine(pus, nX, nY, nX, nY+nHeight, usColor);
  DrawScreenLine(pus, nX+nWidth, nY, nX+nWidth, nY+nHeight, usColor);
}


////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// TEXT WINDOW
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

// fFlags flags

typedef struct TextWindow
{
  int nTextLines;
  int nX;
  int nY;
  int nW;
  int nH;
  int nVisibleLines;
  int nTopLine;
  int bVisible;
  int bMenu;
  char szLines[1000][100];
  int nAttr[1000];
  // these are for menus
  int fFlags;
  int bShowSelectAll;
  int bShowGold;
  int bShowFingers;
  int nCurrentSelection;
  unsigned long **ppSel;
  int nGlyphs[100];
  int bSelected[100];
  ANY_P Data[100];
  int bBold[100];
  int nColumns;
  int nColumnWidths[10];
  int nCounts[100];
} TextWindow;

#define MAX_TEXT_WINDOWS  30

TextWindow *g_pTextWindows[MAX_TEXT_WINDOWS] = {
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
  NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
};

int CountColumns(TextWindow *pWin)
{
  int n;
  int nColumns = 1;
  int nC;
  char *psz;

  for(n = 0; n < pWin->nTextLines; n++)
  {
    nC = 1;
    psz = strchr(pWin->szLines[n], '\t');
    while(psz)
    {
      nC++;
      psz++;
      psz = strchr(psz, '\t');
    }
    if(nC > nColumns)
      nColumns = nC;
  }
  return nColumns;
}

int GetColumnWidth(TextWindow *pWin, int nCol)
{
  int nMaxWidth = 0;
  int n, nW;
  int m;
  char *psz, *psz2;

  for(n = 0; n < pWin->nTextLines; n++)
  {
    psz = pWin->szLines[n];
    nW = 0;
    for(m = 0; m < nCol; m++)
    {
      psz = strchr(psz, '\t');
      if(!psz)
        break;
      psz++;
    }
    if(psz)
    {
      psz2 = strchr(psz, '\t');
      if(!psz2)
      {
        nW = dzzStringWidth(psz);
      }
      else
      {
        *psz2 = 0;
        nW = dzzStringWidth(psz);
        *psz2 = '\t';
      }
      if(nW > nMaxWidth)
        nMaxWidth = nW;
    }
  }
  return nMaxWidth;
}

int InitializeColumns(TextWindow *pWin)
{
  int nW;
  int n;

  pWin->nColumns = CountColumns(pWin);
  nW = 16 * (pWin->nColumns - 1);
  for(n = 0; n < pWin->nColumns; n++)
  {
    pWin->nColumnWidths[n] = GetColumnWidth(pWin, n);
    nW += pWin->nColumnWidths[n];
  }
  return nW;
}

void DrawTextMenuLine(unsigned short *pus, TextWindow *pWin, int nLine, int nLeft, int nTop, int bBold)
{
  char *psz, *psz2;
  int n;

  psz = pWin->szLines[nLine];
  for(n = 0; n < pWin->nColumns; n++)
  {
    psz2 = strchr(psz, '\t');
    if(!psz2)
    {
      dzzDrawString(pus, 320, nLeft, nTop, psz, XRGB(0,0,0));
      if(bBold) dzzDrawString(pus, 320, nLeft+1, nTop, psz, XRGB(0,0,0));
      return;
    }
    *psz2 = 0;
    dzzDrawString(pus, 320, nLeft, nTop, psz, XRGB(0,0,0));
    if(bBold) dzzDrawString(pus, 320, nLeft+1, nTop, psz, XRGB(0,0,0));
    *psz2 = '\t';
    nLeft += (pWin->nColumnWidths[n] + 16);
    psz = psz2;
    psz++;
  }
}


void DrawTextWindow(unsigned short *pus, TextWindow *pWin)
{
  int n, nTop;
  int bScrollbar = 0;

  // draw the outline
  DrawScreenLine(pus, pWin->nX-1, pWin->nY-1, pWin->nX-1, pWin->nY+pWin->nH, XRGB(0,0,20));
  DrawScreenLine(pus, pWin->nX+pWin->nW, pWin->nY-1, pWin->nX+pWin->nW, pWin->nY+pWin->nH, XRGB(0,0,20));
  DrawScreenLine(pus, pWin->nX-1, pWin->nY-1, pWin->nX+pWin->nW, pWin->nY-1, XRGB(0,0,20));
  DrawScreenLine(pus, pWin->nX-1, pWin->nY+pWin->nH, pWin->nX+pWin->nW, pWin->nY+pWin->nH, XRGB(0,0,20));
  // clear the background
  FillScreenRect(pus, pWin->nX, pWin->nY, pWin->nW, pWin->nH, XRGB(31,63,31));
  // draw the scrollbar if needed
  if(pWin->nVisibleLines < pWin->nTextLines)
  {
    float fFrac = ((float) pWin->nVisibleLines) / ((float) pWin->nTextLines);
    float fHeight = fFrac * ((float) (pWin->nH - 4));
    float fTop = ((float) pWin->nTopLine) / ((float) pWin->nTextLines);
    fTop = fTop * ((float) (pWin->nH - 4));
    FillScreenRect(pus, pWin->nX + pWin->nW - 8, pWin->nY + ((int) (fTop + 2.5f)),
        6, ((int) (fHeight + 0.5f)), XRGB(0,0,0));
    bScrollbar = 1;
  }
  if(pWin->bMenu)
  {
    int nTextLeft = 22;
    if(pWin->fFlags == PICK_ANY)
      nTextLeft += 14;
    nTop = pWin->nY + 5;
    for(n = pWin->nTopLine; n < pWin->nTopLine + pWin->nVisibleLines; n++)
    {
      if(n >= pWin->nTextLines)
        break;
      if(n == pWin->nCurrentSelection)
      {
        FillScreenRect(pus, pWin->nX+2, nTop-3, pWin->nW-4 - bScrollbar * 10, 16, XRGB(16,63,16));
      }
      DrawTextMenuLine(pus, pWin, n, pWin->nX+nTextLeft, nTop, pWin->bBold[n]);
      if(pWin->nCounts[n] != -1)
      {
        if((n == pWin->nCurrentSelection) || (pWin->fFlags == PICK_ANY))
        {
          char sz[10];
          int nLeft;
          sprintf(sz, "[%d]", pWin->nCounts[n]);
          nLeft = pWin->nX + pWin->nW - 4 - bScrollbar * 10;
          nLeft -= dzzStringWidth(sz);
          dzzDrawString(pus, 320, nLeft, nTop, sz, XRGB(0,0,0));
        }
      }
      if((pWin->nGlyphs[n] > 0) && (pWin->nGlyphs[n] != 5570) && !pWin->bBold[n])
      {
        int nTile, nTileX, nTileY, x, y;
        unsigned short us;
        int nLoff;
        int nToff;

        nLoff = (16 - g_nMediumTileWidth) / 2;
        nToff = (16 - g_nMediumTileHeight) / 2;

        nTile = glyph2tile[pWin->nGlyphs[n]];
        nTileX = nTile % 40;
        nTileY = nTile / 40;
        for(y = 0; y < g_nMediumTileHeight; y++)
        {
          for(x = 0; x < g_nMediumTileWidth; x++)
          {
            us = g_usTiles16[(nTileY*g_nMediumTileHeight+y)*(g_nMediumTileWidth*40)+nTileX*g_nMediumTileWidth+x];
            if(g_szTileFile[0])
            {
              if(!g_bTransparent || (us != g_usTransparentColor))
                pus[(nTop-4+y+nToff)*320+pWin->nX+nTextLeft-18+x+nLoff] = us;
            }
            else
            {
              if(us != 0x436d)
                pus[(nTop-4+y)*320+pWin->nX+nTextLeft-18+x] = us;
            }
          }
        }
        if(pWin->fFlags == PICK_ANY)
        {
          DrawScreenLine(pus, pWin->nX+nTextLeft-32, nTop, pWin->nX+nTextLeft-23, nTop, XRGB(0,0,0));
          DrawScreenLine(pus, pWin->nX+nTextLeft-32, nTop, pWin->nX+nTextLeft-32, nTop+9, XRGB(0,0,0));
          DrawScreenLine(pus, pWin->nX+nTextLeft-32, nTop+9, pWin->nX+nTextLeft-23, nTop+9, XRGB(0,0,0));
          DrawScreenLine(pus, pWin->nX+nTextLeft-23, nTop, pWin->nX+nTextLeft-23, nTop+9, XRGB(0,0,0));
          if(pWin->bSelected[n])
          {
            FillScreenRect(pus, pWin->nX + nTextLeft-30, nTop+2, 6, 6, XRGB(0,0,0));
          }
        }
      }
      nTop += 16;
    }
  }
  else
  {
    // draw the text itself
    nTop = pWin->nY + 2;
    for(n = pWin->nTopLine; n < pWin->nTopLine + pWin->nVisibleLines; n++)
    {
      if(n >= pWin->nTextLines)
        break;
      dzzDrawString(pus, 320, pWin->nX+2, nTop, pWin->szLines[n], XRGB(0,0,0));
      if(pWin->nAttr[n] == ATR_BOLD)
      {
        dzzDrawString(pus, 320, pWin->nX+3, nTop, pWin->szLines[n], XRGB(0,0,0));
      }
      nTop += 10;
    }
  }
}

void HandleMenuUpdate()
{
  TextWindow *pWin = g_pTextWindows[g_nMenuID];
  if(pWin)
  {
    // cases:  
    // A, B, X, Y, UP, DOWN, STICK, SELECT, START
    if((g_bADown == NEWDOWN) || (g_bBDown == NEWDOWN))
    {
      if(pWin->fFlags == PICK_NONE)
        g_bMenuVisible = 0;
      else if(pWin->fFlags == PICK_ONE)
      {
        g_bMenuVisible = 0;
      }
      else // PICK_ANY
      {
        // if the currently highlighted item is not already selected,
        // select it - but only if nothing else is selected already.
        if(pWin->nCurrentSelection >= 0)
        {
          int n;
          int bSomethingSelected = 0;
          for(n = 0; n < pWin->nTextLines; n++)
          {
            if(pWin->bSelected[n])
            {
              bSomethingSelected = 1;
              break;
            }
          }
          if(!bSomethingSelected)
            pWin->bSelected[pWin->nCurrentSelection] = 1;
        }
        g_bMenuVisible = 0;
      }
      if(g_bADown == NEWDOWN)
        g_bADown = OLDDOWN;
      if(g_bBDown == NEWDOWN)
        g_bBDown = OLDDOWN;
    }
    if(g_bXDown == NEWDOWN)
    {
      int n;
      for(n = 0; n < pWin->nTextLines; n++)
        pWin->bSelected[n] = 0;
      g_bXDown = OLDDOWN;
      g_bMenuAborted = 1;
      g_bMenuVisible = 0;
    }
    if(g_bSelectDown == NEWDOWN)
    {
      if(pWin->fFlags == PICK_ANY)
      {
        if(!pWin->bSelected[pWin->nCurrentSelection])
          pWin->bSelected[pWin->nCurrentSelection] = 1;
        else
          pWin->bSelected[pWin->nCurrentSelection] = 0;
      }
      g_bSelectDown = OLDDOWN;
    }
    if(g_bStickDown == NEWDOWN)
    {
      if(pWin->fFlags == PICK_ANY)
      {
        if(!pWin->bSelected[pWin->nCurrentSelection])
          pWin->bSelected[pWin->nCurrentSelection] = 1;
        else
          pWin->bSelected[pWin->nCurrentSelection] = 0;
      }
      else
      {
        g_bMenuVisible = 0;
      }
      g_bStickDown = OLDDOWN;
    }
    if(g_bStartDown == NEWDOWN)
    {
      g_bStartDown = OLDDOWN;
    }
    if(g_bYDown == NEWDOWN)
    {
      g_bYDown = OLDDOWN;
    }
    if(g_bDownDown == NEWDOWN)
    {
      if(g_ulButtons & GP2X_L)
        PageMenuWindow(g_nMenuID, 1);
      else
        ScrollMenuWindow(g_nMenuID, 1);
      g_bDownDown = OLDDOWN;
    }
    if(g_bUpDown == NEWDOWN)
    {
      if(g_ulButtons & GP2X_L)
        PageMenuWindow(g_nMenuID, 0);
      else
        ScrollMenuWindow(g_nMenuID, 0);
      g_bUpDown = OLDDOWN;
    }
    if(g_bVolUpDown == NEWDOWN)
    {
      MenuQuantity(g_nMenuID, 1);
      g_bVolUpDown = OLDDOWN;
    }
    if(g_bVolDownDown == NEWDOWN)
    {
      MenuQuantity(g_nMenuID, -1);
      g_bVolDownDown = OLDDOWN;
    }
  }
}

void InitTextWindow(TextWindow *pWin)
{
  pWin->nTextLines = 0;
  pWin->nTopLine = 0;
  pWin->bVisible = 0;
  pWin->bMenu = 0;
}

void AppendTextToTextWindow(int nID, char *pszText, int attr)
{
  TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin) return;
  if(pWin->nTextLines >= 1000)
    return;
  strcpy(pWin->szLines[pWin->nTextLines], pszText);
  pWin->nAttr[pWin->nTextLines] = attr;
  pWin->nTextLines++;
}

void PositionTextWindow(int nID)
{
  int n;
  int nMaxWidth = 0;
  TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin) return;

  nMaxWidth = InitializeColumns(pWin);
  
  nMaxWidth += 4; // border
  if(pWin->bMenu)
  {
    nMaxWidth += 20; // for the icon
    if(pWin->fFlags == PICK_ANY)
      nMaxWidth += 14; // for the checkbox
    if(pWin->nTextLines > 11)
    {
      nMaxWidth += 10; // scrollbar
      pWin->nVisibleLines = 11;
    }
    else
      pWin->nVisibleLines = pWin->nTextLines;
    
    nMaxWidth += 20; // for the selected countselected count
  }
  else
  {
    if(pWin->nTextLines > 18)
    {
      nMaxWidth += 10; // scrollbar
      pWin->nVisibleLines = 18;
    }
    else
      pWin->nVisibleLines = pWin->nTextLines;
  }
  if(nMaxWidth > 310)
    nMaxWidth = 310;
  pWin->nW = nMaxWidth;
  pWin->nX = (320 - pWin->nW) / 2;
  if(pWin->bMenu)
    pWin->nH = 16 * pWin->nVisibleLines + 4;
  else
    pWin->nH = 10 * pWin->nVisibleLines + 4;
  pWin->nY = 31 + (189 - pWin->nH) / 2;
}

void DisplayTextWindow(int nID)
{
  TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin) return;
  if(pWin->bVisible)
    return;
  PositionTextWindow(nID);
  pWin->bVisible = 1;
  g_nTextWindowID = nID;
}

void HideTextWindow(int nID)
{
  TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin) return;
  pWin->bVisible = 0;
}

void ScrollTextWindow(int nID, int bDown)
{
  TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin) return;
  if(bDown)
  {
    if(pWin->nTopLine + pWin->nVisibleLines >= pWin->nTextLines)
      return; // cannot scroll further
    pWin->nTopLine++;
  }
  else
  {
    if(pWin->nTopLine > 0)
      pWin->nTopLine--;
  }
}

void PageTextWindow(int nID, int bDown)
{
  TextWindow *pWin = g_pTextWindows[nID];
  int n;
  if(!pWin) return;
  for(n = 0; n < pWin->nVisibleLines - 1; n++)
    ScrollTextWindow(nID, bDown);
}

void ScrollMenuWindow(int nID, int bDown)
{
   TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin) return;
  if(pWin->fFlags == PICK_NONE)
  {
    if(bDown)
    {
      if(pWin->nTopLine + pWin->nVisibleLines >= pWin->nTextLines)
        return; // cannot scroll further
      pWin->nTopLine++;
    }
    else
    {
      if(pWin->nTopLine > 0)
        pWin->nTopLine--;
    }
    return;
  }
  if(bDown)
  {
    while(pWin->nCurrentSelection < pWin->nTextLines - 1)
    {
      pWin->nCurrentSelection++;
      if((pWin->nGlyphs[pWin->nCurrentSelection] > 0) && 
          !pWin->bBold[pWin->nCurrentSelection])
        break;
    }
    // make sure that the line is visible
    if(pWin->nTopLine + pWin->nVisibleLines <= pWin->nCurrentSelection)
      pWin->nTopLine = pWin->nCurrentSelection - pWin->nVisibleLines + 1;
    if(pWin->nTopLine < 0)
      pWin->nTopLine = 0;
  }
  else
  {
    int nOldTopLine;
    int nOldCurrentSelection;
    nOldTopLine = pWin->nTopLine;
    nOldCurrentSelection = pWin->nCurrentSelection;
    while(pWin->nCurrentSelection >= 0)
    {
      pWin->nCurrentSelection--;
      if((pWin->nGlyphs[pWin->nCurrentSelection] > 0) && 
          !pWin->bBold[pWin->nCurrentSelection])
        break;
    }
//fix bug menu
    while(pWin->nCurrentSelection < 0)
    {
pWin->nCurrentSelection++;
      if((pWin->nGlyphs[pWin->nCurrentSelection] > 0) && 
          !pWin->bBold[pWin->nCurrentSelection])

      
//
	break;
    }
    // make sure that the line is visible
    if(pWin->nCurrentSelection < pWin->nTopLine)
      pWin->nTopLine = pWin->nCurrentSelection;
    if((nOldTopLine > 0) && (pWin->nTopLine == nOldTopLine) &&
        (pWin->nCurrentSelection == nOldCurrentSelection))
      pWin->nTopLine--;
  }
}

void PageMenuWindow(int nID, int bDown)
{
  TextWindow *pWin = g_pTextWindows[nID];
  int n, nTarget;
  if(!pWin) return;
  if(bDown)
    nTarget = pWin->nTopLine + pWin->nVisibleLines - 1;
  else
    nTarget = pWin->nTopLine - pWin->nVisibleLines + 1;
  for(n = 0; n < pWin->nVisibleLines - 1; n++)
  {
    if(bDown && (pWin->nTopLine >= nTarget))
      break;
    if(!bDown && (pWin->nTopLine <= nTarget))
      break;
    ScrollMenuWindow(nID, bDown);
  }
}

void MenuQuantity(int nID, int nIncrement)
{
  int n;
  TextWindow *pWin = g_pTextWindows[nID];

  if(!pWin) return;
  if(pWin->fFlags == PICK_NONE)
    return;
  if(!strcmp(pWin->szLines[pWin->nCurrentSelection], "Show All"))
    return;
  if(!strcmp(pWin->szLines[pWin->nCurrentSelection], "Gold"))
    return;
  if(!strcmp(pWin->szLines[pWin->nCurrentSelection], "Fingers"))
    return;
  n = pWin->nCounts[pWin->nCurrentSelection];
  if(n < 1)
    n = 1;
  else
  {
    n += nIncrement;
    if(n < 1)
      n = -1;
  }
  pWin->nCounts[pWin->nCurrentSelection] = n;
}

int NewTextWindow()
{
  int n;
  TextWindow *pWin;
  pWin = (TextWindow *) malloc(sizeof(TextWindow));
  InitTextWindow(pWin);
  for(n = 10; n < MAX_TEXT_WINDOWS; n++)
  {
    if(g_pTextWindows[n] == NULL)
    {
      g_pTextWindows[n] = pWin;
      return n;
    }
  }
  free(pWin);
  return -1;
}

void FreeTextWindow(int nID)
{
  TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin) return;
  free(pWin);
  g_pTextWindows[nID] = NULL;
}

void WaitForTextWindowKey()
{
  g_bTextWindowVisible = 1;
  while(g_bTextWindowVisible)
    dzzMicroSleep(10000);
}

int WaitForMenu(int nID)
{
  TextWindow *pWin;
  int n, m, nSel;
  menu_item **pp;

  g_bMenuVisible = 1;
  g_nMenuID = nID;
  g_bMenuAborted = 0;
  while(g_bMenuVisible)
    dzzMicroSleep(10000);
  pWin = g_pTextWindows[nID];
  if(!pWin) 
    return -1;
  if(pWin->fFlags == PICK_NONE)
    return -1;
  if(g_bMenuAborted)
    return -1;
  pp = (menu_item **) pWin->ppSel;
  if(pWin->fFlags == PICK_ONE)
  {
    if(pWin->bShowSelectAll && (pWin->nCurrentSelection == (pWin->nTextLines - 1)))
    {
      *pp = 0;
      return 0;
    }
    if(pWin->bShowGold)
    {
      if(pWin->bShowSelectAll && (pWin->nCurrentSelection == (pWin->nTextLines - 2)))
      {
        *pp = 0;
        return 100;
      }
      if(!pWin->bShowSelectAll && (pWin->nCurrentSelection == (pWin->nTextLines - 1)))
      {
        *pp = 0;
        return 100;
      }
    }
    if(pWin->bShowFingers)
    {
      if(!strcmp(pWin->szLines[pWin->nCurrentSelection], "Fingers"))
      {
        *pp = 0;
        return 101;
      }
    }
    *pp = (MENU_ITEM_P *) malloc(sizeof(MENU_ITEM_P));

    if(!pp || (pWin->nCurrentSelection < 0))
      return -1;
    (*pp)[0].item = pWin->Data[pWin->nCurrentSelection];
    (*pp)[0].count = pWin->nCounts[pWin->nCurrentSelection];
    return 1;
  }
  nSel = 0;
  for(n = 0; n < pWin->nTextLines; n++)
  {
    if(pWin->bSelected[n])
      nSel++;
  }
  if(nSel == 0)
    return 0;
  *pp = (MENU_ITEM_P *) malloc(nSel * sizeof(MENU_ITEM_P));

  m = 0;
  for(n = 0; n < pWin->nTextLines; n++)
  {
    if(pWin->bSelected[n])
    {
      (*pp)[m].item = pWin->Data[n];
      (*pp)[m].count = pWin->nCounts[n];
      m++;
    }
  }
  return m;
}

void StartMenu(int nID)
{
  TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin) return;
  pWin->fFlags = PICK_NONE;
  pWin->bMenu = 1;
  pWin->nTextLines = 0;
  pWin->nTopLine = 0;
}

void AddMenuItem(int nID, int nGlyph, const ANY_P *pData,
    const char *pStr, int bBold, int bPreselect)
{
  TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin) return;
  if(pWin->nTextLines >= 100)
    return;
  strcpy(pWin->szLines[pWin->nTextLines], pStr);
  pWin->bBold[pWin->nTextLines] = bBold;
  pWin->nGlyphs[pWin->nTextLines] = nGlyph;
  pWin->bSelected[pWin->nTextLines] = 0;
  pWin->Data[pWin->nTextLines] = *pData;
  pWin->nTextLines++;
}

// returns number of selected items

int SelectMenu(int nID, int nFlags, int bShowSelectAll, int bShowGold, int bShowFingers, unsigned long **ppSel)
{
  int n;

  TextWindow *pWin = g_pTextWindows[nID];
  if(!pWin)
    return -1;
  pWin->fFlags = nFlags;
  pWin->bShowSelectAll = 0;
  pWin->bShowGold = 0;
  pWin->bShowFingers = 0;
  pWin->nCurrentSelection = -1;
  if(nFlags != PICK_NONE)
  {
    pWin->bShowSelectAll = bShowSelectAll;
    pWin->bShowGold = bShowGold;
    pWin->bShowFingers = bShowFingers;
    for(n = 0; n < pWin->nTextLines+2; n++)
      pWin->nCounts[n] = -1;

    if(bShowGold && (nFlags == PICK_ONE))
    {
      strcpy(pWin->szLines[pWin->nTextLines], "Gold");
      pWin->nGlyphs[pWin->nTextLines] = 2295;
      pWin->bBold[pWin->nTextLines] = 0;
      pWin->bSelected[pWin->nTextLines] = 0;
      pWin->nTextLines++;
    }
    if(bShowFingers && (nFlags == PICK_ONE))
    {
      strcpy(pWin->szLines[pWin->nTextLines], "Fingers");
      pWin->nGlyphs[pWin->nTextLines] = 2044;
      pWin->bBold[pWin->nTextLines] = 0;
      pWin->bSelected[pWin->nTextLines] = 0;
      pWin->nTextLines++;
    }
    if(bShowSelectAll && (nFlags == PICK_ONE))
    {
      strcpy(pWin->szLines[pWin->nTextLines], "Show All");
      pWin->nGlyphs[pWin->nTextLines] = 0;
      pWin->bBold[pWin->nTextLines] = 0;
      pWin->bSelected[pWin->nTextLines] = 0;
      pWin->nTextLines++;
    }
    for(n = 0; n < pWin->nTextLines; n++)
    {
      if((pWin->nGlyphs[n] > 0) && !pWin->bBold[n])
      {
        pWin->nCurrentSelection = n;
        break;
      }
    }
  }
  pWin->ppSel = ppSel;
  if(ppSel)
    *ppSel = (unsigned long *) 0;
  DisplayTextWindow(nID);
  return -1;
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// STATUS AREA
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

static int g_nStatusCursorX = 0;
static int g_nStatusCursorY = 0;
static char g_szStatusText[2][100];

void dzzSetStatusLines(char *sz1, char *sz2)
{
  strcpy(g_szStatusText[0], sz1);
  strcpy(g_szStatusText[1], sz2);
}

void InitStatusWindow()
{
  g_nStatusCursorX = 0;
  g_nStatusCursorY = 0;
  g_szStatusText[0][0] = 0;
  g_szStatusText[1][0] = 0;
}

void SetStatusCursor(int nX, int nY)
{
  if(nX < 0) nX = 0;
  if(nX > 80) nX = 80;
  if(nY < 0) nY = 0;
  if(nY > 1) nY = 1;
  g_nStatusCursorX = nX;
  g_nStatusCursorY = nY;
}

void StatusPutstr(char *pStr, int attr)
{
  int n;
  // may need to set some spaces
  for(n = strlen(g_szStatusText[g_nStatusCursorY]); n < g_nStatusCursorX; n++)
    g_szStatusText[g_nStatusCursorY][n] = ' ';
  strcpy(&g_szStatusText[g_nStatusCursorY][g_nStatusCursorX], pStr);
}

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// TOP TEXT AREA
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

#define TOPTEXT_LINES 40
static char g_szTopText[TOPTEXT_LINES][120];
int g_nBottomTopTextLine = 0;
int g_nTopTextLines = 0;

void InitTopTextWindow()
{
  int n;
  for(n = 0; n < TOPTEXT_LINES; n++)
  {
    g_szTopText[n][0] = 0;
  }
  g_nBottomTopTextLine = 0;
  g_nTopTextLines = 0;
}

void AddTopTextLineHelper(char *pStr)
{
  int n;
  for(n = TOPTEXT_LINES - 1; n > 0; n--)
    strcpy(g_szTopText[n], g_szTopText[n-1]);
  strcpy(g_szTopText[0], pStr);
  g_nBottomTopTextLine = 0;
  g_nTopTextLines++;
  if(g_nTopTextLines > TOPTEXT_LINES)
    g_nTopTextLines = TOPTEXT_LINES;
}

void AppendTopTextLine(char *pStr)
{
  strcat(g_szTopText[0], pStr);
  g_nBottomTopTextLine = 0;
}

void AddTopTextLine(char *pStr)
{
  char buf[200];
  char *pEnd;

  strcpy(buf, pStr);
  pStr = buf;
  while(dzzStringWidth(pStr) > 316)
  {
    pEnd = &pStr[strlen(pStr)-1];
    while(1)
    {
      while((*pEnd) != ' ')
        pEnd--;
      *pEnd = 0;
      if(dzzStringWidth(pStr) <= 316)
      {
        AddTopTextLineHelper(pStr);
        pStr = pEnd + 1;
        break;
      }
      *pEnd = ' ';
      pEnd--;
    }
  }
  if(dzzStringWidth(pStr) == 0)
    return;
  AddTopTextLineHelper(pStr);
}

void ScrollUpTopTextLines()
{
  if(g_nBottomTopTextLine < g_nTopTextLines - 3)
    g_nBottomTopTextLine++;
}

void ScrollDownTopTextLines()
{
  if(g_nBottomTopTextLine > 0)
    g_nBottomTopTextLine--;
}


////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// SCREEN RENDERING
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

static volatile int g_bScreenBufferBusy = 0;

// the screen has the following format:
//   three lines of text at the top.  10 pixels each, plus one more
//     at the very top for the hip look all the kids are demanding.
//     so a total of 31 pixels.
//   two lines of text at the bottom for the status areas, plus another
//     pixel.  Chop off the bottom one. 20 pixels total.
//   the remainder in the middle is for the map.  320x188.  This is
//     copied from the MapScreen

void RenderScreen(unsigned short *pus, unsigned long ulButtons)
{
  int n;

  // wait for updates to the memscreen (from the engine) to complete
  while(g_bScreenBufferBusy)
  {
    // yield
  }
  g_bScreenBufferBusy = 1;
  // time to draw!

  FillScreenRect(pus, 0, 0, 320, 31, XRGB(31,63,31));
  // here, draw the text lines if any exist
  if(g_nBottomTopTextLine < TOPTEXT_LINES - 2)
    dzzDrawString(pus, 320, 2, 1, g_szTopText[g_nBottomTopTextLine+2],
        XRGB(0,0,0));
  if(g_nBottomTopTextLine < TOPTEXT_LINES - 1)
    dzzDrawString(pus, 320, 2, 11, g_szTopText[g_nBottomTopTextLine+1],
        XRGB(0,0,0));
  if(g_nBottomTopTextLine < TOPTEXT_LINES)
    dzzDrawString(pus, 320, 2, 21, g_szTopText[g_nBottomTopTextLine],
        (g_nBottomTopTextLine == 0) ? XRGB(0,0,0) : XRGB(0,0,0));

  // next, copy the map area.
  DrawMap(pus + 320 * 31, 189);
  
  if(g_szStatusText[0][0])
  {
    FillScreenRect(pus, 0, 220, 320, 20, XRGB(31,63,31));
    // here, draw the status text
    dzzDrawString(pus, 320, 2, 221, g_szStatusText[0], 0);
    dzzDrawString(pus, 320, 2, 231, g_szStatusText[1], 0);
  }
  else
  {
    FillScreenRect(pus, 0, 220, 320, 20, XRGB(0,0,0));
  }
  
  // now, if we have popups (menus, dialogs, etc), they should
  // be drawn on top of everything else
  
  if(dzzIsYNPopped())
    dzzDrawYN(pus);
  
  if(dzzIsRLPopped())
    dzzDrawRL(pus);
  
  if(dzzIsYNQPopped())
    dzzDrawYNQ(pus);
  
  if(dzzIsOptionPopped())
    dzzDrawOption(pus);
  
  if(dzzIsMCPopped())
    dzzDrawMC(pus);

  if(dzzIsTextEntryPopped())
    dzzDrawTextEntry(pus, ulButtons);

  dzzDrawMenus(pus);
  
  for(n = 0; n < MAX_TEXT_WINDOWS; n++)
  {
    if(g_pTextWindows[n] && g_pTextWindows[n]->bVisible)
    {
      DrawTextWindow(pus, g_pTextWindows[n]);
    }
  }

  g_bScreenBufferBusy = 0;
}

void StartUI()
{
  InitTilesMenu();
  InitStatusWindow();
  InitTopTextWindow();
  InitMaps();
  AddTopTextLine("NetHack, Copyright 1985-2003.");
  AddTopTextLine("Stichting Mathematisch Centrum and M. Stephenson.");
  AddTopTextLine("See license for details.");
  InitTiles32();
  InitTiles8();
  StartUIThread();
}

void ShutdownUI()
{
  ShutdownUIThread();
}

